/*********************************************************************/
/*                                                                   */
/*             Optimized BLAS libraries                              */
/*                     By Kazushige Goto <kgoto@tacc.utexas.edu>     */
/*                                                                   */
/* Copyright (c) The University of Texas, 2005. All rights reserved. */
/* UNIVERSITY EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES CONCERNING  */
/* THIS SOFTWARE AND DOCUMENTATION, INCLUDING ANY WARRANTIES OF      */
/* MERCHANTABILITY, FITNESS FOR ANY PARTICULAR PURPOSE,              */
/* NON-INFRINGEMENT AND WARRANTIES OF PERFORMANCE, AND ANY WARRANTY  */
/* THAT MIGHT OTHERWISE ARISE FROM COURSE OF DEALING OR USAGE OF     */
/* TRADE. NO WARRANTY IS EITHER EXPRESS OR IMPLIED WITH RESPECT TO   */
/* THE USE OF THE SOFTWARE OR DOCUMENTATION.                         */
/* Under no circumstances shall University be liable for incidental, */
/* special, indirect, direct or consequential damages or loss of     */
/* profits, interruption of business, or related expenses which may  */
/* arise from use of Software or Documentation, including but not    */
/* limited to those resulting from defects in Software and/or        */
/* Documentation, or loss or inaccuracy of data of any kind.         */
/*********************************************************************/

#define ASSEMBLER
#include "common.h"

#define PREFETCH_SIZE 128

#define SP	r12

#define N	r32
#define K1	r33
#define K2	r34
#define A	r36
#define LDA	r37
#define IPIV	r38
#define INCX	r39

#define I	r14
#define II	r15
#define J	r16
#define PIV	r17
#define IP	r18
#define A1	r19
#define DX1	r20
#define DY1	r21
#define A2	r22
#define DX2	r23
#define DY2	r24
#define A3	r25
#define DX3	r26
#define DY3	r27
#define A4	r28
#define DX4	r29
#define DY4	r30

#define ARLC	r31

#define XDATA1	loc0
#define XDATA2	loc1
#define XDATA3	loc2
#define XDATA4	loc3
#define XDATA5	loc4
#define XDATA6	loc5
#define XDATA7	loc6
#define XDATA8	loc7

#define YDATA1	loc8
#define YDATA2	loc9
#define YDATA3	loc10
#define YDATA4	loc11
#define YDATA5	loc12
#define YDATA6	loc13
#define YDATA7	loc14
#define YDATA8	loc15

#define A5	loc16
#define DX5	loc17
#define DY5	loc18
#define A6	loc19
#define DX6	loc20
#define DY6	loc21
#define A7	loc22
#define DX7	loc23
#define DY7	loc24
#define DX8	loc25
#define DY8	loc26

	PROLOGUE
	.prologue
	PROFCODE
	alloc	r28 = ar.pfs, 8, 32, 0, 0
	adds	r14 = 16, SP
	adds	r15 = 24, SP
	cmp.lt	p6, p7 = 0, N

	adds	A = -SIZE, A		// A--
	.save	ar.lc, ARLC
	mov	ARLC = ar.lc
	.body
	(p7) br.cond.dpnt .L999

	;;
	cmp.ge	p6, p7 = K2, K1
	(p7) br.cond.dpnt .L999
	;;
	ld8	IPIV = [r14]
	ld8	INCX = [r15]
	shladd	LDA = LDA, BASE_SHIFT, r0
	shr	J = N, 3
	;;
#ifndef MINUS
	shladd	IPIV = K1, INTSHIFT, IPIV
 	;;
	adds	IPIV = -INTSIZE, IPIV		// ipiv += k1 - 1
	shladd	INCX = INCX, INTSHIFT, r0	// scaling for INCX
#else
	mov	r2 = 1
	sxt4	INCX = INCX
	;;
	shladd	INCX = INCX, INTSHIFT, r0	// scaling for INCX
	sub	r2 = r2, K2	// 1 - K2
	;;
	setf.sig f6 = r2
	setf.sig f7 = INCX
	;;
	xmpy.l	f6 = f6, f7
	;;
	getf.sig r2 = f6
	;;	
	add	IPIV = IPIV, r2
#endif

	cmp.ge	p6, p7 = 0, J
	(p6)	br.cond.dpnt .L20
	;;
	.align 32

.L12:
	mov	PIV = IPIV
	sub	II = K2, K1		// II = K1 - K2
#ifndef MINUS
	mov	I = K1
#else
	mov	I = K2
#endif
	add	A1 = A, LDA
	;;
	shladd	A2 = LDA, 1, A
	shladd	A4 = LDA, 2, A
	;;
	add	A3 = A2, LDA
	add	A5 = A4, LDA
	shladd	A6 = LDA, 1, A4
	;;
	shladd	A7 = LDA, 2, A3
	mov	ar.lc = II
	LDINT	IP = [PIV], INCX		// ip = *ipiv
	;;
	shladd	DX1 = I,  BASE_SHIFT, A		// dx = a + i
	shladd	DY1 = IP, BASE_SHIFT, A
	shladd	DX2 = I,  BASE_SHIFT, A1	// dx = a + i
	shladd	DY2 = IP, BASE_SHIFT, A1
	shladd	DX3 = I,  BASE_SHIFT, A2	// dx = a + i
	shladd	DY3 = IP, BASE_SHIFT, A2
	shladd	DX4 = I,  BASE_SHIFT, A3	// dx = a + i
	shladd	DY4 = IP, BASE_SHIFT, A3
	shladd	DX5 = I,  BASE_SHIFT, A4	// dx = a + i
	shladd	DY5 = IP, BASE_SHIFT, A4
	shladd	DX6 = I,  BASE_SHIFT, A5	// dx = a + i
	shladd	DY6 = IP, BASE_SHIFT, A5
	shladd	DX7 = I,  BASE_SHIFT, A6	// dx = a + i
	shladd	DY7 = IP, BASE_SHIFT, A6
	shladd	DX8 = I,  BASE_SHIFT, A7	// dx = a + i
	shladd	DY8 = IP, BASE_SHIFT, A7

	cmp4.ne p8, p0 = I, IP
	;;
	.align 32

.L15:
	(p8) LD8   XDATA1 = [DX1]
	(p8) LD8   YDATA1 = [DY1]
	(p8) LD8   XDATA2 = [DX2]
	(p8) LD8   YDATA2 = [DY2]
	(p8) LD8   XDATA3 = [DX3]
	(p8) LD8   YDATA3 = [DY3]
	(p8) LD8   XDATA4 = [DX4]
	(p8) LD8   YDATA4 = [DY4]
	(p8) LD8   XDATA5 = [DX5]
	(p8) LD8   YDATA5 = [DY5]
	(p8) LD8   XDATA6 = [DX6]
	(p8) LD8   YDATA6 = [DY6]
	(p8) LD8   XDATA7 = [DX7]
	(p8) LD8   YDATA7 = [DY7]
	(p8) LD8   XDATA8 = [DX8]
	(p8) LD8   YDATA8 = [DY8]
#ifndef MINUS
	adds	I = 1, I
#else
	adds	I =-1, I
#endif
	LDINT	IP = [PIV], INCX		// ip = *ipiv
	;;
	(p8) ST8 [DX1] = YDATA1
	shladd	DX1 = I,  BASE_SHIFT, A		// dx = a + i
	(p8) ST8 [DY1] = XDATA1
	shladd	DY1 = IP, BASE_SHIFT, A
	;;
	(p8) ST8 [DX2] = YDATA2
	shladd	DX2 = I,  BASE_SHIFT, A1	// dx = a + i
	(p8) cmp.eq.unc p9, p0 = r0, r0
	(p8) ST8 [DY2] = XDATA2
	shladd	DY2 = IP, BASE_SHIFT, A1
	;;
	(p8) ST8 [DX3] = YDATA3
	shladd	DX3 = I,  BASE_SHIFT, A2	// dx = a + i
	(p8) ST8 [DY3] = XDATA3
	shladd	DY3 = IP, BASE_SHIFT, A2
	;;
	(p9) ST8 [DX4] = YDATA4
	shladd	DX4 = I,  BASE_SHIFT, A3	// dx = a + i
	cmp4.ne p8, p0 = I, IP
	(p9) ST8 [DY4] = XDATA4
	shladd	DY4 = IP, BASE_SHIFT, A3
	;;

	(p9) ST8 [DX5] = YDATA5
	shladd	DX5 = I,  BASE_SHIFT, A4	// dx = a + i
	(p9) ST8 [DY5] = XDATA5
	shladd	DY5 = IP, BASE_SHIFT, A4
	;;
	(p9) ST8 [DX6] = YDATA6
	shladd	DX6 = I,  BASE_SHIFT, A5	// dx = a + i
	(p9) ST8 [DY6] = XDATA6
	shladd	DY6 = IP, BASE_SHIFT, A5
	;;
	(p9) ST8 [DX7] = YDATA7
	shladd	DX7 = I,  BASE_SHIFT, A6	// dx = a + i
	(p9) ST8 [DY7] = XDATA7
	shladd	DY7 = IP, BASE_SHIFT, A6
	;;
	(p9) ST8 [DX8] = YDATA8
	shladd	DX8 = I,  BASE_SHIFT, A7	// dx = a + i
	(p9) ST8 [DY8] = XDATA8
	shladd	DY8 = IP, BASE_SHIFT, A7
	br.cloop.sptk.few .L15
	;;
	adds	J = -1, J
	shladd	A  = LDA, 3, A
	shladd	A1 = LDA, 3, A1
	shladd	A2 = LDA, 3, A2
	shladd	A3 = LDA, 3, A3
	;;
	shladd	A4 = LDA, 3, A4
	shladd	A5 = LDA, 3, A5
	shladd	A6 = LDA, 3, A6
	shladd	A7 = LDA, 3, A7
	;;
	cmp.lt	p6, p0 = 0, J
	(p6) br.cond.dptk .L12
	.align 32
	
.L20:
	and	J = 7, N
	;;
	cmp.eq	p6, p7 = 0, J
	(p6) br.cond.dpnt .L999
	;;
.L22:
	sub	II = K2, K1
#ifndef MINUS
	mov	I = K1
#else
	mov	I = K2
#endif
	mov	PIV = IPIV
	;;
	mov	ar.lc = II
	.align 32

.L25:
	LDINT IP = [PIV], INCX
	;;
	shladd DX1 = I,  BASE_SHIFT, A
	shladd DY1 = IP, BASE_SHIFT, A
	cmp4.eq p6, p7 = I, IP
#ifndef MINUS
	adds I = 1, I
#else
	adds I =-1, I
#endif
	;;
	(p7) LD8 XDATA1 = [DX1]
	(p7) LD8 YDATA1 = [DY1]
	;;
	(p7) ST8 [DX1] = YDATA1
	(p7) ST8 [DY1] = XDATA1
	br.cloop.sptk.few .L25

	adds J = -1, J
	add A = A, LDA
	;;
	cmp4.lt p6, p7 = 0, J
	(p6) br.cond.dptk .L22
	.align 32

.L999:
	mov	r8 = r0
	mov	ar.lc = ARLC
	br.ret.sptk.many b0
	EPILOGUE
