/*********************************************************************/
/*                                                                   */
/*             Optimized BLAS libraries                              */
/*                     By Kazushige Goto <kgoto@tacc.utexas.edu>     */
/*                                                                   */
/* Copyright (c) The University of Texas, 2005. All rights reserved. */
/* UNIVERSITY EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES CONCERNING  */
/* THIS SOFTWARE AND DOCUMENTATION, INCLUDING ANY WARRANTIES OF      */
/* MERCHANTABILITY, FITNESS FOR ANY PARTICULAR PURPOSE,              */
/* NON-INFRINGEMENT AND WARRANTIES OF PERFORMANCE, AND ANY WARRANTY  */
/* THAT MIGHT OTHERWISE ARISE FROM COURSE OF DEALING OR USAGE OF     */
/* TRADE. NO WARRANTY IS EITHER EXPRESS OR IMPLIED WITH RESPECT TO   */
/* THE USE OF THE SOFTWARE OR DOCUMENTATION.                         */
/* Under no circumstances shall University be liable for incidental, */
/* special, indirect, direct or consequential damages or loss of     */
/* profits, interruption of business, or related expenses which may  */
/* arise from use of Software or Documentation, including but not    */
/* limited to those resulting from defects in Software and/or        */
/* Documentation, or loss or inaccuracy of data of any kind.         */
/*********************************************************************/

#include <stdio.h>
#include "common.h"

#ifdef UNIT
#define TRMV	TRMV_NLU
#else
#define TRMV	TRMV_NLN
#endif

blasint CNAME(long n, FLOAT *a, long lda, FLOAT *buffer){

  FLOAT ajj;
  long j;

  for (j = n - 1; j >= 0; j--) {

    ajj =  ONE;

#ifndef UNIT
    ajj /= *(a + j + j * lda);
    *(a + j + j * lda) = ajj;
#endif

    TRMV  (n - j - 1,
	   a + (j + 1) + (j + 1) * lda, lda,
	   a + (j + 1) + j * lda,
	   1, buffer);

    SCAL_K(n - j - 1, 0, 0,
	   -ajj, 
	   a + (j + 1)  + j * lda, 1,
	   NULL, 0, NULL, 0);
  }

  return 0;
}
