/*********************************************************************/
/*                                                                   */
/*             Optimized BLAS libraries                              */
/*                     By Kazushige Goto <kgoto@tacc.utexas.edu>     */
/*                                                                   */
/* Copyright (c) The University of Texas, 2005. All rights reserved. */
/* UNIVERSITY EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES CONCERNING  */
/* THIS SOFTWARE AND DOCUMENTATION, INCLUDING ANY WARRANTIES OF      */
/* MERCHANTABILITY, FITNESS FOR ANY PARTICULAR PURPOSE,              */
/* NON-INFRINGEMENT AND WARRANTIES OF PERFORMANCE, AND ANY WARRANTY  */
/* THAT MIGHT OTHERWISE ARISE FROM COURSE OF DEALING OR USAGE OF     */
/* TRADE. NO WARRANTY IS EITHER EXPRESS OR IMPLIED WITH RESPECT TO   */
/* THE USE OF THE SOFTWARE OR DOCUMENTATION.                         */
/* Under no circumstances shall University be liable for incidental, */
/* special, indirect, direct or consequential damages or loss of     */
/* profits, interruption of business, or related expenses which may  */
/* arise from use of Software or Documentation, including but not    */
/* limited to those resulting from defects in Software and/or        */
/* Documentation, or loss or inaccuracy of data of any kind.         */
/*********************************************************************/

#define ASSEMBLER
#include "common.h"

#define PREFETCHSIZE  (32 * 8)

#define N	r32
#define X	r36
#define INCX	r37
#define Y	r38
#define INCY	r39

#define PRE1	r2
#define PRE2	r3

#define I	r14
#define J	r15
#define Y1	r16
#define Y2	r17
#define X1	r18
#define X2	r19
#define INCX16	r20
#define INCY16	r21
#define YYY	r25
#define XX	r26
#define YY	r27
#define XA	r28
#define XB	r29
#define PR	r30
#define ARLC	r31
	
#define ALPHA	f8

	PROLOGUE
	.prologue
	PROFCODE

	{ .mii
	shladd	INCX = INCX, BASE_SHIFT, r0
	.save ar.lc, ARLC
	mov	ARLC = ar.lc
	tbit.nz	p10, p0 = X, BASE_SHIFT
	}
	{ .mfb
	cmp.lt	p0, p6 = r0, N
	fcmp.eq	p7, p0 = ALPHA, f0
	(p6) br.ret.sptk.many b0
	}
	;;
	.body
	{ .mmi
	(p10) LDFD	f32 = [X], INCX
	shladd	INCY = INCY, BASE_SHIFT, r0
	mov	PR = pr
	}
	{ .mib
	(p10) adds N = -1, N
	mov  YYY = Y 
	(p7) br.ret.sptk.many b0
	}
	;;
	{ .mmi
	(p10) LDFD	f33 = [Y], INCY
	cmp.ne	p13, p0 = SIZE, INCX
	shr    XA = X, 3
	}
	{ .mmi
	shladd	INCX16 = INCX, 4, r0
	shladd	INCY16 = INCY, 4, r0
	nop.i 0
	}
	;;
	{ .mii
	mov	Y1 = Y
	tbit.nz	p11, p0 = Y, BASE_SHIFT
	shr    XB = Y, 3
	}
	;;
	{ .mmf
	and	XA = 0x1f, XA
	and	XB = 0x1f, XB
	(p10) FMA f9 = ALPHA, f32, f33
	}
	;;
	{ .mmi
	sub	XA = XB, XA
	shladd	Y2 = INCY, 1, Y
	mov	pr.rot = 0x10000
	}
	{ .mbb
	cmp.ne p14, p0 = SIZE, INCY
	(p13) br.cond.dpnt .L100
	(p14) br.cond.dpnt .L100
	}
	;;
	{ .mmi
	and	J =  15, N
	cmp.lt	p8, p0 =   -1, XA
	shr	I =  N, 4
	}
	{ .mmb
	nop.m 0
	nop.m 0
	(p11) br.cond.dpnt .L30
	}
	;;
	{ .mmi
	cmp.eq	p9, p0  =   r0, J
	cmp.eq	p7 ,p0  = 0, I
	mov	ar.ec = 3
	}
	{ .mmb
	adds	I = -1, I
	(p8) cmp.gt.unc	p6, p0 =  16, XA
	(p6) br.cond.dpnt .L20
	}
	;;
	{ .mmi
	(p10) STFD [YYY] = f9
	adds	PRE1 = PREFETCHSIZE * SIZE, X
	mov	ar.lc = I
	}
	{ .mib
	adds	PRE2 = PREFETCHSIZE * SIZE, Y
	tbit.z	p0, p12 = J, 3
	(p7) br.cond.dpnt  .L15
	}
	;;
	.align 32

.L12:
	{ .mmf
	(p19) STFD	[Y1] = f6,   1 * SIZE
	(p19) STFD	[Y2] = f7,   1 * SIZE
	(p18) FMA	f6  = ALPHA, f34, f82
	}
	{ .mmf
	(p16) lfetch.nt1	[PRE1], 16 * SIZE
	(p16) lfetch.excl.nt1	[PRE2], 16 * SIZE
	(p18) FMA	f7  = ALPHA, f40, f88
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f10,  3 * SIZE
	(p19) STFD	[Y2] = f11,  3 * SIZE
	(p18) FMA	f10 = ALPHA, f37, f85
	}
	{ .mmf
	(p16) LDFPD	f32,  f35  = [X], 2 * SIZE
	(p16) LDFPD	f80,  f83  = [Y], 2 * SIZE
	(p18) FMA	f11 = ALPHA, f43, f91
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f12,  1 * SIZE
	(p19) STFD	[Y2] = f13,  1 * SIZE
	(p18) FMA	f12 = ALPHA, f46, f94
	}
	{ .mmf
	(p16) LDFPD	f38,  f41  = [X], 2 * SIZE
	(p16) LDFPD	f86,  f89  = [Y], 2 * SIZE
	(p18) FMA	f13 = ALPHA, f52, f100
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f14,  3 * SIZE
	(p19) STFD	[Y2] = f15,  3 * SIZE
	(p18) FMA	f14 = ALPHA, f49, f97
	}
	{ .mmf
	(p16) LDFPD	f44,  f47  = [X], 2 * SIZE
	(p16) LDFPD	f92,  f95  = [Y], 2 * SIZE
	(p18) FMA	f15 = ALPHA, f55, f103
	}
	;;
	{ .mmf
	(p18) STFD	[Y1] = f6,   1 * SIZE
	(p18) STFD	[Y2] = f7,   1 * SIZE
	(p18) FMA	f6 = ALPHA, f58, f106
	}
	{ .mmf
	(p16) LDFPD	f50,  f53  = [X], 2 * SIZE
	(p16) LDFPD	f98,  f101 = [Y], 2 * SIZE
	(p18) FMA	f7 = ALPHA, f64, f112
	}
	;;
	{ .mmf
	(p18) STFD	[Y1] = f10,  3 * SIZE
	(p18) STFD	[Y2] = f11,  3 * SIZE
	(p18) FMA	f10  = ALPHA, f61, f109
	}
	{ .mmf
	(p16) LDFPD	f56,  f59  = [X], 2 * SIZE
	(p16) LDFPD	f104, f107 = [Y], 2 * SIZE
	(p18) FMA	f11 = ALPHA, f67, f115
	}
	;;
	{ .mmf
	(p18) STFD	[Y1] = f12,  1 * SIZE
	(p18) STFD	[Y2] = f13,  1 * SIZE
	(p18) FMA	f12 = ALPHA, f70, f118
	}
	{ .mmf
	(p16) LDFPD	f62,  f65  = [X], 2 * SIZE
	(p16) LDFPD	f110, f113 = [Y], 2 * SIZE
	(p18) FMA	f13 = ALPHA, f76, f124
	}
	;;
	{ .mmf
	(p18) STFD	[Y1] = f14,  3 * SIZE
	(p18) STFD	[Y2] = f15,  3 * SIZE
	(p18) FMA	f14 = ALPHA, f73, f121
	}
	{ .mmf
	(p16) LDFPD	f68,  f71  = [X], 2 * SIZE
	(p16) LDFPD	f116, f119 = [Y], 2 * SIZE
	(p18) FMA	f15 = ALPHA, f79, f127
	}
	;;
	(p16) LDFPD	f74,  f77  = [X], 2 * SIZE
	(p16) LDFPD	f122, f125 = [Y], 2 * SIZE
	br.ctop.sptk.few .L12
	;;
	{ .mmf
	(p19) STFD	[Y1] = f6,   1 * SIZE
	(p19) STFD	[Y2] = f7,   1 * SIZE
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f10,  3 * SIZE
	(p19) STFD	[Y2] = f11,  3 * SIZE
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f12,  1 * SIZE
	(p19) STFD	[Y2] = f13,  1 * SIZE
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f14,  3 * SIZE
	(p19) STFD	[Y2] = f15,  3 * SIZE
	}
	;;
	.align 32

.L15:
	{ .mmi
	(p12) LDFPD	f32,  f33  = [X], 2 * SIZE
	(p12) LDFPD	f34,  f35  = [Y], 2 * SIZE
	mov	pr = PR, -65474
	}
	;;
	{ .mmi
	(p12) LDFPD	f36,  f37  = [X], 2 * SIZE
	(p12) LDFPD	f38,  f39  = [Y], 2 * SIZE
	mov	ar.lc  = ARLC
	}
	;;
	{ .mmb
	(p12) LDFPD	f40,  f41  = [X], 2 * SIZE
	(p12) LDFPD	f42,  f43  = [Y], 2 * SIZE
	(p9) br.ret.sptk.many b0
	}
	;;
	{ .mmi
	(p12) LDFPD	f44,  f45  = [X], 2 * SIZE
	(p12) LDFPD	f46,  f47  = [Y], 2 * SIZE
	tbit.z	p0, p13 = J, 2
	}
	;;
	{ .mmi
	(p13) LDFPD	f48,  f49  = [X], 2 * SIZE
	(p13) LDFPD	f50,  f51  = [Y], 2 * SIZE
	tbit.z	p0, p14 = J, 1
	}
	;;
	{ .mmi
	(p13) LDFPD	f52,  f53  = [X], 2 * SIZE
	(p13) LDFPD	f54,  f55  = [Y], 2 * SIZE
	tbit.z	p0, p15 = J, 0
	}
	;;
	{ .mmf
	(p14) LDFPD	f56,  f57  = [X], 2 * SIZE
	(p12) FMA	f6  = ALPHA, f32, f34
	}
	{ .mmf
	(p14) LDFPD	f58,  f59  = [Y], 2 * SIZE
	mov   YY = Y1;
	(p12) FMA	f7  = ALPHA, f36, f38
	}
	;;
	{ .mmf
	(p15) LDFD	f60  = [X]
	(p12) FMA	f10 = ALPHA, f33, f35
	}
	{ .mmf
	(p15) LDFD	f61  = [Y]
	(p12) FMA	f11 = ALPHA, f37, f39
	}
	;;
	(p12) FMA	f12 = ALPHA, f40, f42
	(p12) FMA	f13 = ALPHA, f44, f46
	(p12) FMA	f14 = ALPHA, f41, f43
	(p12) shladd YY = INCY, 3, YY
	(p12) FMA	f15 = ALPHA, f45, f47
	;;
	(p12) STFD	[Y1] = f6,   1 * SIZE
	(p13) FMA	f6  = ALPHA, f48, f50
	(p12) STFD	[Y2] = f7,   1 * SIZE
	(p13) FMA	f7  = ALPHA, f52, f54
	;;
	(p12) STFD	[Y1] = f10,  3 * SIZE
	(p13) FMA	f10 = ALPHA, f49, f51
	(p12) STFD	[Y2] = f11,  3 * SIZE
	(p13) FMA	f11 = ALPHA, f53, f55
	;;
	(p12) STFD	[Y1] = f12,  1 * SIZE
	(p14) FMA	f12 = ALPHA, f56, f58
	(p12) STFD	[Y2] = f13,  1 * SIZE
	(p15) FMA	f13 = ALPHA, f60, f61
	;;
	{ .mmf
	(p12) STFD	[Y1] = f14,  3 * SIZE
	(p12) STFD	[Y2] = f15,  3 * SIZE
	(p14) FMA	f14 = ALPHA, f57, f59
	}
	;;
	{ .mmi
	(p13) STFD	[Y1] = f6,   1 * SIZE
	(p13) STFD	[Y2] = f7,   1 * SIZE
	(p13) shladd YY = INCY, 2, YY
	}
	;;
	{ .mmi
	(p13) STFD	[Y1] = f10,  3 * SIZE
	(p13) STFD	[Y2] = f11,  3 * SIZE
	(p14) shladd YY = INCY, 1, YY
	}
	;;
	(p14) STFD	[Y1] = f12,  1 * SIZE
	(p15) STFD	[YY] = f13
	;;
	(p14) STFD	[Y1] = f14,  1 * SIZE
	br.ret.sptk.many b0
	;;
	.align 32

/* X is aligned; case 2 */

.L20:
	{ .mmi
	(p10) STFD [YYY] = f9
	adds	PRE1 = (PREFETCHSIZE + 16) * SIZE, X
	mov	ar.lc = I
	}
	{ .mib
	adds	PRE2 = PREFETCHSIZE * SIZE, Y
	tbit.z	p0, p12 = J, 3
	(p7) br.cond.dpnt  .L25
	}
	;;
	.align 32

.L22:
	{ .mmf
	(p19) STFD	[Y1] = f6,   1 * SIZE
	(p19) STFD	[Y2] = f7,   1 * SIZE
	(p18) FMA	f6  = ALPHA, f34, f82
	}
	{ .mmf
	(p16) lfetch.nt1	[PRE1], 16 * SIZE
	(p16) lfetch.excl.nt1	[PRE2], 16 * SIZE
	(p18) FMA	f7  = ALPHA, f40, f88
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f10,  3 * SIZE
	(p19) STFD	[Y2] = f11,  3 * SIZE
	(p18) FMA	f10 = ALPHA, f37, f85
	}
	{ .mmf
	(p17) LDFPD	f33,  f36  = [X], 2 * SIZE
	(p16) LDFPD	f80,  f83  = [Y], 2 * SIZE
	(p18) FMA	f11 = ALPHA, f43, f91
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f12,  1 * SIZE
	(p19) STFD	[Y2] = f13,  1 * SIZE
	(p18) FMA	f12 = ALPHA, f46, f94
	}
	{ .mmf
	(p17) LDFPD	f39,  f42  = [X], 2 * SIZE
	(p16) LDFPD	f86,  f89  = [Y], 2 * SIZE
	(p18) FMA	f13 = ALPHA, f52, f100
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f14,  3 * SIZE
	(p19) STFD	[Y2] = f15,  3 * SIZE
	(p18) FMA	f14 = ALPHA, f49, f97
	}
	{ .mmf
	(p17) LDFPD	f45,  f48  = [X], 2 * SIZE
	(p16) LDFPD	f92,  f95  = [Y], 2 * SIZE
	(p18) FMA	f15 = ALPHA, f55, f103
	}
	;;
	{ .mmf
	(p18) STFD	[Y1] = f6,   1 * SIZE
	(p18) STFD	[Y2] = f7,   1 * SIZE
	(p18) FMA	f6 = ALPHA, f58, f106
	}
	{ .mmf
	(p17) LDFPD	f51,  f54  = [X], 2 * SIZE
	(p16) LDFPD	f98,  f101 = [Y], 2 * SIZE
	(p18) FMA	f7 = ALPHA, f64, f112
	}
	;;
	{ .mmf
	(p18) STFD	[Y1] = f10,  3 * SIZE
	(p18) STFD	[Y2] = f11,  3 * SIZE
	(p18) FMA	f10  = ALPHA, f61, f109
	}
	{ .mmf
	(p17) LDFPD	f57,  f60  = [X], 2 * SIZE
	(p16) LDFPD	f104, f107 = [Y], 2 * SIZE
	(p18) FMA	f11 = ALPHA, f67, f115
	}
	;;
	{ .mmf
	(p18) STFD	[Y1] = f12,  1 * SIZE
	(p18) STFD	[Y2] = f13,  1 * SIZE
	(p18) FMA	f12 = ALPHA, f70, f118
	}
	{ .mmf
	(p17) LDFPD	f63,  f66  = [X], 2 * SIZE
	(p16) LDFPD	f110, f113 = [Y], 2 * SIZE
	(p18) FMA	f13 = ALPHA, f76, f124
	}
	;;
	{ .mmf
	(p18) STFD	[Y1] = f14,  3 * SIZE
	(p18) STFD	[Y2] = f15,  3 * SIZE
	(p18) FMA	f14 = ALPHA, f73, f121
	}
	{ .mmf
	(p17) LDFPD	f69,  f72  = [X], 2 * SIZE
	(p16) LDFPD	f116, f119 = [Y], 2 * SIZE
	(p18) FMA	f15 = ALPHA, f79, f127
	}
	;;
	(p17) LDFPD	f75,  f78  = [X], 2 * SIZE
	(p16) LDFPD	f122, f125 = [Y], 2 * SIZE
	br.ctop.sptk.few .L22
	;;
	{ .mmf
	(p19) STFD	[Y1] = f6,   1 * SIZE
	(p19) STFD	[Y2] = f7,   1 * SIZE
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f10,  3 * SIZE
	(p19) STFD	[Y2] = f11,  3 * SIZE
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f12,  1 * SIZE
	(p19) STFD	[Y2] = f13,  1 * SIZE
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f14,  3 * SIZE
	(p19) STFD	[Y2] = f15,  3 * SIZE
	}
	;;
	.align 32

.L25:
	{ .mmi
	(p12) LDFPD	f32,  f33  = [X], 2 * SIZE
	(p12) LDFPD	f34,  f35  = [Y], 2 * SIZE
	mov	pr = PR, -65474
	}
	;;
	{ .mmi
	(p12) LDFPD	f36,  f37  = [X], 2 * SIZE
	(p12) LDFPD	f38,  f39  = [Y], 2 * SIZE
	mov	ar.lc  = ARLC
	}
	;;
	{ .mmb
	(p12) LDFPD	f40,  f41  = [X], 2 * SIZE
	(p12) LDFPD	f42,  f43  = [Y], 2 * SIZE
	(p9) br.ret.sptk.many b0
	}
	;;
	{ .mmi
	(p12) LDFPD	f44,  f45  = [X], 2 * SIZE
	(p12) LDFPD	f46,  f47  = [Y], 2 * SIZE
	tbit.z	p0, p13 = J, 2
	}
	;;
	{ .mmi
	(p13) LDFPD	f48,  f49  = [X], 2 * SIZE
	(p13) LDFPD	f50,  f51  = [Y], 2 * SIZE
	tbit.z	p0, p14 = J, 1
	}
	;;
	{ .mmi
	(p13) LDFPD	f52,  f53  = [X], 2 * SIZE
	(p13) LDFPD	f54,  f55  = [Y], 2 * SIZE
	tbit.z	p0, p15 = J, 0
	}
	;;
	{ .mmf
	(p14) LDFPD	f56,  f57  = [X], 2 * SIZE
	(p12) FMA	f6  = ALPHA, f32, f34
	}
	{ .mmf
	(p14) LDFPD	f58,  f59  = [Y], 2 * SIZE
	mov   YY = Y1;
	(p12) FMA	f7  = ALPHA, f36, f38
	}
	;;
	{ .mmf
	(p15) LDFD	f60  = [X]
	(p12) FMA	f10 = ALPHA, f33, f35
	}
	{ .mmf
	(p15) LDFD	f61  = [Y]
	(p12) FMA	f11 = ALPHA, f37, f39
	}
	;;
	(p12) FMA	f12 = ALPHA, f40, f42
	(p12) FMA	f13 = ALPHA, f44, f46
	(p12) FMA	f14 = ALPHA, f41, f43
	(p12) shladd YY = INCY, 3, YY
	(p12) FMA	f15 = ALPHA, f45, f47
	;;
	(p12) STFD	[Y1] = f6,   1 * SIZE
	(p13) FMA	f6  = ALPHA, f48, f50
	(p12) STFD	[Y2] = f7,   1 * SIZE
	(p13) FMA	f7  = ALPHA, f52, f54
	;;
	(p12) STFD	[Y1] = f10,  3 * SIZE
	(p13) FMA	f10 = ALPHA, f49, f51
	(p12) STFD	[Y2] = f11,  3 * SIZE
	(p13) FMA	f11 = ALPHA, f53, f55
	;;
	(p12) STFD	[Y1] = f12,  1 * SIZE
	(p14) FMA	f12 = ALPHA, f56, f58
	(p12) STFD	[Y2] = f13,  1 * SIZE
	(p15) FMA	f13 = ALPHA, f60, f61
	;;
	{ .mmf
	(p12) STFD	[Y1] = f14,  3 * SIZE
	(p12) STFD	[Y2] = f15,  3 * SIZE
	(p14) FMA	f14 = ALPHA, f57, f59
	}
	;;
	{ .mmi
	(p13) STFD	[Y1] = f6,   1 * SIZE
	(p13) STFD	[Y2] = f7,   1 * SIZE
	(p13) shladd YY = INCY, 2, YY
	}
	;;
	{ .mmi
	(p13) STFD	[Y1] = f10,  3 * SIZE
	(p13) STFD	[Y2] = f11,  3 * SIZE
	(p14) shladd YY = INCY, 1, YY
	}
	;;
	(p14) STFD	[Y1] = f12,  1 * SIZE
	(p15) STFD	[YY] = f13
	;;
	(p14) STFD	[Y1] = f14,  1 * SIZE
	br.ret.sptk.many b0
	;;
	.align 32

.L30:
	{ .mmi
	cmp.eq	p9, p0  =   r0, J
	cmp.eq	p7 ,p0  = 0, I
	mov	ar.ec = 3
	}
	{ .mmb
	(p8) cmp.gt.unc	p6, p0 =  16, XA
	adds	I = -1, I
	(p6) br.cond.dpnt .L40
	}
	;;
	{ .mmi
	(p10) STFD [YYY] = f9
	adds	PRE1 = (PREFETCHSIZE + 24) * SIZE, X
	mov	ar.lc = I
	}
	{ .mib
	adds	PRE2 = (PREFETCHSIZE + 16) * SIZE, Y
	tbit.z	p0, p12 = J, 3
	(p7) br.cond.dpnt  .L35
	}
	;;
	.align 32

.L32:
	{ .mmf
	(p19) STFD	[Y1] = f6,   1 * SIZE
	(p19) STFD	[Y2] = f7,   1 * SIZE
	(p18) FMA	f6  = ALPHA, f34, f82
	}
	{ .mmf
	(p16) LDFD	f80 = [Y], 1 * SIZE
	(p16) LDFPD	f32,  f35  = [X], 2 * SIZE
	(p18) FMA	f7  = ALPHA, f40, f88
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f10,  3 * SIZE
	(p19) STFD	[Y2] = f11,  3 * SIZE
	(p18) FMA	f10 = ALPHA, f37, f85
	}
	{ .mmf
	(p16) LDFPD	f38,  f41  = [X], 2 * SIZE
	(p16) LDFPD	f83,  f86  = [Y], 2 * SIZE
	(p18) FMA	f11 = ALPHA, f43, f91
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f12,  1 * SIZE
	(p19) STFD	[Y2] = f13,  1 * SIZE
	(p18) FMA	f12 = ALPHA, f46, f94
	}
	{ .mmf
	(p16) LDFPD	f44,  f47  = [X], 2 * SIZE
	(p16) LDFPD	f89,  f92  = [Y], 2 * SIZE
	(p18) FMA	f13 = ALPHA, f52, f100
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f14,  3 * SIZE
	(p19) STFD	[Y2] = f15,  3 * SIZE
	(p18) FMA	f14 = ALPHA, f49, f97
	}
	{ .mmf
	(p16) LDFPD	f50,  f53  = [X], 2 * SIZE
	(p16) LDFPD	f95,  f98  = [Y], 2 * SIZE
	(p18) FMA	f15 = ALPHA, f55, f103
	}
	;;
	{ .mmf
	(p18) STFD	[Y1] = f6,   1 * SIZE
	(p18) STFD	[Y2] = f7,   1 * SIZE
	(p18) FMA	f6 = ALPHA, f58, f106
	}
	{ .mmf
	(p16) LDFPD	f56,  f59  = [X], 2 * SIZE
	(p16) LDFPD	f101, f104 = [Y], 2 * SIZE
	(p18) FMA	f7 = ALPHA, f64, f112
	}
	;;
	{ .mmf
	(p18) STFD	[Y1] = f10,  3 * SIZE
	(p18) STFD	[Y2] = f11,  3 * SIZE
	(p18) FMA	f10  = ALPHA, f61, f109
	}
	{ .mmf
	(p16) LDFPD	f62,  f65  = [X], 2 * SIZE
	(p16) LDFPD	f107, f110 = [Y], 2 * SIZE
	(p18) FMA	f11 = ALPHA, f67, f115
	}
	;;
	{ .mmf
	(p18) STFD	[Y1] = f12,  1 * SIZE
	(p18) STFD	[Y2] = f13,  1 * SIZE
	(p18) FMA	f12 = ALPHA, f70, f118
	}
	{ .mmf
	(p16) LDFPD	f68,  f71  = [X], 2 * SIZE
	(p16) LDFPD	f113, f116 = [Y], 2 * SIZE
	(p18) FMA	f13 = ALPHA, f76, f124
	}
	;;
	{ .mmf
	(p18) STFD	[Y1] = f14,  3 * SIZE
	(p18) STFD	[Y2] = f15,  3 * SIZE
	(p18) FMA	f14 = ALPHA, f73, f121
	}
	{ .mmf
	(p16) LDFPD	f74,  f77  = [X], 2 * SIZE
	(p16) LDFPD	f119, f122 = [Y], 2 * SIZE
	(p18) FMA	f15 = ALPHA, f79, f127
	}
	;;
	(p16) lfetch.nt1	[PRE1], 16 * SIZE
	(p16) lfetch.excl.nt1	[PRE2], 16 * SIZE
	(p16) LDFD	f125  = [Y], 1 * SIZE
	br.ctop.sptk.few .L32
	;;
	{ .mmf
	(p19) STFD	[Y1] = f6,   1 * SIZE
	(p19) STFD	[Y2] = f7,   1 * SIZE
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f10,  3 * SIZE
	(p19) STFD	[Y2] = f11,  3 * SIZE
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f12,  1 * SIZE
	(p19) STFD	[Y2] = f13,  1 * SIZE
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f14,  3 * SIZE
	(p19) STFD	[Y2] = f15,  3 * SIZE
	}
	;;
	.align 32

.L35:
	{ .mmi
	(p12) LDFPD	f32,  f33  = [X], 2 * SIZE
	(p12) LDFD	f34 = [Y], 1 * SIZE;
	mov	pr = PR, -65474
	}
	;;
	{ .mmi
	(p12) LDFPD	f36,  f37  = [X], 2 * SIZE
	(p12) LDFPD	f35,  f38  = [Y], 2 * SIZE
	mov	ar.lc  = ARLC
	}
	;;
	{ .mmb
	(p12) LDFPD	f40,  f41  = [X], 2 * SIZE
	(p12) LDFPD	f39,  f42  = [Y], 2 * SIZE
	(p9) br.ret.sptk.many b0
	}
	;;
	{ .mmi
	(p12) LDFPD	f44,  f45  = [X], 2 * SIZE
	(p12) LDFPD	f43,  f46  = [Y], 2 * SIZE
	tbit.z	p0, p13 = J, 2
	}
	;;
	{ .mmi
	(p13) LDFPD	f48,  f49  = [X], 2 * SIZE
	(p12) LDFD	f47 = [Y], 1 * SIZE
	tbit.z	p0, p14 = J, 1
	}
	;;
	{ .mmi
	(p13) LDFPD	f52,  f53  = [X], 2 * SIZE
	(p13) LDFD	f50 = [Y], 1 * SIZE
	tbit.z	p0, p15 = J, 0
	}
	;;
	{ .mmi
	(p14) LDFPD	f56,  f57  = [X], 2 * SIZE
	(p13) LDFPD	f51,  f54  = [Y], 2 * SIZE
	mov   YY = Y1;
	}
	;;
	(p15) LDFD	f60  = [X]
	(p13) LDFD	f55 = [Y], 1 * SIZE
	;;
	(p14) LDFD	f58 = [Y], 1 * SIZE
	;;
	(p14) LDFD	f59  = [Y], 1 * SIZE
	(p12) FMA	f6  = ALPHA, f32, f34
	;;
	(p15) LDFD	f61  = [Y]
	(p12) FMA	f7  = ALPHA, f36, f38
	;;
	(p12) FMA	f10 = ALPHA, f33, f35
	(p12) FMA	f11 = ALPHA, f37, f39
	(p12) FMA	f12 = ALPHA, f40, f42
	(p12) FMA	f13 = ALPHA, f44, f46
	(p12) FMA	f14 = ALPHA, f41, f43
	(p12) shladd YY = INCY, 3, YY
	(p12) FMA	f15 = ALPHA, f45, f47
	;;
	(p12) STFD	[Y1] = f6,   1 * SIZE
	(p13) FMA	f6  = ALPHA, f48, f50
	(p12) STFD	[Y2] = f7,   1 * SIZE
	(p13) FMA	f7  = ALPHA, f52, f54
	;;
	(p12) STFD	[Y1] = f10,  3 * SIZE
	(p13) FMA	f10 = ALPHA, f49, f51
	(p12) STFD	[Y2] = f11,  3 * SIZE
	(p13) FMA	f11 = ALPHA, f53, f55
	;;
	(p12) STFD	[Y1] = f12,  1 * SIZE
	(p14) FMA	f12 = ALPHA, f56, f58
	(p12) STFD	[Y2] = f13,  1 * SIZE
	(p15) FMA	f13 = ALPHA, f60, f61
	;;
	{ .mmf
	(p12) STFD	[Y1] = f14,  3 * SIZE
	(p12) STFD	[Y2] = f15,  3 * SIZE
	(p14) FMA	f14 = ALPHA, f57, f59
	}
	;;
	{ .mmi
	(p13) STFD	[Y1] = f6,   1 * SIZE
	(p13) STFD	[Y2] = f7,   1 * SIZE
	(p13) shladd YY = INCY, 2, YY
	}
	;;
	{ .mmi
	(p13) STFD	[Y1] = f10,  3 * SIZE
	(p13) STFD	[Y2] = f11,  3 * SIZE
	(p14) shladd YY = INCY, 1, YY
	}
	;;
	(p14) STFD	[Y1] = f12,  1 * SIZE
	(p15) STFD	[YY] = f13
	;;
	(p14) STFD	[Y1] = f14,  1 * SIZE
	br.ret.sptk.many b0
	;;
	.align 32

.L40:
	{ .mmi
	(p10) STFD [YYY] = f9
	adds	PRE1 = (PREFETCHSIZE + 8) * SIZE, X
	mov	ar.lc = I
	}
	{ .mib
	adds	PRE2 = (PREFETCHSIZE + 14) * SIZE, Y
	tbit.z	p0, p12 = J, 3
	(p7) br.cond.dpnt  .L45
	}
	;;
	.align 32

.L42:
	{ .mmf
	(p19) STFD	[Y1] = f6,   1 * SIZE
	(p19) STFD	[Y2] = f7,   1 * SIZE
	(p18) FMA	f6  = ALPHA, f34, f82
	}
	{ .mmf
	(p17) LDFPD	f33,  f36  = [X], 2 * SIZE
	(p16) LDFD	f80  = [Y], 1 * SIZE
	(p18) FMA	f7  = ALPHA, f40, f88
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f10,  3 * SIZE
	(p19) STFD	[Y2] = f11,  3 * SIZE
	(p18) FMA	f10 = ALPHA, f37, f85
	}
	{ .mmf
	(p17) LDFPD	f39,  f42  = [X], 2 * SIZE
	(p16) LDFPD	f83,  f86  = [Y], 2 * SIZE
	(p18) FMA	f11 = ALPHA, f43, f91
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f12,  1 * SIZE
	(p19) STFD	[Y2] = f13,  1 * SIZE
	(p18) FMA	f12 = ALPHA, f46, f94
	}
	{ .mmf
	(p17) LDFPD	f45,  f48  = [X], 2 * SIZE
	(p16) LDFPD	f89,  f92  = [Y], 2 * SIZE
	(p18) FMA	f13 = ALPHA, f52, f100
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f14,  3 * SIZE
	(p19) STFD	[Y2] = f15,  3 * SIZE
	(p18) FMA	f14 = ALPHA, f49, f97
	}
	{ .mmf
	(p17) LDFPD	f51,  f54  = [X], 2 * SIZE
	(p16) LDFPD	f95,  f98  = [Y], 2 * SIZE
	(p18) FMA	f15 = ALPHA, f55, f103
	}
	;;
	{ .mmf
	(p18) STFD	[Y1] = f6,   1 * SIZE
	(p18) STFD	[Y2] = f7,   1 * SIZE
	(p18) FMA	f6 = ALPHA, f58, f106
	}
	{ .mmf
	(p17) LDFPD	f57,  f60  = [X], 2 * SIZE
	(p16) LDFPD	f101, f104 = [Y], 2 * SIZE
	(p18) FMA	f7 = ALPHA, f64, f112
	}
	;;
	{ .mmf
	(p18) STFD	[Y1] = f10,  3 * SIZE
	(p18) STFD	[Y2] = f11,  3 * SIZE
	(p18) FMA	f10  = ALPHA, f61, f109
	}
	{ .mmf
	(p17) LDFPD	f63,  f66  = [X], 2 * SIZE
	(p16) LDFPD	f107, f110 = [Y], 2 * SIZE
	(p18) FMA	f11 = ALPHA, f67, f115
	}
	;;
	{ .mmf
	(p18) STFD	[Y1] = f12,  1 * SIZE
	(p18) STFD	[Y2] = f13,  1 * SIZE
	(p18) FMA	f12 = ALPHA, f70, f118
	}
	{ .mmf
	(p17) LDFPD	f69,  f72  = [X], 2 * SIZE
	(p16) LDFPD	f113, f116 = [Y], 2 * SIZE
	(p18) FMA	f13 = ALPHA, f76, f124
	}
	;;
	{ .mmf
	(p18) STFD	[Y1] = f14,  3 * SIZE
	(p18) STFD	[Y2] = f15,  3 * SIZE
	(p18) FMA	f14 = ALPHA, f73, f121
	}
	{ .mmf
	(p17) LDFPD	f75,  f78  = [X], 2 * SIZE
	(p16) LDFPD	f119, f122 = [Y], 2 * SIZE
	(p18) FMA	f15 = ALPHA, f79, f127
	}
	;;
	(p16) lfetch.nt1	[PRE1], 16 * SIZE
	(p16) lfetch.excl.nt1	[PRE2], 16 * SIZE
	(p16) LDFD	f125 = [Y], 1 * SIZE
	br.ctop.sptk.few .L42
	;;
	{ .mmf
	(p19) STFD	[Y1] = f6,   1 * SIZE
	(p19) STFD	[Y2] = f7,   1 * SIZE
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f10,  3 * SIZE
	(p19) STFD	[Y2] = f11,  3 * SIZE
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f12,  1 * SIZE
	(p19) STFD	[Y2] = f13,  1 * SIZE
	}
	;;
	{ .mmf
	(p19) STFD	[Y1] = f14,  3 * SIZE
	(p19) STFD	[Y2] = f15,  3 * SIZE
	}
	;;
	.align 32

.L45:
	{ .mmi
	(p12) LDFPD	f32,  f33  = [X], 2 * SIZE
	(p12) LDFD	f34 = [Y], 1 * SIZE;
	mov	pr = PR, -65474
	}
	;;
	{ .mmi
	(p12) LDFPD	f36,  f37  = [X], 2 * SIZE
	(p12) LDFPD	f35,  f38  = [Y], 2 * SIZE
	mov	ar.lc  = ARLC
	}
	;;
	{ .mmb
	(p12) LDFPD	f40,  f41  = [X], 2 * SIZE
	(p12) LDFPD	f39,  f42  = [Y], 2 * SIZE
	(p9) br.ret.sptk.many b0
	}
	;;
	{ .mmi
	(p12) LDFPD	f44,  f45  = [X], 2 * SIZE
	(p12) LDFPD	f43,  f46  = [Y], 2 * SIZE
	tbit.z	p0, p13 = J, 2
	}
	;;
	{ .mmi
	(p13) LDFPD	f48,  f49  = [X], 2 * SIZE
	(p12) LDFD	f47 = [Y], 1 * SIZE
	tbit.z	p0, p14 = J, 1
	}
	;;
	{ .mmi
	(p13) LDFPD	f52,  f53  = [X], 2 * SIZE
	(p13) LDFD	f50 = [Y], 1 * SIZE
	tbit.z	p0, p15 = J, 0
	}
	;;
	{ .mmi
	(p14) LDFPD	f56,  f57  = [X], 2 * SIZE
	(p13) LDFPD	f51,  f54  = [Y], 2 * SIZE
	mov   YY = Y1;
	}
	;;
	(p15) LDFD	f60  = [X]
	(p13) LDFD	f55 = [Y], 1 * SIZE
	;;
	(p14) LDFD	f58 = [Y], 1 * SIZE
	;;
	(p14) LDFD	f59  = [Y], 1 * SIZE
	(p12) FMA	f6  = ALPHA, f32, f34
	;;
	(p15) LDFD	f61  = [Y]
	(p12) FMA	f7  = ALPHA, f36, f38
	;;
	(p12) FMA	f10 = ALPHA, f33, f35
	(p12) FMA	f11 = ALPHA, f37, f39
	(p12) FMA	f12 = ALPHA, f40, f42
	(p12) FMA	f13 = ALPHA, f44, f46
	(p12) FMA	f14 = ALPHA, f41, f43
	(p12) shladd YY = INCY, 3, YY
	(p12) FMA	f15 = ALPHA, f45, f47
	;;
	(p12) STFD	[Y1] = f6,   1 * SIZE
	(p13) FMA	f6  = ALPHA, f48, f50
	(p12) STFD	[Y2] = f7,   1 * SIZE
	(p13) FMA	f7  = ALPHA, f52, f54
	;;
	(p12) STFD	[Y1] = f10,  3 * SIZE
	(p13) FMA	f10 = ALPHA, f49, f51
	(p12) STFD	[Y2] = f11,  3 * SIZE
	(p13) FMA	f11 = ALPHA, f53, f55
	;;
	(p12) STFD	[Y1] = f12,  1 * SIZE
	(p14) FMA	f12 = ALPHA, f56, f58
	(p12) STFD	[Y2] = f13,  1 * SIZE
	(p15) FMA	f13 = ALPHA, f60, f61
	;;
	{ .mmf
	(p12) STFD	[Y1] = f14,  3 * SIZE
	(p12) STFD	[Y2] = f15,  3 * SIZE
	(p14) FMA	f14 = ALPHA, f57, f59
	}
	;;
	{ .mmi
	(p13) STFD	[Y1] = f6,   1 * SIZE
	(p13) STFD	[Y2] = f7,   1 * SIZE
	(p13) shladd YY = INCY, 2, YY
	}
	;;
	{ .mmi
	(p13) STFD	[Y1] = f10,  3 * SIZE
	(p13) STFD	[Y2] = f11,  3 * SIZE
	(p14) shladd YY = INCY, 1, YY
	}
	;;
	(p14) STFD	[Y1] = f12,  1 * SIZE
	(p15) STFD	[YY] = f13
	;;
	(p14) STFD	[Y1] = f14,  1 * SIZE
	br.ret.sptk.many b0
	;;
	.align 32

.L100:
	{ .mii
	and	J =  15, N
	shr	I =  N, 4
	mov	ar.ec = 3
	}
	;;
	{ .mmi
	cmp.eq	p9, p0  =   r0, J
	cmp.eq	p7 ,p0  = 0, I
	adds	I = -1, I
	}
	;;
	{ .mmi
	(p10) STFD [YYY] = f9
	adds	PRE1 = PREFETCHSIZE * SIZE, X
	mov	ar.lc = I
	}
	{ .mib
	adds	PRE2 = PREFETCHSIZE * SIZE, Y
	tbit.z	p0, p12 = J, 3
	(p7) br.cond.dpnt  .L115
	}
	;;
	.align 32

.L112:
	{ .mmi
	(p18) STFD	[Y1] = f6
	(p16) lfetch.nt1	[PRE1], INCX16
	(p18) add Y1 = INCY, Y1
	}
	{.mmf
	(p16) LDFD	f32  = [X], INCX
	(p16) LDFD	f80  = [Y], INCY
	(p18) FMA	f6  = ALPHA, f58, f106
	}
	;;
	{ .mmi
 	(p18) STFD	[Y1] = f7
	(p16) lfetch.excl.nt1	[PRE2], INCY16
	(p18) add Y1 = INCY, Y1
	}
	{ .mmf
	(p16) LDFD	f35  = [X], INCX
	(p16) LDFD	f83  = [Y], INCY
	(p18) FMA	f7  = ALPHA, f61, f109
	}
	;;
	{ .mmi
	(p18) STFD	[Y1] = f10
	(p18) add Y1 = INCY, Y1
	nop.i 0
	}
	{ .mmf
	(p16) LDFD	f38  = [X], INCX
	(p16) LDFD	f86  = [Y], INCY
	(p18) FMA	f10 = ALPHA, f64, f112
	}
	;;
	{ .mmi
	(p18) STFD	[Y1] = f11
	(p18) add Y1 = INCY, Y1
	nop.i 0
	}
	{ .mmf
	(p16) LDFD	f41  = [X], INCX
	(p16) LDFD	f89  = [Y], INCY
	(p18) FMA	f11 = ALPHA, f67, f115
	}
	;;
	{ .mmi
	(p18) STFD	[Y1] = f12
	(p18) add Y1 = INCY, Y1
	nop.i 0
	}
	{ .mmf
	(p16) LDFD	f44  = [X], INCX
	(p16) LDFD	f92  = [Y], INCY
	(p18) FMA	f12 = ALPHA, f70, f118
	}
	;;
	{ .mmi
	(p18) STFD	[Y1] = f13
	(p18) add Y1 = INCY, Y1
	nop.i 0
	}
	{ .mmf
	(p16) LDFD	f47  = [X], INCX
	(p16) LDFD	f95  = [Y], INCY
	(p18) FMA	f13 = ALPHA, f73, f121
	}
	;;
	{ .mmi
	(p18) STFD	[Y1] = f14
	(p18) add Y1 = INCY, Y1
	nop.i 0
	}
	{ .mmf
	(p16) LDFD	f50  = [X], INCX
	(p16) LDFD	f98  = [Y], INCY
	(p18) FMA	f14 = ALPHA, f76, f124
	}
	;;
	{ .mmi
	(p18) STFD	[Y1] = f15
	(p18) add Y1 = INCY, Y1
	nop.i 0
	}
	{ .mmf
	(p16) LDFD	f53  = [X], INCX
	(p16) LDFD	f101 = [Y], INCY
	(p18) FMA	f15 = ALPHA, f79, f127
	}
	;;
	{ .mmi
	(p18) STFD	[Y1] = f6
	(p18) add Y1 = INCY, Y1
	nop.i 0
	}
	{ .mmf
	(p16) LDFD	f56  = [X], INCX
	(p16) LDFD	f104 = [Y], INCY
	(p17) FMA	f6  = ALPHA, f33, f81
	}
	;;
	{ .mmi
 	(p18) STFD	[Y1] = f7
	(p18) add Y1 = INCY, Y1
	nop.i 0
	}
	{ .mmf
	(p16) LDFD	f59  = [X], INCX
	(p16) LDFD	f107 = [Y], INCY
	(p17) FMA	f7  = ALPHA, f36, f84
	}
	;;
	{ .mmi
	(p18) STFD	[Y1] = f10
	(p18) add Y1 = INCY, Y1
	nop.i 0
	}
	{ .mmf
	(p16) LDFD	f62  = [X], INCX
	(p16) LDFD	f110 = [Y], INCY
	(p17) FMA	f10 = ALPHA, f39, f87
	}
	;;
	{ .mmi
	(p18) STFD	[Y1] = f11
	(p18) add Y1 = INCY, Y1
	nop.i 0
	}
	{ .mmf
	(p16) LDFD	f65  = [X], INCX
	(p16) LDFD	f113 = [Y], INCY
	(p17) FMA	f11 = ALPHA, f42, f90
	}
	;;
	{ .mmi
	(p18) STFD	[Y1] = f12
	(p18) add Y1 = INCY, Y1
	nop.i 0
	}
	{ .mmf
	(p16) LDFD	f68  = [X], INCX
	(p16) LDFD	f116 = [Y], INCY
	(p17) FMA	f12 = ALPHA, f45, f93
	}
	;;
	{ .mmi
	(p18) STFD	[Y1] = f13
	(p18) add Y1 = INCY, Y1
	nop.i 0
	}
	{ .mmf
	(p16) LDFD	f71  = [X], INCX
	(p16) LDFD	f119 = [Y], INCY
	(p17) FMA	f13 = ALPHA, f48, f96
	}	
	;;
	{ .mmi
	(p18) STFD	[Y1] = f14
	(p18) add Y1 = INCY, Y1
	nop.i 0
	}
	{ .mmf
	(p16) LDFD	f74  = [X], INCX
	(p16) LDFD	f122 = [Y], INCY
	(p17) FMA	f14 = ALPHA, f51, f99
	}
	;;
	{ .mmf
	(p18) STFD	[Y1] = f15
	(p18) add Y1 = INCY, Y1
	(p17) FMA	f15 = ALPHA, f54, f102
	}
	{ .mmb
	(p16) LDFD	f77  = [X], INCX
	(p16) LDFD	f125 = [Y], INCY
	br.ctop.sptk.few .L112
	}
	;;
	.align 32

.L115:
	(p12) LDFD f32 = [X], INCX
	(p12) LDFD f34 = [Y], INCY
	mov	pr = PR, -65474
	;;
	(p12) LDFD f33 = [X], INCX
	(p12) LDFD f35 = [Y], INCY
	mov	ar.lc  = ARLC
	;;
	(p12) LDFD f36 = [X], INCX
	(p12) LDFD f38 = [Y], INCY
	(p9) br.ret.sptk.many b0
	;;
	(p12) LDFD f37 = [X], INCX
	(p12) LDFD f39 = [Y], INCY
	tbit.z	p0, p13 = J, 2
	;;
	(p12) LDFD f40 = [X], INCX
	(p12) LDFD f42 = [Y], INCY
	tbit.z	p0, p14 = J, 1
	;;
	(p12) LDFD f41 = [X], INCX
	(p12) LDFD f43 = [Y], INCY
	tbit.z	p0, p15 = J, 0
	;;
	{ .mmf
	(p12) LDFD f44 = [X], INCX
	(p12) LDFD f46 = [Y], INCY
	(p12) FMA	f6  = ALPHA, f32, f34
	}
	;;
	{ .mmf
	(p12) LDFD f45 = [X], INCX
	(p12) LDFD f47 = [Y], INCY
	(p12) FMA	f7  = ALPHA, f33, f35
	}
	;;
	{ .mmf
	(p13) LDFD f48 = [X], INCX
	(p13) LDFD f50 = [Y], INCY
	(p12) FMA	f10 = ALPHA, f36, f38
	}
	;;
	{ .mmf
	(p13) LDFD f49 = [X], INCX
	(p13) LDFD f51 = [Y], INCY
	(p12) FMA	f11 = ALPHA, f37, f39
	}
	;;
	{ .mmi
	(p12) STFD	[Y1] = f6
	(p12) add Y1 = INCY, Y1
	nop.i 0
	}
	{ .mmf
	(p13) LDFD f52 = [X], INCX
	(p13) LDFD f54 = [Y], INCY
	(p12) FMA	f12 = ALPHA, f40, f42
	}
	;;
	{ .mmi
	(p12) STFD	[Y1] = f7
	(p12) add Y1 = INCY, Y1
	nop.i 0
	}
	{ .mmf
	(p13) LDFD f53 = [X], INCX
	(p13) LDFD f55 = [Y], INCY
	(p12) FMA	f13 = ALPHA, f41, f43
	}
	;;
	{ .mmi
	(p12) STFD	[Y1] = f10
	(p12) add Y1 = INCY, Y1
	nop.i 0
	}
	{ .mmf
	(p14) LDFD f56 = [X], INCX
	(p14) LDFD f58 = [Y], INCY
	(p12) FMA	f14 = ALPHA, f44, f46
	}
	;;
	{ .mmi
	(p12) STFD	[Y1] = f11
	(p12) add Y1 = INCY, Y1
	nop.i 0
	}
	{ .mmf
	(p14) LDFD f57 = [X], INCX
	(p14) LDFD f59 = [Y], INCY
	(p12) FMA	f15 = ALPHA, f45, f47
	}
	;;
	{ .mmi
	(p12) STFD	[Y1] = f12
	(p12) add Y1 = INCY, Y1
	nop.i 0
	}
	{ .mmf
	(p15) LDFD f60 = [X]
	(p15) LDFD f61 = [Y]
	(p13) FMA	f6  = ALPHA, f48, f50
	}
	;;
	{ .mmf
	(p12) STFD	[Y1] = f13
	(p12) add Y1 = INCY, Y1
	(p13) FMA	f7  = ALPHA, f49, f51
	}
	;;
	{ .mmf
	(p12) STFD	[Y1] = f14
	(p12) add Y1 = INCY, Y1
	(p13) FMA	f10 = ALPHA, f52, f54
	}
	;;
	{ .mmf
	(p12) STFD	[Y1] = f15
	(p12) add Y1 = INCY, Y1
	(p13) FMA	f11 = ALPHA, f53, f55
	}
	;;
	{ .mmf
	(p13) STFD	[Y1] = f6
	(p13) add Y1 = INCY, Y1
	(p14) FMA	f12 = ALPHA, f56, f58
	}
	;;
	{ .mmf
	(p13) STFD	[Y1] = f7
	(p13) add Y1 = INCY, Y1
	(p14) FMA	f13 = ALPHA, f57, f59
	}
	;;
	{ .mmf
	(p13) STFD	[Y1] = f10
	(p13) add Y1 = INCY, Y1
	(p15) FMA	f14 = ALPHA, f60, f61
	}
	;;
	(p13) STFD	[Y1] = f11
	(p13) add Y1 = INCY, Y1
	;;
	(p14) STFD	[Y1] = f12
	(p14) add Y1 = INCY, Y1
	;;
	(p14) STFD	[Y1] = f13
	(p14) add Y1 = INCY, Y1
	;;
	(p15) STFD	[Y1] = f14
	br.ret.sptk.many b0
	;;
	EPILOGUE

