/*********************************************************************/
/*                                                                   */
/*             Optimized BLAS libraries                              */
/*                     By Kazushige Goto <kgoto@tacc.utexas.edu>     */
/*                                                                   */
/* Copyright (c) The University of Texas, 2005. All rights reserved. */
/* UNIVERSITY EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES CONCERNING  */
/* THIS SOFTWARE AND DOCUMENTATION, INCLUDING ANY WARRANTIES OF      */
/* MERCHANTABILITY, FITNESS FOR ANY PARTICULAR PURPOSE,              */
/* NON-INFRINGEMENT AND WARRANTIES OF PERFORMANCE, AND ANY WARRANTY  */
/* THAT MIGHT OTHERWISE ARISE FROM COURSE OF DEALING OR USAGE OF     */
/* TRADE. NO WARRANTY IS EITHER EXPRESS OR IMPLIED WITH RESPECT TO   */
/* THE USE OF THE SOFTWARE OR DOCUMENTATION.                         */
/* Under no circumstances shall University be liable for incidental, */
/* special, indirect, direct or consequential damages or loss of     */
/* profits, interruption of business, or related expenses which may  */
/* arise from use of Software or Documentation, including but not    */
/* limited to those resulting from defects in Software and/or        */
/* Documentation, or loss or inaccuracy of data of any kind.         */
/*********************************************************************/

#include <stdio.h>
#include "common.h"

int CNAME(long m, long n, long dummy1, FLOAT alpha, 
	 FLOAT *x, long incx,
	 FLOAT *y, long incy,
	 FLOAT *a, long lda, FLOAT *buffer){


  long i, j;
  FLOAT *X;

  X = x;

  if (incx != 1){
    X = buffer;
    
    i = (m >> 3);
    if (i > 0) {
      do {
	*(X + 0) = *x;
	x += incx;
	*(X + 1) = *x;
	x += incx;
	*(X + 2) = *x;
	x += incx;
	*(X + 3) = *x;
	x += incx;
	*(X + 4) = *x;
	x += incx;
	*(X + 5) = *x;
	x += incx;
	*(X + 6) = *x;
	x += incx;
	*(X + 7) = *x;
	x += incx;
	X += 8;
	i --;
      } while (i > 0);
    }

    i = (m & 7);
    if (i > 0) {
      do {
	*(X + 0) = *x;
	X ++;
	x += incx;
	i --;
      } while (i > 0);
    }


    X = buffer;
  }
    
  for (j = 0; j < n; j++) {
    AXPY_K(m, 0, 0, alpha * *y, X, 1, a + j * lda, 1, NULL, 0);
    y += incy;
  }

  return 0;
}

