/*********************************************************************/
/*                                                                   */
/*             Optimized BLAS libraries                              */
/*                     By Kazushige Goto <kgoto@tacc.utexas.edu>     */
/*                                                                   */
/* Copyright (c) The University of Texas, 2005. All rights reserved. */
/* UNIVERSITY EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES CONCERNING  */
/* THIS SOFTWARE AND DOCUMENTATION, INCLUDING ANY WARRANTIES OF      */
/* MERCHANTABILITY, FITNESS FOR ANY PARTICULAR PURPOSE,              */
/* NON-INFRINGEMENT AND WARRANTIES OF PERFORMANCE, AND ANY WARRANTY  */
/* THAT MIGHT OTHERWISE ARISE FROM COURSE OF DEALING OR USAGE OF     */
/* TRADE. NO WARRANTY IS EITHER EXPRESS OR IMPLIED WITH RESPECT TO   */
/* THE USE OF THE SOFTWARE OR DOCUMENTATION.                         */
/* Under no circumstances shall University be liable for incidental, */
/* special, indirect, direct or consequential damages or loss of     */
/* profits, interruption of business, or related expenses which may  */
/* arise from use of Software or Documentation, including but not    */
/* limited to those resulting from defects in Software and/or        */
/* Documentation, or loss or inaccuracy of data of any kind.         */
/*********************************************************************/

#define ASSEMBLER
#include "common.h"

#define C	16(%rsp)
#define LDC	24(%rsp)

	PROLOGUE
	PROFCODE
	
	pxor	%xmm1, %xmm1
	movq	C,   %rdx
	movq	LDC, %rcx		# rcx

	test	%rdi, %rdi		# if m <= 0 goto End
	jle	.L999
	test	%rsi, %rsi		# if n <= 0 goto End
	jle	.L999

	ucomisd	%xmm1, %xmm0
	jne	.L201
	ALIGN_4

.L101:
	movq	 %rdx, %rax			# c_offset = c
	leaq	(%rdx, %rcx, SIZE), %rdx	# c += ldc
	movq	%rdi, %r8
	sarq	$3,   %r8
	jle	.L103
	ALIGN_4

.L102:
#ifdef OPTERON
	prefetchw	32 * SIZE(%rax)
#endif
	
	MOVSD	%xmm0, 0 * SIZE(%rax)
	MOVSD	%xmm0, 1 * SIZE(%rax)
	MOVSD	%xmm0, 2 * SIZE(%rax)
	MOVSD	%xmm0, 3 * SIZE(%rax)
	MOVSD	%xmm0, 4 * SIZE(%rax)
	MOVSD	%xmm0, 5 * SIZE(%rax)
	MOVSD	%xmm0, 6 * SIZE(%rax)
	MOVSD	%xmm0, 7 * SIZE(%rax)
	addq	$8 * SIZE, %rax
	decq	%r8
	jg	.L102
	ALIGN_4

.L103:
	movq	%rdi, %r8
	andq	$7,   %r8
	jle	.L105
	ALIGN_4

.L104:
	MOVSD	%xmm0, 0 * SIZE(%rax)
	addq	$SIZE, %rax
	decq	%r8
	jg	.L104
	ALIGN_4

.L105:
	decq	%rsi
	jg	.L101
	jmp	.L999
	ALIGN_3

.L201:
	movq	 %rdx, %rax			# c_offset = c
	leaq	(%rdx, %rcx, SIZE), %rdx	# c += ldc
	movq	%rdi, %r8
	sarq	$3,   %r8
	jle	.L203
	ALIGN_4

.L202:
#ifdef OPTERON
	prefetchw	32 * SIZE(%rax)
#endif

	MOVSD	0 * SIZE(%rax), %xmm8
	MOVSD	1 * SIZE(%rax), %xmm9
	MOVSD	2 * SIZE(%rax), %xmm10
	MOVSD	3 * SIZE(%rax), %xmm11
	MOVSD	4 * SIZE(%rax), %xmm12
	MOVSD	5 * SIZE(%rax), %xmm13
	MOVSD	6 * SIZE(%rax), %xmm14
	MOVSD	7 * SIZE(%rax), %xmm15

	MULSD	%xmm0, %xmm8
	MULSD	%xmm0, %xmm9
	MULSD	%xmm0, %xmm10
	MULSD	%xmm0, %xmm11
	MULSD	%xmm0, %xmm12
	MULSD	%xmm0, %xmm13
	MULSD	%xmm0, %xmm14
	MULSD	%xmm0, %xmm15

	MOVSD	%xmm8,  0 * SIZE(%rax)
	MOVSD	%xmm9,  1 * SIZE(%rax)
	MOVSD	%xmm10, 2 * SIZE(%rax)
	MOVSD	%xmm11, 3 * SIZE(%rax)
	MOVSD	%xmm12, 4 * SIZE(%rax)
	MOVSD	%xmm13, 5 * SIZE(%rax)
	MOVSD	%xmm14, 6 * SIZE(%rax)
	MOVSD	%xmm15, 7 * SIZE(%rax)

	addq	$8 * SIZE, %rax
	decq	%r8
	jg	.L202
	ALIGN_4

.L203:
	movq	%rdi, %r8
	andq	$7,   %r8
	jle	.L205
	ALIGN_4

.L204:
	MOVSD	0 * SIZE(%rax), %xmm8
	MULSD	%xmm0, %xmm8
	MOVSD	%xmm8,  0 * SIZE(%rax)
	addq	$SIZE, %rax
	decq	%r8
	jg	.L204
	ALIGN_4

.L205:
	decq	%rsi
	jg	.L201
	ALIGN_3

.L999:
	xorq	%rax,%rax
	ret

	EPILOGUE
