/*********************************************************************/
/*                                                                   */
/*             Optimized BLAS libraries                              */
/*                     By Kazushige Goto <kgoto@tacc.utexas.edu>     */
/*                                                                   */
/* Copyright (c) The University of Texas, 2005. All rights reserved. */
/* UNIVERSITY EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES CONCERNING  */
/* THIS SOFTWARE AND DOCUMENTATION, INCLUDING ANY WARRANTIES OF      */
/* MERCHANTABILITY, FITNESS FOR ANY PARTICULAR PURPOSE,              */
/* NON-INFRINGEMENT AND WARRANTIES OF PERFORMANCE, AND ANY WARRANTY  */
/* THAT MIGHT OTHERWISE ARISE FROM COURSE OF DEALING OR USAGE OF     */
/* TRADE. NO WARRANTY IS EITHER EXPRESS OR IMPLIED WITH RESPECT TO   */
/* THE USE OF THE SOFTWARE OR DOCUMENTATION.                         */
/* Under no circumstances shall University be liable for incidental, */
/* special, indirect, direct or consequential damages or loss of     */
/* profits, interruption of business, or related expenses which may  */
/* arise from use of Software or Documentation, including but not    */
/* limited to those resulting from defects in Software and/or        */
/* Documentation, or loss or inaccuracy of data of any kind.         */
/*********************************************************************/

#define ASSEMBLER
#include "common.h"

#define M	 %rdi
#define N	 %rsi
#define C	 %rdx
#define LDC	 %rcx

#define CO1	 %r8
#define I	 %r9

	PROLOGUE
	PROFCODE
	
	pxor	%xmm15, %xmm15
	movq	16(%rsp),  C
	movq	24(%rsp), LDC

	testq	M, M		# if n <= 0 goto End
	jle	.L999
	testq	N, N		# if m <= 0 goto End
	jle	.L999

	salq	$ZBASE_SHIFT, LDC
	ucomisd	%xmm15, %xmm0
	jne	.L71
	ucomisd	%xmm15, %xmm1
	jne	.L71
	ALIGN_2

.L53:
	movq	C, CO1		# c_offset1 = c_offset
	addq	LDC, C		# c_offset += ldc

	movq	M,  I
	sarq	$2, I
	jle	.L56
	ALIGN_2

.L57:
#ifdef OPTERON
	prefetchw	64 * SIZE(CO1)
#endif

	MOVSD	%xmm0, 0 * SIZE(CO1)		# c_offset1
	MOVSD	%xmm0, 1 * SIZE(CO1)
	MOVSD	%xmm0, 2 * SIZE(CO1)
	MOVSD	%xmm0, 3 * SIZE(CO1)
	MOVSD	%xmm0, 4 * SIZE(CO1)
	MOVSD	%xmm0, 5 * SIZE(CO1)
	MOVSD	%xmm0, 6 * SIZE(CO1)
	MOVSD	%xmm0, 7 * SIZE(CO1)
	addq	$8 * SIZE, CO1		# c_offset1 += 8
	decq	I			# i--
	jg	.L57
	ALIGN_2

.L56:
	movq	M,  I
	andq	$3, I
	jle	.L62
	ALIGN_2

.L63:
	MOVSD	%xmm0, 0 * SIZE(CO1)
	MOVSD	%xmm0, 1 * SIZE(CO1)
	addq	$2 * SIZE,CO1
	decq	I
	jg	.L63
	ALIGN_2

.L62:
	decq	N			# j --
	jg	.L53
	jmp	.L999
	ALIGN_3

.L71:
	movq	C, CO1
	addq	LDC, C		# c_offset += ldc

	movq	M,  I
	sarq	$1, I
	jle	.L84
	ALIGN_3

.L85:
#ifdef OPTERON
	prefetchw	16 * SIZE(CO1)
#endif

	MOVSD	0 * SIZE(CO1), %xmm2
	MOVSD	1 * SIZE(CO1), %xmm3
	MOVSD	0 * SIZE(CO1), %xmm4
	MOVSD	1 * SIZE(CO1), %xmm5

	MOVSD	2 * SIZE(CO1), %xmm6
	MOVSD	3 * SIZE(CO1), %xmm7
	MOVSD	2 * SIZE(CO1), %xmm8
	MOVSD	3 * SIZE(CO1), %xmm9

	MULSD	%xmm0, %xmm2
	MULSD	%xmm1, %xmm3
	MULSD	%xmm1, %xmm4
	MULSD	%xmm0, %xmm5

	MULSD	%xmm0, %xmm6
	MULSD	%xmm1, %xmm7
	MULSD	%xmm1, %xmm8
	MULSD	%xmm0, %xmm9

	SUBSD	%xmm3, %xmm2
	ADDPD	%xmm5, %xmm4
	SUBSD	%xmm7, %xmm6
	ADDPD	%xmm9, %xmm8

	MOVSD	%xmm2, 0 * SIZE(CO1)
	MOVSD	%xmm4, 1 * SIZE(CO1)
	MOVSD	%xmm6, 2 * SIZE(CO1)
	MOVSD	%xmm8, 3 * SIZE(CO1)
	addq	$4 * SIZE, CO1
	decq	I
	jg	.L85
	ALIGN_3

.L84:
	testq	$1, M
	jle	.L74
	ALIGN_3

.L75:
	prefetchnta	80 * SIZE(CO1)

	MOVSD	0 * SIZE(CO1), %xmm2
	MULSD	%xmm0, %xmm2
	MOVSD	1 * SIZE(CO1), %xmm3
	MULSD	%xmm1, %xmm3
	MOVSD	0 * SIZE(CO1), %xmm4
	MULSD	%xmm1, %xmm4
	MOVSD	1 * SIZE(CO1), %xmm5
	MULSD	%xmm0, %xmm5

	SUBSD	%xmm3, %xmm2
	ADDPD	%xmm5, %xmm4

	MOVSD	%xmm2, 0 * SIZE(CO1)
	MOVSD	%xmm4, 1 * SIZE(CO1)
	ALIGN_2

.L74:
	decq	N
	jg	.L71
	ALIGN_2

.L999:
	ret

	EPILOGUE
