/*********************************************************************/
/*                                                                   */
/*             Optimized BLAS libraries                              */
/*                     By Kazushige Goto <kgoto@tacc.utexas.edu>     */
/*                                                                   */
/* Copyright (c) The University of Texas, 2005. All rights reserved. */
/* UNIVERSITY EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES CONCERNING  */
/* THIS SOFTWARE AND DOCUMENTATION, INCLUDING ANY WARRANTIES OF      */
/* MERCHANTABILITY, FITNESS FOR ANY PARTICULAR PURPOSE,              */
/* NON-INFRINGEMENT AND WARRANTIES OF PERFORMANCE, AND ANY WARRANTY  */
/* THAT MIGHT OTHERWISE ARISE FROM COURSE OF DEALING OR USAGE OF     */
/* TRADE. NO WARRANTY IS EITHER EXPRESS OR IMPLIED WITH RESPECT TO   */
/* THE USE OF THE SOFTWARE OR DOCUMENTATION.                         */
/* Under no circumstances shall University be liable for incidental, */
/* special, indirect, direct or consequential damages or loss of     */
/* profits, interruption of business, or related expenses which may  */
/* arise from use of Software or Documentation, including but not    */
/* limited to those resulting from defects in Software and/or        */
/* Documentation, or loss or inaccuracy of data of any kind.         */
/*********************************************************************/

#include <stdio.h>
#include "common.h"

void CNAME(long m, long n, FLOAT *a, long lda, long posX, long posY, FLOAT *b){

  long i, js, ii;
  long X;

  FLOAT *a01, *a02, *a03 ,*a04, *a05, *a06, *a07, *a08;
  FLOAT *a09, *a10, *a11, *a12, *a13, *a14, *a15, *a16;

  js = (n >> 4);

  if (js > 0){
    do {
      X = posX;

      if (posX <= posY) {
	a01 = a + posY + (posX +  0) * lda;
	a02 = a + posY + (posX +  1) * lda;
	a03 = a + posY + (posX +  2) * lda;
	a04 = a + posY + (posX +  3) * lda;
	a05 = a + posY + (posX +  4) * lda;
	a06 = a + posY + (posX +  5) * lda;
	a07 = a + posY + (posX +  6) * lda;
	a08 = a + posY + (posX +  7) * lda;
	a09 = a + posY + (posX +  8) * lda;
	a10 = a + posY + (posX +  9) * lda;
	a11 = a + posY + (posX + 10) * lda;
	a12 = a + posY + (posX + 11) * lda;
	a13 = a + posY + (posX + 12) * lda;
	a14 = a + posY + (posX + 13) * lda;
	a15 = a + posY + (posX + 14) * lda;
	a16 = a + posY + (posX + 15) * lda;
      } else {
	a01 = a + posX + (posY +  0) * lda;
	a02 = a + posX + (posY +  1) * lda;
	a03 = a + posX + (posY +  2) * lda;
	a04 = a + posX + (posY +  3) * lda;
	a05 = a + posX + (posY +  4) * lda;
	a06 = a + posX + (posY +  5) * lda;
	a07 = a + posX + (posY +  6) * lda;
	a08 = a + posX + (posY +  7) * lda;
	a09 = a + posX + (posY +  8) * lda;
	a10 = a + posX + (posY +  9) * lda;
	a11 = a + posX + (posY + 10) * lda;
	a12 = a + posX + (posY + 11) * lda;
	a13 = a + posX + (posY + 12) * lda;
	a14 = a + posX + (posY + 13) * lda;
	a15 = a + posX + (posY + 14) * lda;
	a16 = a + posX + (posY + 15) * lda;
      }

      i = (m >> 4);
      if (i > 0) {
	do {
	  if (X > posY) {
	    
	    for (ii = 0; ii < 16; ii++){

	      b[  0] = *(a01 + 0);
	      b[  1] = *(a02 + 0);
	      b[  2] = *(a03 + 0);
	      b[  3] = *(a04 + 0);
	      b[  4] = *(a05 + 0);
	      b[  5] = *(a06 + 0);
	      b[  6] = *(a07 + 0);
	      b[  7] = *(a08 + 0);
	      
	      b[  8] = *(a09 + 0);
	      b[  9] = *(a10 + 0);
	      b[ 10] = *(a11 + 0);
	      b[ 11] = *(a12 + 0);
	      b[ 12] = *(a13 + 0);
	      b[ 13] = *(a14 + 0);
	      b[ 14] = *(a15 + 0);
	      b[ 15] = *(a16 + 0);
	    
	      a01 ++;
	      a02 ++;
	      a03 ++;
	      a04 ++;
	      a05 ++;
	      a06 ++;
	      a07 ++;
	      a08 ++;
	      a09 ++;
	      a10 ++;
	      a11 ++;
	      a12 ++;
	      a13 ++;
	      a14 ++;
	      a15 ++;
	      a16 ++;
	      b += 16;
	    }

	  } else 
	    if (X < posY) {

	      for (ii = 0; ii < 16; ii++){
		
		b[  0] = *(a01 +  0);
		b[  1] = *(a01 +  1);
		b[  2] = *(a01 +  2);
		b[  3] = *(a01 +  3);
		b[  4] = *(a01 +  4);
		b[  5] = *(a01 +  5);
		b[  6] = *(a01 +  6);
		b[  7] = *(a01 +  7);
		
		b[  8] = *(a01 +  8);
		b[  9] = *(a01 +  9);
		b[ 10] = *(a01 + 10);
		b[ 11] = *(a01 + 11);
		b[ 12] = *(a01 + 12);
		b[ 13] = *(a01 + 13);
		b[ 14] = *(a01 + 14);
		b[ 15] = *(a01 + 15);
		
		a01 += lda;
		b += 16;
	      }

	      a02 += 16 * lda;
	      a03 += 16 * lda;
	      a04 += 16 * lda;
	      a05 += 16 * lda;
	      a06 += 16 * lda;
	      a07 += 16 * lda;
	      a08 += 16 * lda;
	      a09 += 16 * lda;
	      a10 += 16 * lda;
	      a11 += 16 * lda;
	      a12 += 16 * lda;
	      a13 += 16 * lda;
	      a14 += 16 * lda;
	      a15 += 16 * lda;
	      a16 += 16 * lda;
		
	    } else {

	      b[  0] = *(a01 +  0);
	      b[  1] = *(a01 +  1);
	      b[  2] = *(a01 +  2);
	      b[  3] = *(a01 +  3);
	      b[  4] = *(a01 +  4);
	      b[  5] = *(a01 +  5);
	      b[  6] = *(a01 +  6);
	      b[  7] = *(a01 +  7);
	      
	      b[  8] = *(a01 +  8);
	      b[  9] = *(a01 +  9);
	      b[ 10] = *(a01 + 10);
	      b[ 11] = *(a01 + 11);
	      b[ 12] = *(a01 + 12);
	      b[ 13] = *(a01 + 13);
	      b[ 14] = *(a01 + 14);
	      b[ 15] = *(a01 + 15);
      
	      b[ 16] = *(a01 +  1);
	      b[ 17] = *(a02 +  1);
	      b[ 18] = *(a02 +  2);
	      b[ 19] = *(a02 +  3);
	      b[ 20] = *(a02 +  4);
	      b[ 21] = *(a02 +  5);
	      b[ 22] = *(a02 +  6);
	      b[ 23] = *(a02 +  7);
	      
	      b[ 24] = *(a02 +  8);
	      b[ 25] = *(a02 +  9);
	      b[ 26] = *(a02 + 10);
	      b[ 27] = *(a02 + 11);
	      b[ 28] = *(a02 + 12);
	      b[ 29] = *(a02 + 13);
	      b[ 30] = *(a02 + 14);
	      b[ 31] = *(a02 + 15);

	      b[ 32] = *(a01 +  2);
	      b[ 33] = *(a02 +  2);
	      b[ 34] = *(a03 +  2);
	      b[ 35] = *(a03 +  3);
	      b[ 36] = *(a03 +  4);
	      b[ 37] = *(a03 +  5);
	      b[ 38] = *(a03 +  6);
	      b[ 39] = *(a03 +  7);
	      
	      b[ 40] = *(a03 +  8);
	      b[ 41] = *(a03 +  9);
	      b[ 42] = *(a03 + 10);
	      b[ 43] = *(a03 + 11);
	      b[ 44] = *(a03 + 12);
	      b[ 45] = *(a03 + 13);
	      b[ 46] = *(a03 + 14);
	      b[ 47] = *(a03 + 15);

	      b[ 48] = *(a01 +  3);
	      b[ 49] = *(a02 +  3);
	      b[ 50] = *(a03 +  3);
	      b[ 51] = *(a04 +  3);
	      b[ 52] = *(a04 +  4);
	      b[ 53] = *(a04 +  5);
	      b[ 54] = *(a04 +  6);
	      b[ 55] = *(a04 +  7);
	      
	      b[ 56] = *(a04 +  8);
	      b[ 57] = *(a04 +  9);
	      b[ 58] = *(a04 + 10);
	      b[ 59] = *(a04 + 11);
	      b[ 60] = *(a04 + 12);
	      b[ 61] = *(a04 + 13);
	      b[ 62] = *(a04 + 14);
	      b[ 63] = *(a04 + 15);

	      b[ 64] = *(a01 +  4);
	      b[ 65] = *(a02 +  4);
	      b[ 66] = *(a03 +  4);
	      b[ 67] = *(a04 +  4);
	      b[ 68] = *(a05 +  4);
	      b[ 69] = *(a05 +  5);
	      b[ 70] = *(a05 +  6);
	      b[ 71] = *(a05 +  7);
	      
	      b[ 72] = *(a05 +  8);
	      b[ 73] = *(a05 +  9);
	      b[ 74] = *(a05 + 10);
	      b[ 75] = *(a05 + 11);
	      b[ 76] = *(a05 + 12);
	      b[ 77] = *(a05 + 13);
	      b[ 78] = *(a05 + 14);
	      b[ 79] = *(a05 + 15);

	      b[ 80] = *(a01 +  5);
	      b[ 81] = *(a02 +  5);
	      b[ 82] = *(a03 +  5);
	      b[ 83] = *(a04 +  5);
	      b[ 84] = *(a05 +  5);
	      b[ 85] = *(a06 +  5);
	      b[ 86] = *(a06 +  6);
	      b[ 87] = *(a06 +  7);
	      
	      b[ 88] = *(a06 +  8);
	      b[ 89] = *(a06 +  9);
	      b[ 90] = *(a06 + 10);
	      b[ 91] = *(a06 + 11);
	      b[ 92] = *(a06 + 12);
	      b[ 93] = *(a06 + 13);
	      b[ 94] = *(a06 + 14);
	      b[ 95] = *(a06 + 15);

	      b[ 96] = *(a01 +  6);
	      b[ 97] = *(a02 +  6);
	      b[ 98] = *(a03 +  6);
	      b[ 99] = *(a04 +  6);
	      b[100] = *(a05 +  6);
	      b[101] = *(a06 +  6);
	      b[102] = *(a07 +  6);
	      b[103] = *(a07 +  7);
	      
	      b[104] = *(a07 +  8);
	      b[105] = *(a07 +  9);
	      b[106] = *(a07 + 10);
	      b[107] = *(a07 + 11);
	      b[108] = *(a07 + 12);
	      b[109] = *(a07 + 13);
	      b[110] = *(a07 + 14);
	      b[111] = *(a07 + 15);

	      b[112] = *(a01 +  7);
	      b[113] = *(a02 +  7);
	      b[114] = *(a03 +  7);
	      b[115] = *(a04 +  7);
	      b[116] = *(a05 +  7);
	      b[117] = *(a06 +  7);
	      b[118] = *(a07 +  7);
	      b[119] = *(a08 +  7);
	      
	      b[120] = *(a08 +  8);
	      b[121] = *(a08 +  9);
	      b[122] = *(a08 + 10);
	      b[123] = *(a08 + 11);
	      b[124] = *(a08 + 12);
	      b[125] = *(a08 + 13);
	      b[126] = *(a08 + 14);
	      b[127] = *(a08 + 15);

	      b[128] = *(a01 +  8);
	      b[129] = *(a02 +  8);
	      b[130] = *(a03 +  8);
	      b[131] = *(a04 +  8);
	      b[132] = *(a05 +  8);
	      b[133] = *(a06 +  8);
	      b[134] = *(a07 +  8);
	      b[135] = *(a08 +  8);
	      
	      b[136] = *(a09 +  8);
	      b[137] = *(a09 +  9);
	      b[138] = *(a09 + 10);
	      b[139] = *(a09 + 11);
	      b[140] = *(a09 + 12);
	      b[141] = *(a09 + 13);
	      b[142] = *(a09 + 14);
	      b[143] = *(a09 + 15);

	      b[144] = *(a01 +  9);
	      b[145] = *(a02 +  9);
	      b[146] = *(a03 +  9);
	      b[147] = *(a04 +  9);
	      b[148] = *(a05 +  9);
	      b[149] = *(a06 +  9);
	      b[150] = *(a07 +  9);
	      b[151] = *(a08 +  9);
	      
	      b[152] = *(a09 +  9);
	      b[153] = *(a10 +  9);
	      b[154] = *(a10 + 10);
	      b[155] = *(a10 + 11);
	      b[156] = *(a10 + 12);
	      b[157] = *(a10 + 13);
	      b[158] = *(a10 + 14);
	      b[159] = *(a10 + 15);

	      b[160] = *(a01 + 10);
	      b[161] = *(a02 + 10);
	      b[162] = *(a03 + 10);
	      b[163] = *(a04 + 10);
	      b[164] = *(a05 + 10);
	      b[165] = *(a06 + 10);
	      b[166] = *(a07 + 10);
	      b[167] = *(a08 + 10);
	      
	      b[168] = *(a09 + 10);
	      b[169] = *(a10 + 10);
	      b[170] = *(a11 + 10);
	      b[171] = *(a11 + 11);
	      b[172] = *(a11 + 12);
	      b[173] = *(a11 + 13);
	      b[174] = *(a11 + 14);
	      b[175] = *(a11 + 15);

	      b[176] = *(a01 + 11);
	      b[177] = *(a02 + 11);
	      b[178] = *(a03 + 11);
	      b[179] = *(a04 + 11);
	      b[180] = *(a05 + 11);
	      b[181] = *(a06 + 11);
	      b[182] = *(a07 + 11);
	      b[183] = *(a08 + 11);
	      
	      b[184] = *(a09 + 11);
	      b[185] = *(a10 + 11);
	      b[186] = *(a11 + 11);
	      b[187] = *(a12 + 11);
	      b[188] = *(a12 + 12);
	      b[189] = *(a12 + 13);
	      b[190] = *(a12 + 14);
	      b[191] = *(a12 + 15);

	      b[192] = *(a01 + 12);
	      b[193] = *(a02 + 12);
	      b[194] = *(a03 + 12);
	      b[195] = *(a04 + 12);
	      b[196] = *(a05 + 12);
	      b[197] = *(a06 + 12);
	      b[198] = *(a07 + 12);
	      b[199] = *(a08 + 12);
	      
	      b[200] = *(a09 + 12);
	      b[201] = *(a10 + 12);
	      b[202] = *(a11 + 12);
	      b[203] = *(a12 + 12);
	      b[204] = *(a13 + 12);
	      b[205] = *(a13 + 13);
	      b[206] = *(a13 + 14);
	      b[207] = *(a13 + 15);

	      b[208] = *(a01 + 13);
	      b[209] = *(a02 + 13);
	      b[210] = *(a03 + 13);
	      b[211] = *(a04 + 13);
	      b[212] = *(a05 + 13);
	      b[213] = *(a06 + 13);
	      b[214] = *(a07 + 13);
	      b[215] = *(a08 + 13);
	      
	      b[216] = *(a09 + 13);
	      b[217] = *(a10 + 13);
	      b[218] = *(a11 + 13);
	      b[219] = *(a12 + 13);
	      b[220] = *(a13 + 13);
	      b[221] = *(a14 + 13);
	      b[222] = *(a14 + 14);
	      b[223] = *(a14 + 15);

	      b[224] = *(a01 + 14);
	      b[225] = *(a02 + 14);
	      b[226] = *(a03 + 14);
	      b[227] = *(a04 + 14);
	      b[228] = *(a05 + 14);
	      b[229] = *(a06 + 14);
	      b[230] = *(a07 + 14);
	      b[231] = *(a08 + 14);
	      
	      b[232] = *(a09 + 14);
	      b[233] = *(a10 + 14);
	      b[234] = *(a11 + 14);
	      b[235] = *(a12 + 14);
	      b[236] = *(a13 + 14);
	      b[237] = *(a14 + 14);
	      b[238] = *(a15 + 14);
	      b[239] = *(a15 + 15);

	      b[240] = *(a01 + 15);
	      b[241] = *(a02 + 15);
	      b[242] = *(a03 + 15);
	      b[243] = *(a04 + 15);
	      b[244] = *(a05 + 15);
	      b[245] = *(a06 + 15);
	      b[246] = *(a07 + 15);
	      b[247] = *(a08 + 15);
	      
	      b[248] = *(a09 + 15);
	      b[249] = *(a10 + 15);
	      b[250] = *(a11 + 15);
	      b[251] = *(a12 + 15);
	      b[252] = *(a13 + 15);
	      b[253] = *(a14 + 15);
	      b[254] = *(a15 + 15);
	      b[255] = *(a16 + 15);

	      a01 += 16;
	      a02 += 16;
	      a03 += 16;
	      a04 += 16;
	      a05 += 16;
	      a06 += 16;
	      a07 += 16;
	      a08 += 16;
	      a09 += 16;
	      a10 += 16;
	      a11 += 16;
	      a12 += 16;
	      a13 += 16;
	      a14 += 16;
	      a15 += 16;
	      a16 += 16;
	      
	      b += 256;
	    }

	  X += 16;
	  i --;
	} while (i > 0);
      }

      i = (m & 15);
      if (i > 0) {
	if (X > posY) {
	  
	  for (ii = 0; ii < i; ii++){
	    
	    b[  0] = *(a01 + 0);
	    b[  1] = *(a02 + 0);
	    b[  2] = *(a03 + 0);
	    b[  3] = *(a04 + 0);
	    b[  4] = *(a05 + 0);
	    b[  5] = *(a06 + 0);
	    b[  6] = *(a07 + 0);
	    b[  7] = *(a08 + 0);
	    
	    b[  8] = *(a09 + 0);
	    b[  9] = *(a10 + 0);
	    b[ 10] = *(a11 + 0);
	    b[ 11] = *(a12 + 0);
	    b[ 12] = *(a13 + 0);
	    b[ 13] = *(a14 + 0);
	    b[ 14] = *(a15 + 0);
	    b[ 15] = *(a16 + 0);
	    
	    a01 ++;
	    a02 ++;
	    a03 ++;
	    a04 ++;
	    a05 ++;
	    a06 ++;
	    a07 ++;
	    a08 ++;
	    a09 ++;
	    a10 ++;
	    a11 ++;
	    a12 ++;
	    a13 ++;
	    a14 ++;
	    a15 ++;
	    a16 ++;
	    b += 16;
	  }

	} else 
	  if (X < posY) {
	    
	    for (ii = 0; ii < i; ii++){
	      
	      b[  0] = *(a01 +  0);
	      b[  1] = *(a01 +  1);
	      b[  2] = *(a01 +  2);
	      b[  3] = *(a01 +  3);
	      b[  4] = *(a01 +  4);
	      b[  5] = *(a01 +  5);
	      b[  6] = *(a01 +  6);
	      b[  7] = *(a01 +  7);
	      
	      b[  8] = *(a01 +  8);
	      b[  9] = *(a01 +  9);
	      b[ 10] = *(a01 + 10);
	      b[ 11] = *(a01 + 11);
	      b[ 12] = *(a01 + 12);
	      b[ 13] = *(a01 + 13);
	      b[ 14] = *(a01 + 14);
	      b[ 15] = *(a01 + 15);
	      
	      a01 += lda;
	      a02 += lda;
	      a03 += lda;
	      a04 += lda;
	      a05 += lda;
	      a06 += lda;
	      a07 += lda;
	      a08 += lda;
	      a09 += lda;
	      a10 += lda;
	      a11 += lda;
	      a12 += lda;
	      a13 += lda;
	      a14 += lda;
	      a15 += lda;
	      a16 += lda;
	      b += 16;
	    }
	  } else {

	    b[ 0] = *(a01 +  0);
	    b[ 1] = *(a01 +  1);
	    b[ 2] = *(a01 +  2);
	    b[ 3] = *(a01 +  3);
	    b[ 4] = *(a01 +  4);
	    b[ 5] = *(a01 +  5);
	    b[ 6] = *(a01 +  6);
	    b[ 7] = *(a01 +  7);
	    
	    b[ 8] = *(a01 +  8);
	    b[ 9] = *(a01 +  9);
	    b[10] = *(a01 + 10);
	    b[11] = *(a01 + 11);
	    b[12] = *(a01 + 12);
	    b[13] = *(a01 + 13);
	    b[14] = *(a01 + 14);
	    b[15] = *(a01 + 15);
	    b += 16;
	    
	    if (i >= 2){
	      b[ 0] = *(a01 +  1);
	      b[ 1] = *(a02 +  1);
	      b[ 2] = *(a02 +  2);
	      b[ 3] = *(a02 +  3);
	      b[ 4] = *(a02 +  4);
	      b[ 5] = *(a02 +  5);
	      b[ 6] = *(a02 +  6);
	      b[ 7] = *(a02 +  7);
		
	      b[ 8] = *(a02 +  8);
	      b[ 9] = *(a02 +  9);
	      b[10] = *(a02 + 10);
	      b[11] = *(a02 + 11);
	      b[12] = *(a02 + 12);
	      b[13] = *(a02 + 13);
	      b[14] = *(a02 + 14);
	      b[15] = *(a02 + 15);
	      b += 16;
	    }
	    
	    if (i >= 3){
	      b[ 0] = *(a01 +  2);
	      b[ 1] = *(a02 +  2);
	      b[ 2] = *(a03 +  2);
	      b[ 3] = *(a03 +  3);
	      b[ 4] = *(a03 +  4);
	      b[ 5] = *(a03 +  5);
	      b[ 6] = *(a03 +  6);
	      b[ 7] = *(a03 +  7);
	      
	      b[ 8] = *(a03 +  8);
	      b[ 9] = *(a03 +  9);
	      b[10] = *(a03 + 10);
	      b[11] = *(a03 + 11);
	      b[12] = *(a03 + 12);
	      b[13] = *(a03 + 13);
	      b[14] = *(a03 + 14);
	      b[15] = *(a03 + 15);
	      b += 16;
	    }
	    
	    if (i >= 4){
	      b[ 0] = *(a01 +  3);
	      b[ 1] = *(a02 +  3);
	      b[ 2] = *(a03 +  3);
	      b[ 3] = *(a04 +  3);
	      b[ 4] = *(a04 +  4);
	      b[ 5] = *(a04 +  5);
	      b[ 6] = *(a04 +  6);
	      b[ 7] = *(a04 +  7);
	      
	      b[ 8] = *(a04 +  8);
	      b[ 9] = *(a04 +  9);
	      b[10] = *(a04 + 10);
	      b[11] = *(a04 + 11);
	      b[12] = *(a04 + 12);
	      b[13] = *(a04 + 13);
	      b[14] = *(a04 + 14);
	      b[15] = *(a04 + 15);
	      b += 16;
	    }
	      
	    if (i >= 5){
	      b[ 0] = *(a01 +  4);
	      b[ 1] = *(a02 +  4);
	      b[ 2] = *(a03 +  4);
	      b[ 3] = *(a04 +  4);
	      b[ 4] = *(a05 +  4);
	      b[ 5] = *(a05 +  5);
	      b[ 6] = *(a05 +  6);
	      b[ 7] = *(a05 +  7);
	      
	      b[ 8] = *(a05 +  8);
	      b[ 9] = *(a05 +  9);
	      b[10] = *(a05 + 10);
	      b[11] = *(a05 + 11);
	      b[12] = *(a05 + 12);
	      b[13] = *(a05 + 13);
	      b[14] = *(a05 + 14);
	      b[15] = *(a05 + 15);
	      b += 16;
	    }
	      
	    if (i >= 6){
	      b[ 0] = *(a01 +  5);
	      b[ 1] = *(a02 +  5);
	      b[ 2] = *(a03 +  5);
	      b[ 3] = *(a04 +  5);
	      b[ 4] = *(a05 +  5);
	      b[ 5] = *(a06 +  5);
	      b[ 6] = *(a06 +  6);
	      b[ 7] = *(a06 +  7);
	      
	      b[ 8] = *(a06 +  8);
	      b[ 9] = *(a06 +  9);
	      b[10] = *(a06 + 10);
	      b[11] = *(a06 + 11);
	      b[12] = *(a06 + 12);
	      b[13] = *(a06 + 13);
	      b[14] = *(a06 + 14);
	      b[15] = *(a06 + 15);
	      b += 16;
	    }
	      
	    if (i >= 7){
	      b[ 0] = *(a01 +  6);
	      b[ 1] = *(a02 +  6);
	      b[ 2] = *(a03 +  6);
	      b[ 3] = *(a04 +  6);
	      b[ 4] = *(a05 +  6);
	      b[ 5] = *(a06 +  6);
	      b[ 6] = *(a07 +  6);
	      b[ 7] = *(a07 +  7);
	      
	      b[ 8] = *(a07 +  8);
	      b[ 9] = *(a07 +  9);
	      b[10] = *(a07 + 10);
	      b[11] = *(a07 + 11);
	      b[12] = *(a07 + 12);
	      b[13] = *(a07 + 13);
	      b[14] = *(a07 + 14);
	      b[15] = *(a07 + 15);
	      b += 16;
	      }
	      
	    if (i >= 8){
	      b[ 0] = *(a01 +  7);
	      b[ 1] = *(a02 +  7);
	      b[ 2] = *(a03 +  7);
	      b[ 3] = *(a04 +  7);
	      b[ 4] = *(a05 +  7);
	      b[ 5] = *(a06 +  7);
	      b[ 6] = *(a07 +  7);
	      b[ 7] = *(a08 +  7);
	      
	      b[ 8] = *(a08 +  8);
	      b[ 9] = *(a08 +  9);
	      b[10] = *(a08 + 10);
	      b[11] = *(a08 + 11);
	      b[12] = *(a08 + 12);
	      b[13] = *(a08 + 13);
	      b[14] = *(a08 + 14);
	      b[15] = *(a08 + 15);
	      b += 16;
	    }
	    
	    if (i >= 9){
	      b[ 0] = *(a01 +  8);
	      b[ 1] = *(a02 +  8);
	      b[ 2] = *(a03 +  8);
	      b[ 3] = *(a04 +  8);
	      b[ 4] = *(a05 +  8);
	      b[ 5] = *(a06 +  8);
	      b[ 6] = *(a07 +  8);
	      b[ 7] = *(a08 +  8);
	      
	      b[ 8] = *(a09 +  8);
	      b[ 9] = *(a09 +  9);
	      b[10] = *(a09 + 10);
	      b[11] = *(a09 + 11);
	      b[12] = *(a09 + 12);
	      b[13] = *(a09 + 13);
	      b[14] = *(a09 + 14);
	      b[15] = *(a09 + 15);
	      b += 16;
	    }
	    
	    if (i >= 10){
	      b[ 0] = *(a01 +  9);
	      b[ 1] = *(a02 +  9);
	      b[ 2] = *(a03 +  9);
	      b[ 3] = *(a04 +  9);
	      b[ 4] = *(a05 +  9);
	      b[ 5] = *(a06 +  9);
	      b[ 6] = *(a07 +  9);
	      b[ 7] = *(a08 +  9);
	      
	      b[ 8] = *(a09 +  9);
	      b[ 9] = *(a10 +  9);
	      b[10] = *(a10 + 10);
	      b[11] = *(a10 + 11);
	      b[12] = *(a10 + 12);
	      b[13] = *(a10 + 13);
	      b[14] = *(a10 + 14);
	      b[15] = *(a10 + 15);
	      b += 16;
	    }
	    
	    if (i >= 11){
	      b[ 0] = *(a01 + 10);
	      b[ 1] = *(a02 + 10);
	      b[ 2] = *(a03 + 10);
	      b[ 3] = *(a04 + 10);
	      b[ 4] = *(a05 + 10);
	      b[ 5] = *(a06 + 10);
	      b[ 6] = *(a07 + 10);
	      b[ 7] = *(a08 + 10);
	      
	      b[ 8] = *(a09 + 10);
	      b[ 9] = *(a10 + 10);
	      b[10] = *(a11 + 10);
	      b[11] = *(a11 + 11);
	      b[12] = *(a11 + 12);
	      b[13] = *(a11 + 13);
	      b[14] = *(a11 + 14);
	      b[15] = *(a11 + 15);
	      b += 16;
	    }
	      
	    if (i >= 12){
	      b[ 0] = *(a01 + 11);
	      b[ 1] = *(a02 + 11);
	      b[ 2] = *(a03 + 11);
	      b[ 3] = *(a04 + 11);
	      b[ 4] = *(a05 + 11);
	      b[ 5] = *(a06 + 11);
	      b[ 6] = *(a07 + 11);
	      b[ 7] = *(a08 + 11);
	      
	      b[ 8] = *(a09 + 11);
	      b[ 9] = *(a10 + 11);
	      b[10] = *(a11 + 11);
	      b[11] = *(a12 + 11);
	      b[12] = *(a12 + 12);
	      b[13] = *(a12 + 13);
	      b[14] = *(a12 + 14);
	      b[15] = *(a12 + 15);
	      b += 16;
	    }
	      
	    if (i >= 13){
	      b[ 0] = *(a01 + 12);
	      b[ 1] = *(a02 + 12);
	      b[ 2] = *(a03 + 12);
	      b[ 3] = *(a04 + 12);
	      b[ 4] = *(a05 + 12);
	      b[ 5] = *(a06 + 12);
	      b[ 6] = *(a07 + 12);
	      b[ 7] = *(a08 + 12);
		
	      b[ 8] = *(a09 + 12);
	      b[ 9] = *(a10 + 12);
	      b[10] = *(a11 + 12);
	      b[11] = *(a12 + 12);
	      b[12] = *(a13 + 12);
	      b[13] = *(a13 + 13);
	      b[14] = *(a13 + 14);
	      b[15] = *(a13 + 15);
	      b += 16;
	    }
	    
	    if (i >= 14){
	      b[ 0] = *(a01 + 13);
	      b[ 1] = *(a02 + 13);
	      b[ 2] = *(a03 + 13);
	      b[ 3] = *(a04 + 13);
	      b[ 4] = *(a05 + 13);
	      b[ 5] = *(a06 + 13);
	      b[ 6] = *(a07 + 13);
	      b[ 7] = *(a08 + 13);
	      
	      b[ 8] = *(a09 + 13);
	      b[ 9] = *(a10 + 13);
	      b[10] = *(a11 + 13);
	      b[11] = *(a12 + 13);
	      b[12] = *(a13 + 13);
	      b[13] = *(a14 + 13);
	      b[14] = *(a14 + 14);
	      b[15] = *(a14 + 15);
	      b += 16;
	    }
	      
	    if (i >= 15){
	      b[ 0] = *(a01 + 14);
	      b[ 1] = *(a02 + 14);
	      b[ 2] = *(a03 + 14);
	      b[ 3] = *(a04 + 14);
	      b[ 4] = *(a05 + 14);
	      b[ 5] = *(a06 + 14);
	      b[ 6] = *(a07 + 14);
	      b[ 7] = *(a08 + 14);
	      
	      b[ 8] = *(a09 + 14);
	      b[ 9] = *(a10 + 14);
	      b[10] = *(a11 + 14);
	      b[11] = *(a12 + 14);
	      b[12] = *(a13 + 14);
	      b[13] = *(a14 + 14);
	      b[14] = *(a15 + 14);
	      b[15] = *(a15 + 15);
	      b += 16;
	    }
	  }
      }

      posY += 16;
      js --;
    } while (js > 0);
  } /* End of main loop */


  if (n & 8){
    X = posX;

    if (posX <= posY) {
      a01 = a + posY + (posX +  0) * lda;
      a02 = a + posY + (posX +  1) * lda;
      a03 = a + posY + (posX +  2) * lda;
      a04 = a + posY + (posX +  3) * lda;
      a05 = a + posY + (posX +  4) * lda;
      a06 = a + posY + (posX +  5) * lda;
      a07 = a + posY + (posX +  6) * lda;
      a08 = a + posY + (posX +  7) * lda;
    } else {
      a01 = a + posX + (posY +  0) * lda;
      a02 = a + posX + (posY +  1) * lda;
      a03 = a + posX + (posY +  2) * lda;
      a04 = a + posX + (posY +  3) * lda;
      a05 = a + posX + (posY +  4) * lda;
      a06 = a + posX + (posY +  5) * lda;
      a07 = a + posX + (posY +  6) * lda;
      a08 = a + posX + (posY +  7) * lda;
    }
    
    i = (m >> 3);
    if (i > 0) {
      do {
	if (X > posY) {
	  
	  for (ii = 0; ii < 8; ii++){

	    b[  0] = *(a01 + 0);
	    b[  1] = *(a02 + 0);
	    b[  2] = *(a03 + 0);
	    b[  3] = *(a04 + 0);
	    b[  4] = *(a05 + 0);
	    b[  5] = *(a06 + 0);
	    b[  6] = *(a07 + 0);
	    b[  7] = *(a08 + 0);
	      
	    a01 ++;
	    a02 ++;
	    a03 ++;
	    a04 ++;
	    a05 ++;
	    a06 ++;
	    a07 ++;
	    a08 ++;
	    b += 8;
	  }
	} else 
	  if (X < posY) {
	    
	    for (ii = 0; ii < 8; ii++){
	      b[  0] = *(a01 +  0);
	      b[  1] = *(a01 +  1);
	      b[  2] = *(a01 +  2);
	      b[  3] = *(a01 +  3);
	      b[  4] = *(a01 +  4);
	      b[  5] = *(a01 +  5);
	      b[  6] = *(a01 +  6);
	      b[  7] = *(a01 +  7);
	      a01 += lda;
	      b += 8;
	    }

	    a02 += 8 * lda;
	    a03 += 8 * lda;
	    a04 += 8 * lda;
	    a05 += 8 * lda;
	    a06 += 8 * lda;
	    a07 += 8 * lda;
	    a08 += 8 * lda;
	  } else {

	      b[ 0] = *(a01 +  0);
	      b[ 1] = *(a01 +  1);
	      b[ 2] = *(a01 +  2);
	      b[ 3] = *(a01 +  3);
	      b[ 4] = *(a01 +  4);
	      b[ 5] = *(a01 +  5);
	      b[ 6] = *(a01 +  6);
	      b[ 7] = *(a01 +  7);
	      
	      b[ 8] = *(a01 +  1);
	      b[ 9] = *(a02 +  1);
	      b[10] = *(a02 +  2);
	      b[11] = *(a02 +  3);
	      b[12] = *(a02 +  4);
	      b[13] = *(a02 +  5);
	      b[14] = *(a02 +  6);
	      b[15] = *(a02 +  7);
	      
	      b[16] = *(a01 +  2);
	      b[17] = *(a02 +  2);
	      b[18] = *(a03 +  2);
	      b[19] = *(a03 +  3);
	      b[20] = *(a03 +  4);
	      b[21] = *(a03 +  5);
	      b[22] = *(a03 +  6);
	      b[23] = *(a03 +  7);
	      
	      b[24] = *(a01 +  3);
	      b[25] = *(a02 +  3);
	      b[26] = *(a03 +  3);
	      b[27] = *(a04 +  3);
	      b[28] = *(a04 +  4);
	      b[29] = *(a04 +  5);
	      b[30] = *(a04 +  6);
	      b[31] = *(a04 +  7);
	      
	      b[32] = *(a01 +  4);
	      b[33] = *(a02 +  4);
	      b[34] = *(a03 +  4);
	      b[35] = *(a04 +  4);
	      b[36] = *(a05 +  4);
	      b[37] = *(a05 +  5);
	      b[38] = *(a05 +  6);
	      b[39] = *(a05 +  7);
	      
	      b[40] = *(a01 +  5);
	      b[41] = *(a02 +  5);
	      b[42] = *(a03 +  5);
	      b[43] = *(a04 +  5);
	      b[44] = *(a05 +  5);
	      b[45] = *(a06 +  5);
	      b[46] = *(a06 +  6);
	      b[47] = *(a06 +  7);
	      
	      b[48] = *(a01 +  6);
	      b[49] = *(a02 +  6);
	      b[50] = *(a03 +  6);
	      b[51] = *(a04 +  6);
	      b[52] = *(a05 +  6);
	      b[53] = *(a06 +  6);
	      b[54] = *(a07 +  6);
	      b[55] = *(a07 +  7);
	      
	      b[56] = *(a01 +  7);
	      b[57] = *(a02 +  7);
	      b[58] = *(a03 +  7);
	      b[59] = *(a04 +  7);
	      b[60] = *(a05 +  7);
	      b[61] = *(a06 +  7);
	      b[62] = *(a07 +  7);
	      b[63] = *(a08 +  7);
	      
	      a01 += 8;
	      a02 += 8;
	      a03 += 8;
	      a04 += 8;
	      a05 += 8;
	      a06 += 8;
	      a07 += 8;
	      a08 += 8;
	      b += 64;
	    }

	  X += 8;
	  i --;
	} while (i > 0);
      }

    i = (m & 7);
    if (i > 0) {
      if (X > posY) {
	
	for (ii = 0; ii < i; ii++){
	  
	  b[  0] = *(a01 + 0);
	  b[  1] = *(a02 + 0);
	  b[  2] = *(a03 + 0);
	  b[  3] = *(a04 + 0);
	  b[  4] = *(a05 + 0);
	  b[  5] = *(a06 + 0);
	  b[  6] = *(a07 + 0);
	  b[  7] = *(a08 + 0);
	  
	  a01 ++;
	  a02 ++;
	  a03 ++;
	  a04 ++;
	  a05 ++;
	  a06 ++;
	  a07 ++;
	  a08 ++;
	  b += 8;
	}
	
      } else 
	if (X < posY) {
	  
	  for (ii = 0; ii < i; ii++){
	    
	    b[  0] = *(a01 +  0);
	    b[  1] = *(a01 +  1);
	    b[  2] = *(a01 +  2);
	    b[  3] = *(a01 +  3);
	    b[  4] = *(a01 +  4);
	    b[  5] = *(a01 +  5);
	    b[  6] = *(a01 +  6);
	    b[  7] = *(a01 +  7);
	    
	    a01 += lda;
	    a02 += lda;
	    a03 += lda;
	    a04 += lda;
	    a05 += lda;
	    a06 += lda;
	    a07 += lda;
	    a08 += lda;
	    b += 8;
	  }
	} else {
	  
	  b[ 0] = *(a01 +  0);
	  b[ 1] = *(a01 +  1);
	  b[ 2] = *(a01 +  2);
	  b[ 3] = *(a01 +  3);
	  b[ 4] = *(a01 +  4);
	  b[ 5] = *(a01 +  5);
	  b[ 6] = *(a01 +  6);
	  b[ 7] = *(a01 +  7);
	  b += 8;
	    
	  if (i >= 2){
	    b[ 0] = *(a01 +  1);
	    b[ 1] = *(a02 +  1);
	    b[ 2] = *(a02 +  2);
	    b[ 3] = *(a02 +  3);
	    b[ 4] = *(a02 +  4);
	    b[ 5] = *(a02 +  5);
	    b[ 6] = *(a02 +  6);
	    b[ 7] = *(a02 +  7);
	    b += 8;
	  }
	    
	  if (i >= 3){
	    b[ 0] = *(a01 +  2);
	    b[ 1] = *(a02 +  2);
	    b[ 2] = *(a03 +  2);
	    b[ 3] = *(a03 +  3);
	    b[ 4] = *(a03 +  4);
	    b[ 5] = *(a03 +  5);
	    b[ 6] = *(a03 +  6);
	    b[ 7] = *(a03 +  7);
	    b += 8;
	  }
	    
	  if (i >= 4){
	    b[ 0] = *(a01 +  3);
	    b[ 1] = *(a02 +  3);
	    b[ 2] = *(a03 +  3);
	    b[ 3] = *(a04 +  3);
	    b[ 4] = *(a04 +  4);
	    b[ 5] = *(a04 +  5);
	    b[ 6] = *(a04 +  6);
	    b[ 7] = *(a04 +  7);
	    b += 8;
	  }
	      
	  if (i >= 5){
	    b[ 0] = *(a01 +  4);
	    b[ 1] = *(a02 +  4);
	    b[ 2] = *(a03 +  4);
	    b[ 3] = *(a04 +  4);
	    b[ 4] = *(a05 +  4);
	    b[ 5] = *(a05 +  5);
	    b[ 6] = *(a05 +  6);
	    b[ 7] = *(a05 +  7);
	    b += 8;
	  }
	      
	  if (i >= 6){
	    b[ 0] = *(a01 +  5);
	    b[ 1] = *(a02 +  5);
	    b[ 2] = *(a03 +  5);
	    b[ 3] = *(a04 +  5);
	    b[ 4] = *(a05 +  5);
	    b[ 5] = *(a06 +  5);
	    b[ 6] = *(a06 +  6);
	    b[ 7] = *(a06 +  7);
	    b += 8;
	  }
	      
	  if (i >= 7){
	    b[ 0] = *(a01 +  6);
	    b[ 1] = *(a02 +  6);
	    b[ 2] = *(a03 +  6);
	    b[ 3] = *(a04 +  6);
	    b[ 4] = *(a05 +  6);
	    b[ 5] = *(a06 +  6);
	    b[ 6] = *(a07 +  6);
	    b[ 7] = *(a07 +  7);
	    b += 8;
	  }
	}
    }
    posY += 8;
  }

  if (n & 4){
    X = posX;

    if (posX <= posY) {
      a01 = a + posY + (posX +  0) * lda;
      a02 = a + posY + (posX +  1) * lda;
      a03 = a + posY + (posX +  2) * lda;
      a04 = a + posY + (posX +  3) * lda;
    } else {
      a01 = a + posX + (posY +  0) * lda;
      a02 = a + posX + (posY +  1) * lda;
      a03 = a + posX + (posY +  2) * lda;
      a04 = a + posX + (posY +  3) * lda;
    }
    
    i = (m >> 2);
    if (i > 0) {
      do {
	if (X > posY) {
	  
	  for (ii = 0; ii < 4; ii++){

	    b[  0] = *(a01 + 0);
	    b[  1] = *(a02 + 0);
	    b[  2] = *(a03 + 0);
	    b[  3] = *(a04 + 0);
	    a01 ++;
	    a02 ++;
	    a03 ++;
	    a04 ++;
	    b += 4;
	  }
	} else 
	  if (X < posY) {
	    
	    for (ii = 0; ii < 4; ii++){
	      b[  0] = *(a01 +  0);
	      b[  1] = *(a01 +  1);
	      b[  2] = *(a01 +  2);
	      b[  3] = *(a01 +  3);
	      a01 += lda;
	      b += 4;
	    }

	    a02 += 4 * lda;
	    a03 += 4 * lda;
	    a04 += 4 * lda;
	  } else {

	    b[ 0] = *(a01 +  0);
	    b[ 1] = *(a01 +  1);
	    b[ 2] = *(a01 +  2);
	    b[ 3] = *(a01 +  3);
	    
	    b[ 4] = *(a01 +  1);
	    b[ 5] = *(a02 +  1);
	    b[ 6] = *(a02 +  2);
	    b[ 7] = *(a02 +  3);
	    
	    b[ 8] = *(a01 +  2);
	    b[ 9] = *(a02 +  2);
	    b[10] = *(a03 +  2);
	    b[11] = *(a03 +  3);
	    
	    b[12] = *(a01 +  3);
	    b[13] = *(a02 +  3);
	    b[14] = *(a03 +  3);
	    b[15] = *(a04 +  3);
	    
	    a01 += 4;
	    a02 += 4;
	    a03 += 4;
	    a04 += 4;
	    b += 16;
	  }
	
	X += 4;
	i --;
      } while (i > 0);
    }
    
    i = (m & 3);
    if (i > 0) {
      if (X > posY) {
	
	for (ii = 0; ii < i; ii++){
	  
	  b[  0] = *(a01 + 0);
	  b[  1] = *(a02 + 0);
	  b[  2] = *(a03 + 0);
	  b[  3] = *(a04 + 0);
	  
	  a01 ++;
	  a02 ++;
	  a03 ++;
	  a04 ++;
	  b += 4;
	}
	
      } else 
	if (X < posY) {
	  
	  for (ii = 0; ii < i; ii++){
	    
	    b[  0] = *(a01 +  0);
	    b[  1] = *(a01 +  1);
	    b[  2] = *(a01 +  2);
	    b[  3] = *(a01 +  3);

	    a01 += lda;
	    a02 += lda;
	    a03 += lda;
	    a04 += lda;
	    b += 4;
	  }
	} else {
	  
	  b[ 0] = *(a01 +  0);
	  b[ 1] = *(a01 +  1);
	  b[ 2] = *(a01 +  2);
	  b[ 3] = *(a01 +  3);
	  b += 4;
	    
	  if (i >= 2){
	    b[ 0] = *(a01 +  1);
	    b[ 1] = *(a02 +  1);
	    b[ 2] = *(a02 +  2);
	    b[ 3] = *(a02 +  3);
	    b += 4;
	  }
	    
	  if (i >= 3){
	    b[ 0] = *(a01 +  2);
	    b[ 1] = *(a02 +  2);
	    b[ 2] = *(a03 +  2);
	    b[ 3] = *(a03 +  3);
	    b += 4;
	  }
	}
    }
    posY += 4;
  }

  if (n & 2){
    X = posX;

    if (posX <= posY) {
      a01 = a + posY + (posX +  0) * lda;
      a02 = a + posY + (posX +  1) * lda;
    } else {
      a01 = a + posX + (posY +  0) * lda;
      a02 = a + posX + (posY +  1) * lda;
    }
    
    i = (m >> 1);
    if (i > 0) {
      do {
	if (X > posY) {
	  b[  0] = *(a01 + 0);
	  b[  1] = *(a02 + 0);
	  b[  2] = *(a01 + 1);
	  b[  3] = *(a02 + 1);
	  a01 += 2;
	  a02 += 2;
	  b += 4;
	} else 
	  if (X < posY) {
	    b[  0] = *(a01 +  0);
	    b[  1] = *(a01 +  1);
	    b[  2] = *(a02 +  0);
	    b[  3] = *(a02 +  1);
	    a01 += 2 * lda;
	    a02 += 2 * lda;
	    b += 4;
	  } else {
	    b[ 0] = *(a01 +  0);
	    b[ 1] = *(a01 +  1);
	    b[ 2] = *(a01 +  1);
	    b[ 3] = *(a02 +  1);
	    a01 += 2;
	    a02 += 2;
	    b += 4;
	  }
	
	X += 2;
	i --;
      } while (i > 0);
    }
    
    if (m & 1) {
      if (X > posY) {

	b[  0] = *(a01 + 0);
	b[  1] = *(a02 + 0);

	a01 ++;
	a02 ++;
	b += 2;
      } else 
	if (X < posY) {
	  b[  0] = *(a01 +  0);
	  b[  1] = *(a01 +  1);
	  a01 += lda;
	  a02 += lda;
	  b += 2;
	  }
    } else {
      
      b[ 0] = *(a01 +  0);
      b[ 1] = *(a01 +  1);
      b += 2;
    }
    posY += 2;
  }

  if (n & 1){
    X = posX;

    if (posX <= posY) {
      a01 = a + posY + (posX +  0) * lda;
    } else {
      a01 = a + posX + (posY +  0) * lda;
    }
    
    i = m;
    if (i > 0) {
      do {
	b[  0] = *(a01 + 0);
	b ++;
	  
	if (X >= posY) {
	  a01 ++;
	} else 
	  if (X < posY) {
	    a01 += lda;
	  }
	X += 1;
	i --;
      } while (i > 0);
    }
    posY += 1;
  }
}


