#define ASSEMBLER
#include "common.h"

#if !defined(HAVE_SSE) || !defined(HAVE_MMX)
#error  You have to check your configuration.
#endif

#define STACK	16
#define ARGS	 0
	
#define STACK_M	 4 + STACK + ARGS(%esi)
#define STACK_N	 8 + STACK + ARGS(%esi)
#define STACK_K	12 + STACK + ARGS(%esi)
#define STACK_ALPHA	16 + STACK + ARGS(%esi)
#define STACK_A	20 + STACK + ARGS(%esi)
#define STACK_B	24 + STACK + ARGS(%esi)
#define STACK_C	28 + STACK + ARGS(%esi)
#define STACK_LDC	32 + STACK + ARGS(%esi)
#define STACK_OFFT	36 + STACK + ARGS(%esi)

#define ALPHA	 0(%esp)
#define K	16(%esp)
#define N	20(%esp)
#define M	24(%esp)
#define A	28(%esp)
#define C	32(%esp)
#define J	36(%esp)
#define OLD_STACK 40(%esp)
#define OFFSET  44(%esp)
#define KK	48(%esp)
#define KKK	52(%esp)
#define AORIG	56(%esp)
#define BORIG	60(%esp)
#define SSEONE	64(%esp)
#define MASK1	80(%esp)
#define MASK2	96(%esp)
#define MASK3  112(%esp)
#define BUFFER 128(%esp)

#define B	%edi
#define LDC	%ebp

#define STACK_ALIGN	4096
#define STACK_OFFSET	1024

#define PREFETCHSIZE 48   /* for PIII */

#define LOCAL_BUFFER_SIZE  GEMM_Q * GEMM_UNROLL_N * COMPSIZE * 16

#define AA	%edx
#define BB	%ecx

#ifdef HAVE_SSE2
#define MOVSD	movsd
#define XORPS	pxor
#else
#define MOVSD	movlps
#define XORPS	xorps
#endif

#define KERNELMACRO(address) \
	mulps	%xmm0, %xmm2; \
	mulps	 4 * SIZE + (address) * SIZE * 2(BB), %xmm0; \
	addps	%xmm2, %xmm4; \
	movaps	 0 * SIZE + (address) * SIZE * 2(BB), %xmm2; \
	addps	%xmm0, %xmm5; \
	movaps	 4 * SIZE + (address) * SIZE * 2(AA), %xmm0; \
	mulps	%xmm0, %xmm2; \
	mulps	 4 * SIZE + (address) * SIZE * 2(BB), %xmm0; \
	addps	%xmm2, %xmm6; \
	movaps	 8 * SIZE + (address) * SIZE * 2(BB), %xmm2; \
	addps	%xmm0, %xmm7; \
	movaps	 8 * SIZE + (address) * SIZE * 2(AA), %xmm0; \
	mulps	%xmm0, %xmm2; \
	mulps	12 * SIZE + (address) * SIZE * 2(BB), %xmm0; \
	addps	%xmm2, %xmm4; \
	movaps	 8 * SIZE + (address) * SIZE * 2(BB), %xmm2; \
	addps	%xmm0, %xmm5; \
	movaps	12 * SIZE + (address) * SIZE * 2(AA), %xmm0; \
	mulps	%xmm0, %xmm2; \
	mulps	12 * SIZE + (address) * SIZE * 2(BB), %xmm0; \
	addps	%xmm2, %xmm6; \
	movaps	32 * SIZE + (address) * SIZE * 2(BB), %xmm2; \
	addps	%xmm0, %xmm7; \
	movaps	32 * SIZE + (address) * SIZE * 2(AA), %xmm0; \
	mulps	%xmm1, %xmm3; \
	mulps	20 * SIZE + (address) * SIZE * 2(BB), %xmm1; \
	addps	%xmm3, %xmm4; \
	movaps	16 * SIZE + (address) * SIZE * 2(BB), %xmm3; \
	addps	%xmm1, %xmm5; \
	movaps	20 * SIZE + (address) * SIZE * 2(AA), %xmm1; \
	mulps	%xmm1, %xmm3; \
	mulps	20 * SIZE + (address) * SIZE * 2(BB), %xmm1; \
	addps	%xmm3, %xmm6; \
	movaps	24 * SIZE + (address) * SIZE * 2(BB), %xmm3; \
	addps	%xmm1, %xmm7; \
	movaps	24 * SIZE + (address) * SIZE * 2(AA), %xmm1; \
	mulps	%xmm1, %xmm3; \
	mulps	28 * SIZE + (address) * SIZE * 2(BB), %xmm1; \
	addps	%xmm3, %xmm4; \
	movaps	24 * SIZE + (address) * SIZE * 2(BB), %xmm3; \
	addps	%xmm1, %xmm5; \
	movaps	28 * SIZE + (address) * SIZE * 2(AA), %xmm1; \
	mulps	%xmm1, %xmm3; \
	mulps	28 * SIZE + (address) * SIZE * 2(BB), %xmm1; \
	addps	%xmm3, %xmm6; \
	movaps	48 * SIZE + (address) * SIZE * 2(BB), %xmm3; \
	addps	%xmm1, %xmm7; \
	movaps	48 * SIZE + (address) * SIZE * 2(AA), %xmm1; \
	mulps	%xmm0, %xmm2; \
	mulps	36 * SIZE + (address) * SIZE * 2(BB), %xmm0; \
	addps	%xmm2, %xmm4; \
	movaps	32 * SIZE + (address) * SIZE * 2(BB), %xmm2; \
	addps	%xmm0, %xmm5; \
	movaps	36 * SIZE + (address) * SIZE * 2(AA), %xmm0; \
	mulps	%xmm0, %xmm2; \
	mulps	36 * SIZE + (address) * SIZE * 2(BB), %xmm0; \
	addps	%xmm2, %xmm6; \
	movaps	40 * SIZE + (address) * SIZE * 2(BB), %xmm2; \
	addps	%xmm0, %xmm7; \
	movaps	40 * SIZE + (address) * SIZE * 2(AA), %xmm0; \
	mulps	%xmm0, %xmm2; \
	mulps	44 * SIZE + (address) * SIZE * 2(BB), %xmm0; \
	addps	%xmm2, %xmm4; \
	movaps	40 * SIZE + (address) * SIZE * 2(BB), %xmm2; \
	addps	%xmm0, %xmm5; \
	movaps	44 * SIZE + (address) * SIZE * 2(AA), %xmm0; \
	mulps	%xmm0, %xmm2; \
	mulps	44 * SIZE + (address) * SIZE * 2(BB), %xmm0; \
	addps	%xmm2, %xmm6; \
	movaps	64 * SIZE + (address) * SIZE * 2(BB), %xmm2; \
	addps	%xmm0, %xmm7; \
	movaps	64 * SIZE + (address) * SIZE * 2(AA), %xmm0; \
	mulps	%xmm1, %xmm3; \
	mulps	52 * SIZE + (address) * SIZE * 2(BB), %xmm1; \
	addps	%xmm3, %xmm4; \
	movaps	48 * SIZE + (address) * SIZE * 2(BB), %xmm3; \
	addps	%xmm1, %xmm5; \
	movaps	52 * SIZE + (address) * SIZE * 2(AA), %xmm1; \
	mulps	%xmm1, %xmm3; \
	mulps	52 * SIZE + (address) * SIZE * 2(BB), %xmm1; \
	addps	%xmm3, %xmm6; \
	movaps	56 * SIZE + (address) * SIZE * 2(BB), %xmm3; \
	addps	%xmm1, %xmm7; \
	movaps	56 * SIZE + (address) * SIZE * 2(AA), %xmm1; \
	mulps	%xmm1, %xmm3; \
	mulps	60 * SIZE + (address) * SIZE * 2(BB), %xmm1; \
	addps	%xmm3, %xmm4; \
	movaps	56 * SIZE + (address) * SIZE * 2(BB), %xmm3; \
	addps	%xmm1, %xmm5; \
	movaps	60 * SIZE + (address) * SIZE * 2(AA), %xmm1; \
	mulps	%xmm1, %xmm3; \
	mulps	60 * SIZE + (address) * SIZE * 2(BB), %xmm1; \
	addps	%xmm3, %xmm6; \
	movaps	80 * SIZE + (address) * SIZE * 2(BB), %xmm3; \
	addps	%xmm1, %xmm7; \
	movaps	80 * SIZE + (address) * SIZE * 2(AA), %xmm1

	PROLOGUE

	pushl	%ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx

	PROFCODE

	EMMS

	movl	%esp, %esi	# save old stack

	subl	$128 + LOCAL_BUFFER_SIZE + STACK_OFFSET, %esp
	andl	$-STACK_ALIGN, %esp
	addl	$STACK_OFFSET, %esp

	movd	STACK_M, %mm0
	movl	STACK_N, %eax
	movd	STACK_K, %mm1
	movd	STACK_A, %mm2
	movl	STACK_B, B
	movd	STACK_C, %mm3
	movl	STACK_LDC, LDC
	movd	STACK_OFFT, %mm4

	movd	%mm1, K
	movl	%eax, N
	movd	%mm0, M
	movd	%mm2, A
	movd	%mm3, C
	movl	%esi, OLD_STACK

	movd	%mm4, OFFSET
	movd	%mm4, KK

	leal	(, LDC, SIZE), LDC

	movl	$0x3f800000, 0 + SSEONE
	movl	$0x3f800000, 4 + SSEONE
	movl	$0x3f800000, 8 + SSEONE
	movl	$0x3f800000,12 + SSEONE

	movl	$0x00000000, 0 + MASK1
	movl	$0xffffffff, 4 + MASK1
	movl	$0xffffffff, 8 + MASK1
	movl	$0xffffffff,12 + MASK1

#ifdef LN
       movl	M, %eax
       leal	(, %eax, SIZE), %eax
       addl	%eax, C
       imull	K, %eax
       addl	%eax, A
#endif

#ifdef RT
       movl	N, %eax
       leal	(, %eax, SIZE), %eax
       imull	K, %eax
       addl	%eax, B
       movl	N, %eax
       imull	LDC, %eax
       addl	%eax, C
#endif

#ifdef RN
	negl	KK
#endif	

#ifdef RT
       movl	N, %eax
       subl	OFFSET, %eax
       movl	%eax, KK
#else
	movl	N, %eax
#endif
	sarl	$1, %eax	# j = (n >> 1)
	movl	%eax, J
	jle	.L100
	ALIGN_2
	
.L01:
/* Copying to Sub Buffer */
#ifdef LN
	movl	OFFSET, %eax
	addl	M, %eax
	movl	%eax, KK
#endif	

	leal	BUFFER, BB

#ifdef RT
       movl	K, %eax
       sall	$1 + BASE_SHIFT, %eax
       subl	%eax, B
#endif

#if defined(LN) || defined(RT)
	movl	KK, %eax
	movl	B, BORIG
	leal	(, %eax, SIZE), %eax
	leal	(B,  %eax, 2), B
	leal	(BB, %eax, 8), BB
#endif	

#ifdef LT
	movl	OFFSET, %eax
	movl	%eax, KK
#endif

#if defined(LT) || defined(RN)
	movl	KK, %eax
#else
	movl	K, %eax
	subl	KK, %eax
#endif
	sarl	$2, %eax
	jle	.L03
	ALIGN_4
	
.L02:
	movss	0 * SIZE(B), %xmm0
	movss	1 * SIZE(B), %xmm1
	movss	2 * SIZE(B), %xmm2
	movss	3 * SIZE(B), %xmm3
	movss	4 * SIZE(B), %xmm4
	movss	5 * SIZE(B), %xmm5
	movss	6 * SIZE(B), %xmm6
	movss	7 * SIZE(B), %xmm7

	shufps	$0, %xmm0, %xmm0
	shufps	$0, %xmm1, %xmm1
	shufps	$0, %xmm2, %xmm2
	shufps	$0, %xmm3, %xmm3
	shufps	$0, %xmm4, %xmm4
	shufps	$0, %xmm5, %xmm5
	shufps	$0, %xmm6, %xmm6
	shufps	$0, %xmm7, %xmm7

	movaps	%xmm0,  0 * SIZE(%ecx)
	movaps	%xmm1,  4 * SIZE(%ecx)
	movaps	%xmm2,  8 * SIZE(%ecx)
	movaps	%xmm3, 12 * SIZE(%ecx)
	movaps	%xmm4, 16 * SIZE(%ecx)
	movaps	%xmm5, 20 * SIZE(%ecx)
	movaps	%xmm6, 24 * SIZE(%ecx)
	movaps	%xmm7, 28 * SIZE(%ecx)

	prefetcht0     104 * SIZE(B)
	
	addl	$ 8 * SIZE, B
	addl	$32 * SIZE, %ecx
	decl	%eax
	BRANCH
	jne	.L02
	ALIGN_2

.L03:
#if defined(LT) || defined(RN)
	movl	KK, %eax
#else
	movl	K, %eax
	subl	KK, %eax
#endif
	andl	$3, %eax
	BRANCH
	jle	.L05
	ALIGN_2

.L04:
	movss	0 * SIZE(B), %xmm0
	movss	1 * SIZE(B), %xmm1
	addl	$2 * SIZE, B

	shufps	$0, %xmm0, %xmm0
	shufps	$0, %xmm1, %xmm1

	movaps	%xmm0,  0 * SIZE(%ecx)
	movaps	%xmm1,  4 * SIZE(%ecx)
	addl	$8 * SIZE, %ecx
	decl	%eax
	jne	.L04
	ALIGN_4

.L05:
#if defined(LT) || defined(RN)
	movl	A, AA
#else
	movl	A, %eax
	movl	%eax, AORIG
#endif

#ifdef RT
       leal	(, LDC, 2), %eax
       subl	%eax, C
#endif
	movl	C, %esi		# coffset = c

#ifndef RT
	leal	(%esi, LDC, 2), %eax
	movl	%eax, C
#endif

	movl	M,  %ebx
	sarl	$3, %ebx	# i = (m >> 2)
	jle	.L30
	ALIGN_4

.L10:
#ifdef LN
       movl	K, %eax
       sall	$3 + BASE_SHIFT, %eax
       subl	%eax, AORIG
#endif

#if defined(LN) || defined(RT)
	movl	KK, %eax
	movl	AORIG, AA
	leal	(, %eax, SIZE), %eax
	leal	(AA, %eax, 8), AA
#endif

#ifdef PENTIUM4
	leal	BUFFER, BB

#if defined(LN) || defined(RT)
	movl	KK, %eax
	sall	$1 + BASE_SHIFT, %eax
	leal	(BB, %eax, 4), BB
#endif	

	movaps	 0 * SIZE(BB), %xmm2
	XORPS	%xmm4, %xmm4
	movaps	 0 * SIZE(AA), %xmm0
	XORPS	%xmm5, %xmm5
	movaps	 16 * SIZE(BB), %xmm3
	XORPS	%xmm6, %xmm6
	movaps	 16 * SIZE(AA), %xmm1
	XORPS	%xmm7, %xmm7

#if 0
	prefetchnta   8 * SIZE(%esi)
	prefetchnta   8 * SIZE(%esi, %ebp)
#endif

#if defined(LT) || defined(RN)
	movl	KK, %eax
#else
	movl	K, %eax
	subl	KK, %eax
#endif
	andl	$-8, %eax
	leal	(, %eax, 8), %eax
	je	.L12
	
	KERNELMACRO(32 *  0)		# 0
	cmpl	$64 *  1, %eax
	jle	.L11
	KERNELMACRO(32 *  1)		# 1
	cmpl	$64 *  2, %eax
	jle	.L11
	KERNELMACRO(32 *  2)		# 2
	cmpl	$64 *  3, %eax
	jle	.L11
	KERNELMACRO(32 *  3)		# 3
	cmpl	$64 *  4, %eax
	jle	.L11
	KERNELMACRO(32 *  4)		# 4
	cmpl	$64 *  5, %eax
	jle	.L11
	KERNELMACRO(32 *  5)		# 5
	cmpl	$64 *  6, %eax
	jle	.L11
	KERNELMACRO(32 *  6)		# 6
	cmpl	$64 *  7, %eax
	jle	.L11
	KERNELMACRO(32 *  7)		# 7
	cmpl	$64 *  8, %eax
	jle	.L11
	KERNELMACRO(32 *  8)		# 8
	cmpl	$64 *  9, %eax
	jle	.L11
	KERNELMACRO(32 *  9)		# 9
	cmpl	$64 * 10, %eax
	jle	.L11
	KERNELMACRO(32 * 10)		# 10
	cmpl	$64 * 11, %eax
	jle	.L11
	KERNELMACRO(32 * 11)		# 11
	cmpl	$64 * 12, %eax
	jle	.L11
	KERNELMACRO(32 * 12)		# 12
	cmpl	$64 * 13, %eax
	jle	.L11
	KERNELMACRO(32 * 13)		# 13
	cmpl	$64 * 14, %eax
	jle	.L11
	movd 7 * SIZE(%esi), %mm0
	KERNELMACRO(32 * 14)		# 14
	cmpl	$64 * 15, %eax
	jle	.L11
	movd 7 * SIZE(%esi, LDC), %mm1
	KERNELMACRO(32 * 15)		# 15
.L11:
	leal	(AA, %eax, 4), AA
	leal	(BB, %eax, 4), BB

#else

	leal	BUFFER, BB

#if defined(LN) || defined(RT)
	movl	KK, %eax
	sall	$1 + BASE_SHIFT, %eax
	leal	(BB, %eax, 4), BB
#endif	

	movaps	 0 * SIZE(BB), %xmm2
	XORPS	%xmm4, %xmm4
	movaps	 0 * SIZE(AA), %xmm0
	XORPS	%xmm5, %xmm5
	movaps	 8 * SIZE(BB), %xmm3
	XORPS	%xmm6, %xmm6
	movaps	 8 * SIZE(AA), %xmm1
	XORPS	%xmm7, %xmm7

	prefetchnta   8 * SIZE(%esi)
	prefetchnta   8 * SIZE(%esi, %ebp)

#if defined(LT) || defined(RN)
	movl	KK, %eax
#else
	movl	K, %eax
	subl	KK, %eax
#endif
	sarl	$3, %eax
	je	.L12
	ALIGN_2

.L11:
#if (L2_SIZE == 524288)
	prefetcht0	PREFETCHSIZE * SIZE(AA)
#endif

	mulps	%xmm0, %xmm2
	mulps	 4 * SIZE(BB), %xmm0
	addps	%xmm2, %xmm4
	movaps	 0 * SIZE(BB), %xmm2

	addps	%xmm0, %xmm5
	movaps	 4 * SIZE(AA), %xmm0
	mulps	%xmm0, %xmm2
	mulps	 4 * SIZE(BB), %xmm0

	addps	%xmm2, %xmm6
	movaps	16 * SIZE(BB), %xmm2
	addps	%xmm0, %xmm7
	movaps	16 * SIZE(AA), %xmm0

#if (L2_SIZE == 524288)
	prefetcht0	(PREFETCHSIZE + 8) * SIZE(AA)
#endif

	mulps	%xmm1, %xmm3
	mulps	12 * SIZE(BB), %xmm1
	addps	%xmm3, %xmm4
	movaps	 8 * SIZE(BB), %xmm3

	addps	%xmm1, %xmm5
	movaps	12 * SIZE(AA), %xmm1
	mulps	%xmm1, %xmm3
	mulps	12 * SIZE(BB), %xmm1

	addps	%xmm3, %xmm6
	movaps	24 * SIZE(BB), %xmm3
	addps	%xmm1, %xmm7
	movaps	24 * SIZE(AA), %xmm1

#if (L2_SIZE == 524288)
	prefetcht0	(PREFETCHSIZE + 16) * SIZE(AA)
#endif

	mulps	%xmm0, %xmm2
	mulps	20 * SIZE(BB), %xmm0
	addps	%xmm2, %xmm4
	movaps	16 * SIZE(BB), %xmm2

	addps	%xmm0, %xmm5
	movaps	20 * SIZE(AA), %xmm0
	mulps	%xmm0, %xmm2
	mulps	20 * SIZE(BB), %xmm0

	addps	%xmm2, %xmm6
	movaps	32 * SIZE(BB), %xmm2
	addps	%xmm0, %xmm7
	movaps	32 * SIZE(AA), %xmm0

#if (L2_SIZE == 524288)
	prefetcht0	(PREFETCHSIZE + 24) * SIZE(AA)
#endif

	mulps	%xmm1, %xmm3
	mulps	28 * SIZE(BB), %xmm1
	addps	%xmm3, %xmm4
	movaps	24 * SIZE(BB), %xmm3

	addps	%xmm1, %xmm5
	movaps	28 * SIZE(AA), %xmm1
	mulps	%xmm1, %xmm3
	mulps	28 * SIZE(BB), %xmm1

	addps	%xmm3, %xmm6
	movaps	40 * SIZE(BB), %xmm3
	addps	%xmm1, %xmm7
	movaps	40 * SIZE(AA), %xmm1

#if (L2_SIZE == 524288)
	prefetcht0	(PREFETCHSIZE + 32) * SIZE(AA)
#endif

	mulps	%xmm0, %xmm2
	mulps	36 * SIZE(BB), %xmm0
	addps	%xmm2, %xmm4
	movaps	32 * SIZE(BB), %xmm2

	addps	%xmm0, %xmm5
	movaps	36 * SIZE(AA), %xmm0
	mulps	%xmm0, %xmm2
	mulps	36 * SIZE(BB), %xmm0

	addps	%xmm2, %xmm6
	movaps	48 * SIZE(BB), %xmm2
	addps	%xmm0, %xmm7
	movaps	48 * SIZE(AA), %xmm0

#if (L2_SIZE == 524288)
	prefetcht0	(PREFETCHSIZE + 40) * SIZE(AA)
#endif

	mulps	%xmm1, %xmm3
	mulps	44 * SIZE(BB), %xmm1
	addps	%xmm3, %xmm4
	movaps	40 * SIZE(BB), %xmm3

	addps	%xmm1, %xmm5
	movaps	44 * SIZE(AA), %xmm1
	mulps	%xmm1, %xmm3
	mulps	44 * SIZE(BB), %xmm1

	addps	%xmm3, %xmm6
	movaps	56 * SIZE(BB), %xmm3
	addps	%xmm1, %xmm7
	movaps	56 * SIZE(AA), %xmm1

#if (L2_SIZE == 524288)
	prefetcht0	(PREFETCHSIZE + 48) * SIZE(AA)
#endif

	mulps	%xmm0, %xmm2
	mulps	52 * SIZE(BB), %xmm0
	addps	%xmm2, %xmm4
	movaps	48 * SIZE(BB), %xmm2

	addps	%xmm0, %xmm5
	movaps	52 * SIZE(AA), %xmm0
	mulps	%xmm0, %xmm2
	mulps	52 * SIZE(BB), %xmm0

	addps	%xmm2, %xmm6
	movaps	64 * SIZE(BB), %xmm2
	addps	%xmm0, %xmm7
	movaps	64 * SIZE(AA), %xmm0

#if (L2_SIZE == 524288)
	prefetcht0	(PREFETCHSIZE + 56) * SIZE(AA)
#endif

	mulps	%xmm1, %xmm3
	mulps	60 * SIZE(BB), %xmm1
	addps	%xmm3, %xmm4
	movaps	56 * SIZE(BB), %xmm3

	addps	%xmm1, %xmm5
	movaps	60 * SIZE(AA), %xmm1
	mulps	%xmm1, %xmm3
	mulps	60 * SIZE(BB), %xmm1

	addps	%xmm3, %xmm6
	movaps	72 * SIZE(BB), %xmm3
	addps	%xmm1, %xmm7
	movaps	72 * SIZE(AA), %xmm1

	addl   $64 * SIZE, BB
	addl   $64 * SIZE, AA
	decl   %eax
	jne    .L11
	ALIGN_2
#endif

.L12:
#if defined(LT) || defined(RN)
	movl	KK, %eax
#else
	movl	K, %eax
	subl	KK, %eax
#endif
	andl	$7, %eax		# if (k & 1)
	BRANCH
	je .L14

.L13:
	movaps	 4 * SIZE(BB), %xmm1
	mulps	%xmm0, %xmm2
	addps	%xmm2, %xmm4
	movaps	 0 * SIZE(BB), %xmm2
	mulps	%xmm0, %xmm1
	movaps	 4 * SIZE(AA), %xmm0
	addps	%xmm1, %xmm5
	movaps	 4 * SIZE(BB), %xmm1
	mulps	%xmm0, %xmm2
	addps	%xmm2, %xmm6
	movaps	 8 * SIZE(BB), %xmm2
	mulps	%xmm0, %xmm1
	movaps	 8 * SIZE(AA), %xmm0
	addps	%xmm1, %xmm7

	addl	$8 * SIZE, AA
	addl	$8 * SIZE, BB
	subl	$1, %eax
	jg	.L13
	ALIGN_4

.L14:
#if defined(LN) || defined(RT)
	movl	KK, %eax
#ifdef LN
	subl	$8, %eax
#else
	subl	$2, %eax
#endif

	movl	AORIG, AA
	movl	BORIG, B
	leal	BUFFER, BB

	leal	(, %eax, SIZE), %eax
	leal	(AA, %eax, 8), AA
	leal	(B,  %eax, 2), B
	leal	(BB, %eax, 8), BB
#endif

#if defined(LN) || defined(LT)
	movaps	 %xmm4, %xmm0
	movaps	 %xmm6, %xmm1

	unpcklps %xmm5, %xmm4
	unpcklps %xmm7, %xmm6

	unpckhps %xmm5, %xmm0
	unpckhps %xmm7, %xmm1

	movlps	 0 * SIZE(B), %xmm2
	movhps	 2 * SIZE(B), %xmm2
	movlps	 4 * SIZE(B), %xmm3
	movhps	 6 * SIZE(B), %xmm3
	movlps	 8 * SIZE(B), %xmm5
	movhps	10 * SIZE(B), %xmm5
	movlps	12 * SIZE(B), %xmm7
	movhps	14 * SIZE(B), %xmm7

	subps	%xmm4,  %xmm2
	subps	%xmm0,  %xmm3
	subps	%xmm6,  %xmm5
	subps	%xmm1,  %xmm7
#else
	movaps	 0 * SIZE(AA), %xmm0
	movaps	 4 * SIZE(AA), %xmm1
	movaps	 8 * SIZE(AA), %xmm2
	movaps	12 * SIZE(AA), %xmm3

	subps	%xmm4, %xmm0
	subps	%xmm6, %xmm1
	subps	%xmm5, %xmm2
	subps	%xmm7, %xmm3
#endif

#ifdef LN
	movss	63 * SIZE(AA), %xmm0
	shufps	$0x0e, %xmm0, %xmm0
	movlps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm7

	movss	62 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	xorps	 %xmm4,  %xmm4
	movhlps	 %xmm7,  %xmm4
	mulps	 %xmm4,  %xmm0
	subps	 %xmm0,  %xmm7

	movaps	 %xmm7,  %xmm1	
	movhlps  %xmm1,  %xmm1

	movlps	 60 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm5

	movlps	 58 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm3

	movlps	 56 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm2

	movss	54 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm7

	movaps	 %xmm7,  %xmm1	
	movlhps  %xmm1,  %xmm1

	movlps	 52 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm5

	movlps	 50 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm3

	movlps	 48 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm2



	movss	45 * SIZE(AA), %xmm0
	shufps	$0x0e, %xmm0, %xmm0
	movlps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm5

	movss	44 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	xorps	 %xmm4,  %xmm4
	movhlps	 %xmm5,  %xmm4
	mulps	 %xmm4,  %xmm0
	subps	 %xmm0,  %xmm5

	movaps	 %xmm5,  %xmm1	
	movhlps  %xmm1,  %xmm1

	movlps	 42 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm3

	movlps	 40 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm2


	movss	36 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm5

	movaps	 %xmm5,  %xmm1	
	movlhps  %xmm1,  %xmm1

	movlps	 34 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm3

	movlps	 32 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm2


	movss	27 * SIZE(AA), %xmm0
	shufps	$0x0e, %xmm0, %xmm0
	movlps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm3

	movss	26 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	xorps	 %xmm4,  %xmm4
	movhlps	 %xmm3,  %xmm4
	mulps	 %xmm4,  %xmm0
	subps	 %xmm0,  %xmm3

	movaps	 %xmm3,  %xmm1	
	movhlps  %xmm1,  %xmm1

	movlps	24 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm2


	movss	18 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm3

	movaps	 %xmm3,  %xmm1	
	movlhps  %xmm1,  %xmm1

	movlps	 16 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm2


	movss	 9 * SIZE(AA), %xmm0
	shufps	$0x0e, %xmm0, %xmm0
	movlps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm2

	movss	 8 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	xorps	 %xmm4,  %xmm4
	movhlps	 %xmm2,  %xmm4
	mulps	 %xmm4,  %xmm0
	subps	 %xmm0,  %xmm2

	movss	 0 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm2
#endif

#ifdef LT
	movss	 0 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm2

	movss	 1 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm2, %xmm0
	shufps	 $0x4e, %xmm0, %xmm0
	subps	 %xmm0, %xmm2

	movaps	 %xmm2,  %xmm1	
	movlhps %xmm1,  %xmm1

	movlps	 2 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm3

	movlps	 4 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm5

	movlps	 6 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm7

	movss	 9 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	shufps	 $0x4e, %xmm0, %xmm0
	mulps	 %xmm0,  %xmm2

	movaps	 %xmm2,  %xmm1	
	movhlps %xmm1,  %xmm1

	movlps	10 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm3

	movlps	12 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm5

	movlps	14 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm7

	movss	18 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm3

	movss	19 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm3, %xmm0
	shufps	 $0x4e, %xmm0, %xmm0
	subps	 %xmm0, %xmm3

	movaps	 %xmm3,  %xmm1	
	movlhps %xmm1,  %xmm1

	movlps	20 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm5

	movlps	22 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm7

	movss	 27 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	shufps	 $0x4e, %xmm0, %xmm0
	mulps	 %xmm0,  %xmm3

	movaps	 %xmm3,  %xmm1	
	movhlps  %xmm1,  %xmm1

	movlps	28 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm5

	movlps	30 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm7

	movss	36 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm5

	movss	37 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm5, %xmm0
	shufps	 $0x4e, %xmm0, %xmm0
	subps	 %xmm0, %xmm5

	movaps	 %xmm5,  %xmm1	
	movlhps %xmm1,  %xmm1

	movlps	38 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm7

	movss	 45 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	shufps	 $0x4e, %xmm0, %xmm0
	mulps	 %xmm0,  %xmm5

	movaps	 %xmm5,  %xmm1	
	movhlps %xmm1,  %xmm1

	movlps	46 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm7

	movss	54 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm7

	movss	55 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm7, %xmm0
	shufps	 $0x4e, %xmm0, %xmm0
	subps	 %xmm0, %xmm7

	movss	 63 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	shufps	 $0x4e, %xmm0, %xmm0
	mulps	 %xmm0,  %xmm7

#endif

#ifdef RN
	movss	 0 * SIZE(B),  %xmm4
	shufps	 $0x00, %xmm4, %xmm4
	mulps	 %xmm4, %xmm0
	mulps	 %xmm4, %xmm1

	movss	 1 * SIZE(B),  %xmm4
	shufps	 $0x00, %xmm4, %xmm4
	mulps	 %xmm0, %xmm4
	subps	 %xmm4, %xmm2

	movss	 1 * SIZE(B),  %xmm4
	shufps	 $0x00, %xmm4, %xmm4
	mulps	 %xmm1, %xmm4
	subps	 %xmm4, %xmm3

	movss	 3 * SIZE(B),  %xmm4
	shufps	 $0x00, %xmm4, %xmm4
	mulps	 %xmm4, %xmm2
	mulps	 %xmm4, %xmm3
#endif

#ifdef RT
	movss	 3 * SIZE(B),  %xmm4
	shufps	 $0x00, %xmm4, %xmm4
	mulps	 %xmm4, %xmm2
	mulps	 %xmm4, %xmm3

	movss	 2 * SIZE(B),  %xmm4
	shufps	 $0x00, %xmm4, %xmm4
	mulps	 %xmm2, %xmm4
	subps	 %xmm4, %xmm0

	movss	 2 * SIZE(B),  %xmm4
	shufps	 $0x00, %xmm4, %xmm4
	mulps	 %xmm3, %xmm4
	subps	 %xmm4, %xmm1

	movss	 0 * SIZE(B),  %xmm4
	shufps	 $0x00, %xmm4, %xmm4
	mulps	 %xmm4, %xmm0
	mulps	 %xmm4, %xmm1
#endif

#if defined(LN) || defined(LT)
	movlps	%xmm2,   0 * SIZE(B)
	movhps	%xmm2,   2 * SIZE(B)
	movlps	%xmm3,   4 * SIZE(B)
	movhps	%xmm3,   6 * SIZE(B)
	movlps	%xmm5,   8 * SIZE(B)
	movhps	%xmm5,  10 * SIZE(B)
	movlps	%xmm7,  12 * SIZE(B)
	movhps	%xmm7,  14 * SIZE(B)

	movaps	%xmm2, %xmm0
	shufps	$0x00, %xmm0, %xmm0
	movaps	%xmm0,   0 * SIZE(BB)
	movaps	%xmm2, %xmm0
	shufps	$0x55, %xmm0, %xmm0
	movaps	%xmm0,   4 * SIZE(BB)
	movaps	%xmm2, %xmm0
	shufps	$0xaa, %xmm0, %xmm0
	movaps	%xmm0,   8 * SIZE(BB)
	movaps	%xmm2, %xmm0
	shufps	$0xff, %xmm0, %xmm0
	movaps	%xmm0,  12 * SIZE(BB)
	movaps	%xmm3, %xmm0
	shufps	$0x00, %xmm0, %xmm0
	movaps	%xmm0,  16 * SIZE(BB)
	movaps	%xmm3, %xmm0
	shufps	$0x55, %xmm0, %xmm0
	movaps	%xmm0,  20 * SIZE(BB)
	movaps	%xmm3, %xmm0
	shufps	$0xaa, %xmm0, %xmm0
	movaps	%xmm0,  24 * SIZE(BB)
	movaps	%xmm3, %xmm0
	shufps	$0xff, %xmm0, %xmm0
	movaps	%xmm0,  28 * SIZE(BB)
	movaps	%xmm5, %xmm0
	shufps	$0x00, %xmm0, %xmm0
	movaps	%xmm0,  32 * SIZE(BB)
	movaps	%xmm5, %xmm0
	shufps	$0x55, %xmm0, %xmm0
	movaps	%xmm0,  36 * SIZE(BB)
	movaps	%xmm5, %xmm0
	shufps	$0xaa, %xmm0, %xmm0
	movaps	%xmm0,  40 * SIZE(BB)
	movaps	%xmm5, %xmm0
	shufps	$0xff, %xmm0, %xmm0
	movaps	%xmm0,  44 * SIZE(BB)
	movaps	%xmm7, %xmm0
	shufps	$0x00, %xmm0, %xmm0
	movaps	%xmm0,  48 * SIZE(BB)
	movaps	%xmm7, %xmm0
	shufps	$0x55, %xmm0, %xmm0
	movaps	%xmm0,  52 * SIZE(BB)
	movaps	%xmm7, %xmm0
	shufps	$0xaa, %xmm0, %xmm0
	movaps	%xmm0,  56 * SIZE(BB)
	movaps	%xmm7, %xmm0
	shufps	$0xff, %xmm0, %xmm0
	movaps	%xmm0,  60 * SIZE(BB)

#else
	movaps	%xmm0,   0 * SIZE(AA)
	movaps	%xmm1,   4 * SIZE(AA)
	movaps	%xmm2,   8 * SIZE(AA)
	movaps	%xmm3,  12 * SIZE(AA)
#endif

#ifdef LN
	subl	$8 * SIZE, %esi
#endif

#if defined(LN) || defined(LT)
	movaps	%xmm2, %xmm0
	shufps	$0x88, %xmm3, %xmm2
	shufps	$0xdd, %xmm3, %xmm0

	movaps	%xmm5, %xmm1
	shufps	$0x88, %xmm7, %xmm5
	shufps	$0xdd, %xmm7, %xmm1

	movlps	%xmm2,  0 * SIZE(%esi)
	movhps	%xmm2,  2 * SIZE(%esi)
	movlps	%xmm5,  4 * SIZE(%esi)
	movhps	%xmm5,  6 * SIZE(%esi)

	movlps	%xmm0,  0 * SIZE(%esi, LDC)
	movhps	%xmm0,  2 * SIZE(%esi, LDC)
	movlps	%xmm1,  4 * SIZE(%esi, LDC)
	movhps	%xmm1,  6 * SIZE(%esi, LDC)
#else
	movlps	%xmm0,  0 * SIZE(%esi)
	movhps	%xmm0,  2 * SIZE(%esi)
	movlps	%xmm1,  4 * SIZE(%esi)
	movhps	%xmm1,  6 * SIZE(%esi)

	movlps	%xmm2,  0 * SIZE(%esi, LDC)
	movhps	%xmm2,  2 * SIZE(%esi, LDC)
	movlps	%xmm3,  4 * SIZE(%esi, LDC)
	movhps	%xmm3,  6 * SIZE(%esi, LDC)
#endif

#ifndef LN
	addl	$8 * SIZE, %esi
#endif

#if defined(LT) || defined(RN)
	movl	K,  %eax
	subl	KK, %eax
	leal	(,%eax, SIZE), %eax
	leal	(AA, %eax, 8), AA
#ifdef LT
	addl	$16 * SIZE, B
#endif
#endif

#ifdef LN
	subl	$8, KK
	movl	BORIG, B
#endif

#ifdef LT
	addl	$8, KK
#endif

#ifdef RT
	movl	K, %eax
	movl	BORIG, B
	sall	$3 + BASE_SHIFT, %eax
	addl	%eax, AORIG
#endif
	decl	%ebx			# i --
	jg	.L10
	ALIGN_2	

.L30:
	movl	M,  %ebx
	andl	$7, %ebx
	jle	.L99

	testl	$4, %ebx
	jle	.L50

#ifdef LN
       movl	K, %eax
       sall	$2 + BASE_SHIFT, %eax
       subl	%eax, AORIG
#endif

#if defined(LN) || defined(RT)
	movl	KK, %eax
	movl	AORIG, AA
	leal	(, %eax, SIZE), %eax
	leal	(AA, %eax, 4), AA
#endif

#if (L1_DATA_LINESIZE == 64)
	leal	BUFFER, BB

#if defined(LN) || defined(RT)
	movl	KK, %eax
	sall	$1 + BASE_SHIFT, %eax
	leal	(BB, %eax, 4), BB
#endif	

	movaps	 0 * SIZE(BB), %xmm2
	XORPS	%xmm4, %xmm4
	movaps	 0 * SIZE(AA), %xmm0
	XORPS	%xmm5, %xmm5
	movaps	 16 * SIZE(BB), %xmm3
	XORPS	%xmm6, %xmm6
	movaps	 16 * SIZE(AA), %xmm1
	XORPS	%xmm7, %xmm7

#if defined(LT) || defined(RN)
	movl	KK, %eax
#else
	movl	K, %eax
	subl	KK, %eax
#endif
	sarl	$3, %eax
	je	.L32
	ALIGN_2

.L31:
	mulps	%xmm0, %xmm2
	mulps	 4 * SIZE(BB), %xmm0
	addps	%xmm2, %xmm4
	movaps	 8 * SIZE(BB), %xmm2
	addps	%xmm0, %xmm5
	movaps	 4 * SIZE(AA), %xmm0
	mulps	%xmm0, %xmm2
	mulps	12 * SIZE(BB), %xmm0
	addps	%xmm2, %xmm6
	movaps	32 * SIZE(BB), %xmm2
	addps	%xmm0, %xmm7
	movaps	 8 * SIZE(AA), %xmm0
	mulps	%xmm0, %xmm3
	mulps	20 * SIZE(BB), %xmm0
	addps	%xmm3, %xmm4
	movaps	24 * SIZE(BB), %xmm3
	addps	%xmm0, %xmm5
	movaps	12 * SIZE(AA), %xmm0
	mulps	%xmm0, %xmm3
	mulps	28 * SIZE(BB), %xmm0
	addps	%xmm3, %xmm6
	movaps	48 * SIZE(BB), %xmm3
	addps	%xmm0, %xmm7
	movaps	32 * SIZE(AA), %xmm0
	mulps	%xmm1, %xmm2
	mulps	36 * SIZE(BB), %xmm1
	addps	%xmm2, %xmm4
	movaps	40 * SIZE(BB), %xmm2
	addps	%xmm1, %xmm5
	movaps	20 * SIZE(AA), %xmm1
	mulps	%xmm1, %xmm2
	mulps	44 * SIZE(BB), %xmm1
	addps	%xmm2, %xmm6
	movaps	64 * SIZE(BB), %xmm2
	addps	%xmm1, %xmm7
	movaps	24 * SIZE(AA), %xmm1
	mulps	%xmm1, %xmm3
	mulps	52 * SIZE(BB), %xmm1
	addps	%xmm3, %xmm4
	movaps	56 * SIZE(BB), %xmm3
	addps	%xmm1, %xmm5
	movaps	28 * SIZE(AA), %xmm1
	mulps	%xmm1, %xmm3
	mulps	60 * SIZE(BB), %xmm1
	addps	%xmm3, %xmm6
	movaps	80 * SIZE(BB), %xmm3
	addps	%xmm1, %xmm7
	movaps	48 * SIZE(AA), %xmm1

	addl   $32 * SIZE, AA
	addl   $64 * SIZE, BB
	decl   %eax
	jne    .L31
	ALIGN_2

#else
	leal	BUFFER, BB

#if defined(LN) || defined(RT)
	movl	KK, %eax
	sall	$1 + BASE_SHIFT, %eax
	leal	(BB, %eax, 4), BB
#endif	

	movaps	 0 * SIZE(BB), %xmm2
	XORPS	%xmm4, %xmm4
	movaps	 0 * SIZE(AA), %xmm0
	XORPS	%xmm5, %xmm5
	movaps	 8 * SIZE(BB), %xmm3
	XORPS	%xmm6, %xmm6
	movaps	 8 * SIZE(AA), %xmm1
	XORPS	%xmm7, %xmm7

#if defined(LT) || defined(RN)
	movl	KK, %eax
#else
	movl	K, %eax
	subl	KK, %eax
#endif
	sarl	$3, %eax
	je	.L32
	ALIGN_2

.L31:
	mulps	%xmm0, %xmm2
	mulps	 4 * SIZE(BB), %xmm0
	addps	%xmm2, %xmm4
	movaps	16 * SIZE(BB), %xmm2
	addps	%xmm0, %xmm5
	movaps	 4 * SIZE(AA), %xmm0
	mulps	%xmm0, %xmm3
	mulps	12 * SIZE(BB), %xmm0
	addps	%xmm3, %xmm6
	movaps	24 * SIZE(BB), %xmm3
	addps	%xmm0, %xmm7
	movaps	16 * SIZE(AA), %xmm0
	mulps	%xmm1, %xmm2
	mulps	20 * SIZE(BB), %xmm1
	addps	%xmm2, %xmm4
	movaps	32 * SIZE(BB), %xmm2
	addps	%xmm1, %xmm5
	movaps	12 * SIZE(AA), %xmm1
	mulps	%xmm1, %xmm3
	mulps	28 * SIZE(BB), %xmm1
	addps	%xmm3, %xmm6
	movaps	40 * SIZE(BB), %xmm3
	addps	%xmm1, %xmm7
	movaps	24 * SIZE(AA), %xmm1
	mulps	%xmm0, %xmm2
	mulps	36 * SIZE(BB), %xmm0
	addps	%xmm2, %xmm4
	movaps	48 * SIZE(BB), %xmm2
	addps	%xmm0, %xmm5
	movaps	20 * SIZE(AA), %xmm0
	mulps	%xmm0, %xmm3
	mulps	44 * SIZE(BB), %xmm0
	addps	%xmm3, %xmm6
	movaps	56 * SIZE(BB), %xmm3
	addps	%xmm0, %xmm7
	movaps	32 * SIZE(AA), %xmm0
	mulps	%xmm1, %xmm2
	mulps	52 * SIZE(BB), %xmm1
	addps	%xmm2, %xmm4
	movaps	64 * SIZE(BB), %xmm2
	addps	%xmm1, %xmm5
	movaps	28 * SIZE(AA), %xmm1
	mulps	%xmm1, %xmm3
	mulps	60 * SIZE(BB), %xmm1
	addps	%xmm3, %xmm6
	movaps	72 * SIZE(BB), %xmm3
	addps	%xmm1, %xmm7
	movaps	40 * SIZE(AA), %xmm1

	addl   $32 * SIZE, AA
	addl   $64 * SIZE, BB
	decl   %eax
	jne    .L31
	ALIGN_2
#endif

.L32:
#if defined(LT) || defined(RN)
	movl	KK, %eax
#else
	movl	K, %eax
	subl	KK, %eax
#endif
	andl	$7, %eax		# if (k & 1)
	BRANCH
	je .L34

.L33:
	mulps	%xmm0, %xmm2
	mulps	 4 * SIZE(BB), %xmm0
	addps	%xmm2, %xmm4
	movaps	 8 * SIZE(BB), %xmm2
	addps	%xmm0, %xmm5
	movaps	 4 * SIZE(AA), %xmm0

	addl	$4 * SIZE, AA
	addl	$8 * SIZE, BB
	decl	%eax
	jg	.L33
	ALIGN_4

.L34:
	addps	%xmm6, %xmm4
	addps	%xmm7, %xmm5

#if defined(LN) || defined(RT)
	movl	KK, %eax
#ifdef LN
	subl	$4, %eax
#else
	subl	$2, %eax
#endif

	movl	AORIG, AA
	movl	BORIG, B
	leal	BUFFER, BB

	leal	(, %eax, SIZE), %eax
	leal	(AA, %eax, 4), AA
	leal	(B,  %eax, 2), B
	leal	(BB, %eax, 8), BB
#endif

#if defined(LN) || defined(LT)
	movaps	 %xmm4, %xmm0
	unpcklps %xmm5, %xmm4
	unpckhps %xmm5, %xmm0

	movlps	 0 * SIZE(B), %xmm2
	movhps	 2 * SIZE(B), %xmm2
	movlps	 4 * SIZE(B), %xmm3
	movhps	 6 * SIZE(B), %xmm3

	subps	%xmm4,  %xmm2
	subps	%xmm0,  %xmm3
#else
	movaps	 0 * SIZE(AA), %xmm0
	movaps	 4 * SIZE(AA), %xmm1

	subps	%xmm4, %xmm0
	subps	%xmm5, %xmm1
#endif

#ifdef LN
	movss	15 * SIZE(AA), %xmm0
	shufps	$0x0e, %xmm0, %xmm0
	movlps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm3

	movss	14 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	xorps	 %xmm4,  %xmm4
	movhlps	 %xmm3,  %xmm4
	mulps	 %xmm4,  %xmm0
	subps	 %xmm0,  %xmm3

	movaps	 %xmm3,  %xmm1	
	movhlps  %xmm1,  %xmm1

	movlps	12 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm2

	movss	10 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm3

	movaps	 %xmm3,  %xmm1	
	movlhps  %xmm1,  %xmm1

	movlps	 8 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm2

	movss	 5 * SIZE(AA), %xmm0
	shufps	$0x0e, %xmm0, %xmm0
	movlps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm2

	movss	 4 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	xorps	 %xmm4,  %xmm4
	movhlps	 %xmm2,  %xmm4
	mulps	 %xmm4,  %xmm0
	subps	 %xmm0,  %xmm2

	movss	 0 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm2
#endif

#ifdef LT
	movss	 0 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm2

	movss	 1 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm2, %xmm0
	shufps	 $0x4e, %xmm0, %xmm0
	subps	 %xmm0, %xmm2

	movaps	 %xmm2,  %xmm1	
	movlhps %xmm1,  %xmm1

	movlps	 2 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm3

	movss	 5 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	shufps	 $0x4e, %xmm0, %xmm0
	mulps	 %xmm0,  %xmm2

	movaps	 %xmm2,  %xmm1	
	movhlps %xmm1,  %xmm1

	movlps	 6 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm1,  %xmm0
	subps	 %xmm0,  %xmm3

	movss	10 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm3

	movss	11 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm3, %xmm0
	shufps	 $0x4e, %xmm0, %xmm0
	subps	 %xmm0, %xmm3

	movss	 15 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	shufps	 $0x4e, %xmm0, %xmm0
	mulps	 %xmm0,  %xmm3

#endif

#ifdef RN
	movss	 0 * SIZE(B),  %xmm4
	shufps	 $0x00, %xmm4, %xmm4
	mulps	 %xmm4, %xmm0

	movss	 1 * SIZE(B),  %xmm4
	shufps	 $0x00, %xmm4, %xmm4
	mulps	 %xmm0, %xmm4
	subps	 %xmm4, %xmm1

	movss	 3 * SIZE(B),  %xmm4
	shufps	 $0x00, %xmm4, %xmm4
	mulps	 %xmm4, %xmm1
#endif

#ifdef RT
	movss	 3 * SIZE(B),  %xmm4
	shufps	 $0x00, %xmm4, %xmm4
	mulps	 %xmm4, %xmm1

	movss	 2 * SIZE(B),  %xmm4
	shufps	 $0x00, %xmm4, %xmm4
	mulps	 %xmm1, %xmm4
	subps	 %xmm4, %xmm0

	movss	 0 * SIZE(B),  %xmm4
	shufps	 $0x00, %xmm4, %xmm4
	mulps	 %xmm4, %xmm0
#endif

#if defined(LN) || defined(LT)
	movlps	%xmm2,   0 * SIZE(B)
	movhps	%xmm2,   2 * SIZE(B)
	movlps	%xmm3,   4 * SIZE(B)
	movhps	%xmm3,   6 * SIZE(B)

	movaps	%xmm2, %xmm0
	shufps	$0x00, %xmm0, %xmm0
	movaps	%xmm0,   0 * SIZE(BB)
	movaps	%xmm2, %xmm0
	shufps	$0x55, %xmm0, %xmm0
	movaps	%xmm0,   4 * SIZE(BB)
	movaps	%xmm2, %xmm0
	shufps	$0xaa, %xmm0, %xmm0
	movaps	%xmm0,   8 * SIZE(BB)
	movaps	%xmm2, %xmm0
	shufps	$0xff, %xmm0, %xmm0
	movaps	%xmm0,  12 * SIZE(BB)
	movaps	%xmm3, %xmm0
	shufps	$0x00, %xmm0, %xmm0
	movaps	%xmm0,  16 * SIZE(BB)
	movaps	%xmm3, %xmm0
	shufps	$0x55, %xmm0, %xmm0
	movaps	%xmm0,  20 * SIZE(BB)
	movaps	%xmm3, %xmm0
	shufps	$0xaa, %xmm0, %xmm0
	movaps	%xmm0,  24 * SIZE(BB)
	movaps	%xmm3, %xmm0
	shufps	$0xff, %xmm0, %xmm0
	movaps	%xmm0,  28 * SIZE(BB)

#else
	movaps	%xmm0,   0 * SIZE(AA)
	movaps	%xmm1,   4 * SIZE(AA)
#endif

#ifdef LN
	subl	$4 * SIZE, %esi
#endif

#if defined(LN) || defined(LT)
	movaps	%xmm2, %xmm0
	shufps	$0x88, %xmm3, %xmm2
	shufps	$0xdd, %xmm3, %xmm0

	movlps	%xmm2,  0 * SIZE(%esi)
	movhps	%xmm2,  2 * SIZE(%esi)

	movlps	%xmm0,  0 * SIZE(%esi, LDC)
	movhps	%xmm0,  2 * SIZE(%esi, LDC)
#else
	movlps	%xmm0,  0 * SIZE(%esi)
	movhps	%xmm0,  2 * SIZE(%esi)

	movlps	%xmm1,  0 * SIZE(%esi, LDC)
	movhps	%xmm1,  2 * SIZE(%esi, LDC)
#endif

#ifndef LN
	addl	$4 * SIZE, %esi
#endif

#if defined(LT) || defined(RN)
	movl	K,  %eax
	subl	KK, %eax
	leal	(,%eax, SIZE), %eax
	leal	(AA, %eax, 4), AA
#ifdef LT
	addl	$ 8 * SIZE, B
#endif
#endif

#ifdef LN
	subl	$4, KK
	movl	BORIG, B
#endif

#ifdef LT
	addl	$4, KK
#endif

#ifdef RT
	movl	K, %eax
	movl	BORIG, B
	sall	$2 + BASE_SHIFT, %eax
	addl	%eax, AORIG
#endif
	ALIGN_2	

.L50:
	testl	$2, %ebx
	jle	.L70

#ifdef LN
       movl	K, %eax
       sall	$1 + BASE_SHIFT, %eax
       subl	%eax, AORIG
#endif

#if defined(LN) || defined(RT)
	movl	KK, %eax
	movl	AORIG, AA
	leal	(, %eax, SIZE), %eax
	leal	(AA, %eax, 2), AA
#endif

#if (L1_DATA_LINESIZE == 64)
	leal	BUFFER, BB

#if defined(LN) || defined(RT)
	movl	KK, %eax
	sall	$1 + BASE_SHIFT, %eax
	leal	(BB, %eax, 4), BB
#endif	

	MOVSD	 0 * SIZE(BB), %xmm2
	XORPS	%xmm4, %xmm4
	MOVSD	 0 * SIZE(AA), %xmm0
	XORPS	%xmm5, %xmm5
	MOVSD	 16 * SIZE(BB), %xmm3
	XORPS	%xmm6, %xmm6
	MOVSD	 8 * SIZE(AA), %xmm1
	XORPS	%xmm7, %xmm7

#if defined(LT) || defined(RN)
	movl	KK, %eax
#else
	movl	K, %eax
	subl	KK, %eax
#endif
	sarl	$3, %eax
	je	.L52
	ALIGN_2

.L51:
	mulps	%xmm0, %xmm2
	addps	%xmm2, %xmm4
	MOVSD	 4 * SIZE(BB), %xmm2
	mulps	%xmm0, %xmm2
	MOVSD	 2 * SIZE(AA), %xmm0
	addps	%xmm2, %xmm5
	MOVSD	 8 * SIZE(BB), %xmm2
	mulps	%xmm0, %xmm2
	addps	%xmm2, %xmm6
	MOVSD	12 * SIZE(BB), %xmm2
	mulps	%xmm0, %xmm2
	MOVSD	 4 * SIZE(AA), %xmm0
	addps	%xmm2, %xmm7
	MOVSD	32 * SIZE(BB), %xmm2
	mulps	%xmm0, %xmm3
	addps	%xmm3, %xmm4
	MOVSD	20 * SIZE(BB), %xmm3
	mulps	%xmm0, %xmm3
	MOVSD	 6 * SIZE(AA), %xmm0
	addps	%xmm3, %xmm5
	MOVSD	24 * SIZE(BB), %xmm3
	mulps	%xmm0, %xmm3
	addps	%xmm3, %xmm6
	MOVSD	28 * SIZE(BB), %xmm3
	mulps	%xmm0, %xmm3
	MOVSD	16 * SIZE(AA), %xmm0
	addps	%xmm3, %xmm7
	MOVSD	48 * SIZE(BB), %xmm3
	mulps	%xmm1, %xmm2
	addps	%xmm2, %xmm4
	MOVSD	36 * SIZE(BB), %xmm2
	mulps	%xmm1, %xmm2
	MOVSD	10 * SIZE(AA), %xmm1
	addps	%xmm2, %xmm5
	MOVSD	40 * SIZE(BB), %xmm2
	mulps	%xmm1, %xmm2
	addps	%xmm2, %xmm6
	MOVSD	44 * SIZE(BB), %xmm2
	mulps	%xmm1, %xmm2
	MOVSD	12 * SIZE(AA), %xmm1
	addps	%xmm2, %xmm7
	MOVSD	64 * SIZE(BB), %xmm2
	mulps	%xmm1, %xmm3
	addps	%xmm3, %xmm4
	MOVSD	52 * SIZE(BB), %xmm3
	mulps	%xmm1, %xmm3
	MOVSD	14 * SIZE(AA), %xmm1
	addps	%xmm3, %xmm5
	MOVSD	56 * SIZE(BB), %xmm3
	mulps	%xmm1, %xmm3
	addps	%xmm3, %xmm6
	MOVSD	60 * SIZE(BB), %xmm3
	mulps	%xmm1, %xmm3
	MOVSD	24 * SIZE(AA), %xmm1
	addps	%xmm3, %xmm7
	MOVSD	80 * SIZE(BB), %xmm3

	addl   $16 * SIZE, AA
	addl   $64 * SIZE, BB
	decl   %eax
	jne    .L51
	ALIGN_2

#else
	leal	BUFFER, BB

#if defined(LN) || defined(RT)
	movl	KK, %eax
	sall	$1 + BASE_SHIFT, %eax
	leal	(BB, %eax, 4), BB
#endif	

	MOVSD	 0 * SIZE(BB), %xmm2
	XORPS	%xmm4, %xmm4
	MOVSD	 0 * SIZE(AA), %xmm0
	XORPS	%xmm5, %xmm5
	MOVSD	 8 * SIZE(BB), %xmm3
	XORPS	%xmm6, %xmm6
	MOVSD	 8 * SIZE(AA), %xmm1
	XORPS	%xmm7, %xmm7

#if defined(LT) || defined(RN)
	movl	KK, %eax
#else
	movl	K, %eax
	subl	KK, %eax
#endif
	sarl	$3, %eax
	je	.L52
	ALIGN_2

.L51:
	mulps	%xmm0, %xmm2
	addps	%xmm2, %xmm4
	MOVSD	 4 * SIZE(BB), %xmm2
	mulps	%xmm0, %xmm2
	MOVSD	 2 * SIZE(AA), %xmm0
	addps	%xmm2, %xmm5
	MOVSD	16 * SIZE(BB), %xmm2
	mulps	%xmm0, %xmm3
	addps	%xmm3, %xmm6
	MOVSD	12 * SIZE(BB), %xmm3
	mulps	%xmm0, %xmm3
	MOVSD	 4 * SIZE(AA), %xmm0
	addps	%xmm3, %xmm7
	MOVSD	24 * SIZE(BB), %xmm3
	mulps	%xmm0, %xmm2
	addps	%xmm2, %xmm4
	MOVSD	20 * SIZE(BB), %xmm2
	mulps	%xmm0, %xmm2
	MOVSD	 6 * SIZE(AA), %xmm0
	addps	%xmm2, %xmm5
	MOVSD	32 * SIZE(BB), %xmm2
	mulps	%xmm0, %xmm3
	addps	%xmm3, %xmm6
	MOVSD	28 * SIZE(BB), %xmm3
	mulps	%xmm0, %xmm3
	MOVSD	16 * SIZE(AA), %xmm0
	addps	%xmm3, %xmm7
	MOVSD	40 * SIZE(BB), %xmm3
	mulps	%xmm1, %xmm2
	addps	%xmm2, %xmm4
	MOVSD	36 * SIZE(BB), %xmm2
	mulps	%xmm1, %xmm2
	MOVSD	10 * SIZE(AA), %xmm1
	addps	%xmm2, %xmm5
	MOVSD	48 * SIZE(BB), %xmm2
	mulps	%xmm1, %xmm3
	addps	%xmm3, %xmm6
	MOVSD	44 * SIZE(BB), %xmm3
	mulps	%xmm1, %xmm3
	MOVSD	12 * SIZE(AA), %xmm1
	addps	%xmm3, %xmm7
	MOVSD	56 * SIZE(BB), %xmm3
	mulps	%xmm1, %xmm2
	addps	%xmm2, %xmm4
	MOVSD	52 * SIZE(BB), %xmm2
	mulps	%xmm1, %xmm2
	MOVSD	14 * SIZE(AA), %xmm1
	addps	%xmm2, %xmm5
	MOVSD	64 * SIZE(BB), %xmm2
	mulps	%xmm1, %xmm3
	addps	%xmm3, %xmm6
	MOVSD	60 * SIZE(BB), %xmm3
	mulps	%xmm1, %xmm3
	MOVSD	24 * SIZE(AA), %xmm1
	addps	%xmm3, %xmm7
	MOVSD	72 * SIZE(BB), %xmm3

	addl   $16 * SIZE, AA
	addl   $64 * SIZE, BB
	decl   %eax
	jne    .L51
	ALIGN_2
#endif

.L52:
#if defined(LT) || defined(RN)
	movl	KK, %eax
#else
	movl	K, %eax
	subl	KK, %eax
#endif
	andl	$7, %eax		# if (k & 1)
	BRANCH
	je .L54

.L53:
	mulps	%xmm0, %xmm2
	addps	%xmm2, %xmm4
	MOVSD	 4 * SIZE(BB), %xmm2
	mulps	%xmm0, %xmm2
	MOVSD	 2 * SIZE(AA), %xmm0
	addps	%xmm2, %xmm5
	MOVSD	 8 * SIZE(BB), %xmm2

	addl	$2 * SIZE, AA
	addl	$8 * SIZE, BB
	decl	%eax
	jg	.L53
	ALIGN_4

.L54:
	addps	%xmm6, %xmm4
	addps	%xmm7, %xmm5

#if defined(LN) || defined(RT)
	movl	KK, %eax
#ifdef LN
	subl	$2, %eax
#else
	subl	$2, %eax
#endif

	movl	AORIG, AA
	movl	BORIG, B
	leal	BUFFER, BB

	leal	(, %eax, SIZE), %eax
	leal	(AA, %eax, 2), AA
	leal	(B,  %eax, 2), B
	leal	(BB, %eax, 8), BB
#endif

#if defined(LN) || defined(LT)
	unpcklps %xmm5, %xmm4

	movlps	 0 * SIZE(B), %xmm2
	movhps	 2 * SIZE(B), %xmm2

	subps	%xmm4,  %xmm2
#else
	movlhps	%xmm5, %xmm4

	movaps	 0 * SIZE(AA), %xmm0

	subps	%xmm4, %xmm0
#endif

#ifdef LN
	movss	 3 * SIZE(AA), %xmm0
	shufps	$0x0e, %xmm0, %xmm0
	movlps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm2

	movss	 2 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	xorps	 %xmm4,  %xmm4
	movhlps	 %xmm2,  %xmm4
	mulps	 %xmm4,  %xmm0
	subps	 %xmm0,  %xmm2

	movss	 0 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm2
#endif

#ifdef LT
	movss	 0 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	mulps	 %xmm0,  %xmm2

	movss	 1 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	mulps	 %xmm2, %xmm0
	shufps	 $0x4e, %xmm0, %xmm0
	subps	 %xmm0, %xmm2

	movss	 3 * SIZE(AA), %xmm0
	unpcklps %xmm0,  %xmm0
	movhps	 SSEONE, %xmm0
	shufps	 $0x4e, %xmm0, %xmm0
	mulps	 %xmm0,  %xmm2
#endif

#ifdef RN
	movss	 0 * SIZE(B),  %xmm4
	unpcklps %xmm4,  %xmm4
	movhps	 SSEONE, %xmm4
	mulps	 %xmm4, %xmm0

	movss	 1 * SIZE(B),  %xmm4
	unpcklps %xmm4,  %xmm4
	mulps	 %xmm0, %xmm4
	shufps	 $0x4e, %xmm4, %xmm4
	subps	 %xmm4, %xmm0

	movss	 3 * SIZE(B),  %xmm4
	unpcklps %xmm4,  %xmm4
	movhps	 SSEONE, %xmm4
	shufps	 $0x4e, %xmm4, %xmm4
	mulps	 %xmm4, %xmm0
#endif

#ifdef RT
	movss	 3 * SIZE(B), %xmm4
	shufps	$0x0e, %xmm4, %xmm4
	movlps	 SSEONE, %xmm4
	mulps	 %xmm4,  %xmm0

	movss	 2 * SIZE(B), %xmm4
	unpcklps %xmm4,  %xmm4
	xorps	 %xmm5,  %xmm5
	movhlps	 %xmm0,  %xmm5
	mulps	 %xmm5,  %xmm4
	subps	 %xmm4,  %xmm0

	movss	 0 * SIZE(B), %xmm4
	unpcklps %xmm4,  %xmm4
	movhps	 SSEONE, %xmm4
	mulps	 %xmm4,  %xmm0
#endif

#if defined(LN) || defined(LT)
	movlps	%xmm2,   0 * SIZE(B)
	movhps	%xmm2,   2 * SIZE(B)

	movaps	%xmm2, %xmm0
	shufps	$0x00, %xmm0, %xmm0
	movaps	%xmm0,   0 * SIZE(BB)
	movaps	%xmm2, %xmm0
	shufps	$0x55, %xmm0, %xmm0
	movaps	%xmm0,   4 * SIZE(BB)
	movaps	%xmm2, %xmm0
	shufps	$0xaa, %xmm0, %xmm0
	movaps	%xmm0,   8 * SIZE(BB)
	movaps	%xmm2, %xmm0
	shufps	$0xff, %xmm0, %xmm0
	movaps	%xmm0,  12 * SIZE(BB)
#else
	movaps	%xmm0,   0 * SIZE(AA)
#endif

#ifdef LN
	subl	$2 * SIZE, %esi
#endif

#if defined(LN) || defined(LT)
	movaps	%xmm2, %xmm0
	shufps	$0x88, %xmm2, %xmm2
	shufps	$0xdd, %xmm2, %xmm0

	movlps	%xmm2,  0 * SIZE(%esi)
	movlps	%xmm0,  0 * SIZE(%esi, LDC)
#else
	movlps	%xmm0,  0 * SIZE(%esi)
	movhps	%xmm0,  0 * SIZE(%esi, LDC)
#endif

#ifndef LN
	addl	$2 * SIZE, %esi
#endif

#if defined(LT) || defined(RN)
	movl	K,  %eax
	subl	KK, %eax
	leal	(,%eax, SIZE), %eax
	leal	(AA, %eax, 2), AA
#ifdef LT
	addl	$ 4 * SIZE, B
#endif
#endif

#ifdef LN
	subl	$2, KK
	movl	BORIG, B
#endif

#ifdef LT
	addl	$2, KK
#endif

#ifdef RT
	movl	K, %eax
	movl	BORIG, B
	sall	$1 + BASE_SHIFT, %eax
	addl	%eax, AORIG
#endif
	ALIGN_2	

.L70:
	testl	$1, %ebx
	jle	.L99

#ifdef LN
       movl	K, %eax
       sall	$0 + BASE_SHIFT, %eax
       subl	%eax, AORIG
#endif

#if defined(LN) || defined(RT)
	movl	KK, %eax
	movl	AORIG, AA
	leal	(, %eax, SIZE), %eax
	leal	(AA, %eax, 1), AA
#endif

#if (L1_DATA_LINESIZE == 64)
	leal	BUFFER, BB

#if defined(LN) || defined(RT)
	movl	KK, %eax
	sall	$1 + BASE_SHIFT, %eax
	leal	(BB, %eax, 4), BB
#endif	

	movss	 0 * SIZE(BB), %xmm2
	XORPS	%xmm4, %xmm4
	movss	 0 * SIZE(AA), %xmm0
	XORPS	%xmm5, %xmm5
	movss	 16 * SIZE(BB), %xmm3
	XORPS	%xmm6, %xmm6
	movss	 4 * SIZE(AA), %xmm1
	XORPS	%xmm7, %xmm7

#if defined(LT) || defined(RN)
	movl	KK, %eax
#else
	movl	K, %eax
	subl	KK, %eax
#endif
	sarl	$3, %eax
	je	.L72
	ALIGN_2

.L71:
	mulss	%xmm0, %xmm2
	mulss	 4 * SIZE(BB), %xmm0
	addss	%xmm2, %xmm4
	movss	 8 * SIZE(BB), %xmm2
	addss	%xmm0, %xmm5
	movss	 1 * SIZE(AA), %xmm0
	mulss	%xmm0, %xmm2
	mulss	12 * SIZE(BB), %xmm0
	addss	%xmm2, %xmm6
	movss	32 * SIZE(BB), %xmm2
	addss	%xmm0, %xmm7
	movss	 2 * SIZE(AA), %xmm0
	mulss	%xmm0, %xmm3
	mulss	20 * SIZE(BB), %xmm0
	addss	%xmm3, %xmm4
	movss	24 * SIZE(BB), %xmm3
	addss	%xmm0, %xmm5
	movss	 3 * SIZE(AA), %xmm0
	mulss	%xmm0, %xmm3
	mulss	28 * SIZE(BB), %xmm0
	addss	%xmm3, %xmm6
	movss	48 * SIZE(BB), %xmm3
	addss	%xmm0, %xmm7
	movss	 8 * SIZE(AA), %xmm0
	mulss	%xmm1, %xmm2
	mulss	36 * SIZE(BB), %xmm1
	addss	%xmm2, %xmm4
	movss	40 * SIZE(BB), %xmm2
	addss	%xmm1, %xmm5
	movss	 5 * SIZE(AA), %xmm1
	mulss	%xmm1, %xmm2
	mulss	44 * SIZE(BB), %xmm1
	addss	%xmm2, %xmm6
	movss	64 * SIZE(BB), %xmm2
	addss	%xmm1, %xmm7
	movss	 6 * SIZE(AA), %xmm1
	mulss	%xmm1, %xmm3
	mulss	52 * SIZE(BB), %xmm1
	addss	%xmm3, %xmm4
	movss	56 * SIZE(BB), %xmm3
	addss	%xmm1, %xmm5
	movss	 7 * SIZE(AA), %xmm1
	mulss	%xmm1, %xmm3
	mulss	60 * SIZE(BB), %xmm1
	addss	%xmm3, %xmm6
	movss	80 * SIZE(BB), %xmm3
	addss	%xmm1, %xmm7
	movss	12 * SIZE(AA), %xmm1

	addl   $ 8 * SIZE, AA
	addl   $64 * SIZE, BB
	decl   %eax
	jne    .L71
	ALIGN_2

#else
	leal	BUFFER, BB

#if defined(LN) || defined(RT)
	movl	KK, %eax
	sall	$1 + BASE_SHIFT, %eax
	leal	(BB, %eax, 4), BB
#endif	

	movss	 0 * SIZE(BB), %xmm2
	XORPS	%xmm4, %xmm4
	movss	 0 * SIZE(AA), %xmm0
	XORPS	%xmm5, %xmm5
	movss	 8 * SIZE(BB), %xmm3
	XORPS	%xmm6, %xmm6
	movss	 4 * SIZE(AA), %xmm1
	XORPS	%xmm7, %xmm7

#if defined(LT) || defined(RN)
	movl	KK, %eax
#else
	movl	K, %eax
	subl	KK, %eax
#endif
	sarl	$3, %eax
	je	.L72
	ALIGN_2

.L71:
	mulss	%xmm0, %xmm2
	mulss	 4 * SIZE(BB), %xmm0
	addss	%xmm2, %xmm4
	movss	16 * SIZE(BB), %xmm2
	addss	%xmm0, %xmm5
	movss	 1 * SIZE(AA), %xmm0
	mulss	%xmm0, %xmm3
	mulss	12 * SIZE(BB), %xmm0
	addss	%xmm3, %xmm6
	movss	24 * SIZE(BB), %xmm3
	addss	%xmm0, %xmm7
	movss	 2 * SIZE(AA), %xmm0
	mulss	%xmm0, %xmm2
	mulss	20 * SIZE(BB), %xmm0
	addss	%xmm2, %xmm4
	movss	32 * SIZE(BB), %xmm2
	addss	%xmm0, %xmm5
	movss	 3 * SIZE(AA), %xmm0
	mulss	%xmm0, %xmm3
	mulss	28 * SIZE(BB), %xmm0
	addss	%xmm3, %xmm6
	movss	40 * SIZE(BB), %xmm3
	addss	%xmm0, %xmm7
	movss	 8 * SIZE(AA), %xmm0
	mulss	%xmm1, %xmm2
	mulss	36 * SIZE(BB), %xmm1
	addss	%xmm2, %xmm4
	movss	48 * SIZE(BB), %xmm2
	addss	%xmm1, %xmm5
	movss	 5 * SIZE(AA), %xmm1
	mulss	%xmm1, %xmm3
	mulss	44 * SIZE(BB), %xmm1
	addss	%xmm3, %xmm6
	movss	56 * SIZE(BB), %xmm3
	addss	%xmm1, %xmm7
	movss	 6 * SIZE(AA), %xmm1
	mulss	%xmm1, %xmm2
	mulss	52 * SIZE(BB), %xmm1
	addss	%xmm2, %xmm4
	movss	64 * SIZE(BB), %xmm2
	addss	%xmm1, %xmm5
	movss	 7 * SIZE(AA), %xmm1
	mulss	%xmm1, %xmm3
	mulss	60 * SIZE(BB), %xmm1
	addss	%xmm3, %xmm6
	movss	72 * SIZE(BB), %xmm3
	addss	%xmm1, %xmm7
	movss	12 * SIZE(AA), %xmm1

	addl   $ 8 * SIZE, AA
	addl   $64 * SIZE, BB
	decl   %eax
	jne    .L71
	ALIGN_2
#endif

.L72:
#if defined(LT) || defined(RN)
	movl	KK, %eax
#else
	movl	K, %eax
	subl	KK, %eax
#endif
	andl	$7, %eax		# if (k & 1)
	BRANCH
	je .L74

.L73:
	mulss	%xmm0, %xmm2
	mulss	 4 * SIZE(BB), %xmm0
	addss	%xmm2, %xmm4
	movss	 8 * SIZE(BB), %xmm2
	addss	%xmm0, %xmm5
	movss	 1 * SIZE(AA), %xmm0

	addl	$1 * SIZE, AA
	addl	$8 * SIZE, BB
	decl	%eax
	jg	.L73
	ALIGN_4

.L74:
	addss	%xmm6, %xmm4
	addss	%xmm7, %xmm5

#if defined(LN) || defined(RT)
	movl	KK, %eax
#ifdef LN
	subl	$1, %eax
#else
	subl	$2, %eax
#endif

	movl	AORIG, AA
	movl	BORIG, B
	leal	BUFFER, BB

	leal	(, %eax, SIZE), %eax
	leal	(AA, %eax, 1), AA
	leal	(B,  %eax, 2), B
	leal	(BB, %eax, 8), BB
#endif

#if defined(LN) || defined(LT)
	movss	 0 * SIZE(B), %xmm0
	movss	 1 * SIZE(B), %xmm1
	subss	%xmm4,  %xmm0
	subss	%xmm5,  %xmm1
#else
	movss	 0 * SIZE(AA), %xmm0
	movss	 1 * SIZE(AA), %xmm1
	subss	%xmm4, %xmm0
	subss	%xmm5, %xmm1
#endif

#ifdef LN
	movss	 0 * SIZE(AA), %xmm2
	mulss	 %xmm2,  %xmm0
	mulss	 %xmm2,  %xmm1
#endif

#ifdef LT
	movss	 0 * SIZE(AA), %xmm2
	mulss	 %xmm2,  %xmm0
	mulss	 %xmm2,  %xmm1
#endif

#ifdef RN
	movss	 0 * SIZE(B),  %xmm2
	mulss	 %xmm2, %xmm0

	movss	 1 * SIZE(B),  %xmm2
	mulss	 %xmm0, %xmm2
	subss	 %xmm2, %xmm1

	movss	 3 * SIZE(B),  %xmm2
	mulss	 %xmm2, %xmm1
#endif

#ifdef RT
	movss	 3 * SIZE(B),  %xmm2
	mulss	 %xmm2, %xmm1

	movss	 2 * SIZE(B),  %xmm2
	mulss	 %xmm1, %xmm2
	subss	 %xmm2, %xmm0

	movss	 0 * SIZE(B),  %xmm2
	mulss	 %xmm2, %xmm0
#endif

#if defined(LN) || defined(LT)
	movss	%xmm0,   0 * SIZE(B)
	movss	%xmm1,   1 * SIZE(B)

	shufps	$0x00, %xmm0, %xmm0
	shufps	$0x00, %xmm1, %xmm1
	movaps	%xmm1,   0 * SIZE(BB)
	movaps	%xmm1,   4 * SIZE(BB)
#else
	movss	%xmm0,   0 * SIZE(AA)
	movss	%xmm1,   1 * SIZE(AA)
#endif

#ifdef LN
	subl	$1 * SIZE, %esi
#endif

#if defined(LN) || defined(LT)
	movss	%xmm0,  0 * SIZE(%esi)
	movss	%xmm1,  0 * SIZE(%esi, LDC)
#else
	movss	%xmm0,  0 * SIZE(%esi)
	movss	%xmm1,  0 * SIZE(%esi, LDC)
#endif

#ifndef LN
	addl	$1 * SIZE, %esi
#endif

#if defined(LT) || defined(RN)
	movl	K,  %eax
	subl	KK, %eax
	leal	(,%eax, SIZE), %eax
	leal	(AA, %eax, 1), AA
#ifdef LT
	addl	$ 2 * SIZE, B
#endif
#endif

#ifdef LN
	subl	$1, KK
	movl	BORIG, B
#endif

#ifdef LT
	addl	$1, KK
#endif

#ifdef RT
	movl	K, %eax
	movl	BORIG, B
	sall	$0 + BASE_SHIFT, %eax
	addl	%eax, AORIG
#endif
	ALIGN_2

.L99:
#ifdef LN
       movl	K, %eax
       leal	(, %eax, SIZE), %eax
       leal 	(B, %eax, 2), B
#endif

#if defined(LT) || defined(RN)
	movl	K,  %eax
	subl	KK, %eax
	leal	(,%eax, SIZE), %eax
	leal	(B,  %eax, 2), B
#endif

#ifdef RN
	addl	$2, KK
#endif

#ifdef RT
	subl	$2, KK
#endif

	BRANCH
	decl	J			# j --
	jg	.L01
	ALIGN_2

.L100:
	movl	N, %eax
	testl	$1, %eax
	jle	.L999
	ALIGN_2
	
.L101:
/* Copying to Sub Buffer */
#ifdef LN
	movl	OFFSET, %eax
	addl	M, %eax
	movl	%eax, KK
#endif	

	leal	BUFFER, %ecx

#ifdef RT
       movl	K, %eax
       sall	$0 + BASE_SHIFT, %eax
       subl	%eax, B
#endif

#if defined(LN) || defined(RT)
	movl	KK, %eax
	movl	B, BORIG
	leal	(, %eax, SIZE), %eax
	leal	(B,  %eax, 1), B
	leal	(BB, %eax, 4), BB
#endif	

#ifdef LT
	movl	OFFSET, %eax
	movl	%eax, KK
#endif

#if defined(LT) || defined(RN)
	movl	KK, %eax
#else
	movl	K, %eax
	subl	KK, %eax
#endif
	sarl	$3, %eax
	jle	.L103
	ALIGN_4
	
.L102:
	prefetchnta	96 * SIZE(B)
	
	movss	0 * SIZE(B), %xmm0
	movss	1 * SIZE(B), %xmm1
	movss	2 * SIZE(B), %xmm2
	movss	3 * SIZE(B), %xmm3
	movss	4 * SIZE(B), %xmm4
	movss	5 * SIZE(B), %xmm5
	movss	6 * SIZE(B), %xmm6
	movss	7 * SIZE(B), %xmm7
	addl	$ 8 * SIZE, B

	shufps	$0, %xmm0, %xmm0
	shufps	$0, %xmm1, %xmm1
	shufps	$0, %xmm2, %xmm2
	shufps	$0, %xmm3, %xmm3
	shufps	$0, %xmm4, %xmm4
	shufps	$0, %xmm5, %xmm5
	shufps	$0, %xmm6, %xmm6
	shufps	$0, %xmm7, %xmm7

	movaps	%xmm0,  0 * SIZE(%ecx)
	movaps	%xmm1,  4 * SIZE(%ecx)
	movaps	%xmm2,  8 * SIZE(%ecx)
	movaps	%xmm3, 12 * SIZE(%ecx)
	movaps	%xmm4, 16 * SIZE(%ecx)
	movaps	%xmm5, 20 * SIZE(%ecx)
	movaps	%xmm6, 24 * SIZE(%ecx)
	movaps	%xmm7, 28 * SIZE(%ecx)
	addl	$32 * SIZE, %ecx

	decl	%eax
	BRANCH
	jne	.L102
	ALIGN_2

.L103:
#if defined(LT) || defined(RN)
	movl	KK, %eax
#else
	movl	K, %eax
	subl	KK, %eax
#endif
	andl	$7, %eax
	BRANCH
	jle	.L105
	ALIGN_2

.L104:
	movss	0 * SIZE(B), %xmm0
	addl	$1 * SIZE, B

	shufps	$0, %xmm0, %xmm0

	movaps	%xmm0,  0 * SIZE(%ecx)
	addl	$4 * SIZE, %ecx
	decl	%eax
	jne	.L104
	ALIGN_4

.L105:
#if defined(LT) || defined(RN)
	movl	A, AA
#else
	movl	A, %eax
	movl	%eax, AORIG
#endif

#ifdef RT
       subl	LDC, C
#endif

	movl	C, %esi		# coffset = c

	movl	M,  %ebx
	sarl	$3, %ebx	# i = (m >> 2)
	jle	.L130
	ALIGN_4

.L110:
#ifdef LN
       movl	K, %eax
       sall	$3 + BASE_SHIFT, %eax
       subl	%eax, AORIG
#endif

#if defined(LN) || defined(RT)
	movl	KK, %eax
	movl	AORIG, AA
	leal	(, %eax, SIZE), %eax
	leal	(AA, %eax, 8), AA
#endif

#if (L1_DATA_LINESIZE == 64)
	leal	BUFFER, BB

#if defined(LN) || defined(RT)
	movl	KK, %eax
	sall	$0 + BASE_SHIFT, %eax
	leal	(BB, %eax, 4), BB
#endif	

	movaps	 0 * SIZE(BB), %xmm2
	XORPS	%xmm4, %xmm4
	movaps	 0 * SIZE(AA), %xmm0
	XORPS	%xmm5, %xmm5
	movaps	 16 * SIZE(BB), %xmm3
	XORPS	%xmm6, %xmm6
	movaps	 16 * SIZE(AA), %xmm1
	XORPS	%xmm7, %xmm7

#if defined(LT) || defined(RN)
	movl	KK, %eax
#else
	movl	K, %eax
	subl	KK, %eax
#endif
	sarl	$3, %eax
	je	.L112
	ALIGN_2

.L111:
	mulps	%xmm2, %xmm0
	mulps	 4 * SIZE(AA), %xmm2
	addps	%xmm0, %xmm4
	movaps	 8 * SIZE(AA), %xmm0
	addps	%xmm2, %xmm5
	movaps	 4 * SIZE(BB), %xmm2
	mulps	%xmm2, %xmm0
	mulps	12 * SIZE(AA), %xmm2
	addps	%xmm0, %xmm6
	movaps	32 * SIZE(AA), %xmm0
	addps	%xmm2, %xmm7
	movaps	 8 * SIZE(BB), %xmm2
	mulps	%xmm2, %xmm1
	mulps	20 * SIZE(AA), %xmm2
	addps	%xmm1, %xmm4
	movaps	24 * SIZE(AA), %xmm1
	addps	%xmm2, %xmm5
	movaps	12 * SIZE(BB), %xmm2
	mulps	%xmm2, %xmm1
	mulps	28 * SIZE(AA), %xmm2
	addps	%xmm1, %xmm6
	movaps	48 * SIZE(AA), %xmm1
	addps	%xmm2, %xmm7
	movaps	32 * SIZE(BB), %xmm2
	mulps	%xmm3, %xmm0
	mulps	36 * SIZE(AA), %xmm3
	addps	%xmm0, %xmm4
	movaps	40 * SIZE(AA), %xmm0
	addps	%xmm3, %xmm5
	movaps	20 * SIZE(BB), %xmm3
	mulps	%xmm3, %xmm0
	mulps	44 * SIZE(AA), %xmm3
	addps	%xmm0, %xmm6
	movaps	64 * SIZE(AA), %xmm0
	addps	%xmm3, %xmm7
	movaps	24 * SIZE(BB), %xmm3
	mulps	%xmm3, %xmm1
	mulps	52 * SIZE(AA), %xmm3
	addps	%xmm1, %xmm4
	movaps	56 * SIZE(AA), %xmm1
	addps	%xmm3, %xmm5
	movaps	28 * SIZE(BB), %xmm3
	mulps	%xmm3, %xmm1
	mulps	60 * SIZE(AA), %xmm3
	addps	%xmm1, %xmm6
	movaps	80 * SIZE(AA), %xmm1
	addps	%xmm3, %xmm7
	movaps	48 * SIZE(BB), %xmm3

	addl   $64 * SIZE, AA
	addl   $32 * SIZE, BB
	decl   %eax
	jne    .L111
	ALIGN_2

#else

	leal	BUFFER, BB

	movaps	 0 * SIZE(BB), %xmm2
	XORPS	%xmm4, %xmm4
	movaps	 0 * SIZE(AA), %xmm0
	XORPS	%xmm5, %xmm5
	movaps	 8 * SIZE(BB), %xmm3
	XORPS	%xmm6, %xmm6
	movaps	 8 * SIZE(AA), %xmm1
	XORPS	%xmm7, %xmm7

	movl	K, %eax
	sarl	$3, %eax
	je	.L112
	ALIGN_2

.L111:
	mulps	%xmm2, %xmm0
	mulps	 4 * SIZE(AA), %xmm2
	addps	%xmm0, %xmm4
	movaps	16 * SIZE(AA), %xmm0
	addps	%xmm2, %xmm5
	movaps	 4 * SIZE(BB), %xmm2
	mulps	%xmm2, %xmm1
	mulps	12 * SIZE(AA), %xmm2
	addps	%xmm1, %xmm6
	movaps	24 * SIZE(AA), %xmm1
	addps	%xmm2, %xmm7
	movaps	16 * SIZE(BB), %xmm2
	mulps	%xmm3, %xmm0
	mulps	20 * SIZE(AA), %xmm3
	addps	%xmm0, %xmm4
	movaps	32 * SIZE(AA), %xmm0
	addps	%xmm3, %xmm5
	movaps	12 * SIZE(BB), %xmm3
	mulps	%xmm3, %xmm1
	mulps	28 * SIZE(AA), %xmm3
	addps	%xmm1, %xmm6
	movaps	40 * SIZE(AA), %xmm1
	addps	%xmm3, %xmm7
	movaps	24 * SIZE(BB), %xmm3
	mulps	%xmm2, %xmm0
	mulps	36 * SIZE(AA), %xmm2
	addps	%xmm0, %xmm4
	movaps	48 * SIZE(AA), %xmm0
	addps	%xmm2, %xmm5
	movaps	20 * SIZE(BB), %xmm2
	mulps	%xmm2, %xmm1
	mulps	44 * SIZE(AA), %xmm2
	addps	%xmm1, %xmm6
	movaps	56 * SIZE(AA), %xmm1
	addps	%xmm2, %xmm7
	movaps	32 * SIZE(BB), %xmm2
	mulps	%xmm3, %xmm0
	mulps	52 * SIZE(AA), %xmm3
	addps	%xmm0, %xmm4
	movaps	64 * SIZE(AA), %xmm0
	addps	%xmm3, %xmm5
	movaps	28 * SIZE(BB), %xmm3
	mulps	%xmm3, %xmm1
	mulps	60 * SIZE(AA), %xmm3
	addps	%xmm1, %xmm6
	movaps	72 * SIZE(AA), %xmm1
	addps	%xmm3, %xmm7
	movaps	40 * SIZE(BB), %xmm3

	addl   $64 * SIZE, AA
	addl   $32 * SIZE, BB
	decl   %eax
	jne    .L111
	ALIGN_2
#endif

.L112:
#if defined(LT) || defined(RN)
	movl	KK, %eax
#else
	movl	K, %eax
	subl	KK, %eax
#endif
	andl	$7, %eax		# if (k & 1)
	BRANCH
	je .L114

.L113:
	movaps	 0 * SIZE(BB), %xmm2
	movaps	 0 * SIZE(AA), %xmm0
	mulps	%xmm2, %xmm0
	addps	%xmm0, %xmm4
	mulps	 4 * SIZE(AA), %xmm2
	addps	%xmm2, %xmm5

	addl	$8 * SIZE, AA
	addl	$4 * SIZE, BB
	subl	$1, %eax
	jg	.L113
	ALIGN_4

.L114:
	addps	%xmm6, %xmm4
	addps	%xmm7, %xmm5

#if defined(LN) || defined(RT)
	movl	KK, %eax
#ifdef LN
	subl	$8, %eax
#else
	subl	$1, %eax
#endif

	movl	AORIG, AA
	movl	BORIG, B
	leal	BUFFER, BB

	leal	(, %eax, SIZE), %eax
	leal	(AA, %eax, 8), AA
	leal	(B,  %eax, 1), B
	leal	(BB, %eax, 4), BB
#endif


#if defined(LN) || defined(LT)
	movlps	 0 * SIZE(B), %xmm0
	movhps	 2 * SIZE(B), %xmm0
	movlps	 4 * SIZE(B), %xmm1
	movhps	 6 * SIZE(B), %xmm1

	subps	%xmm4,  %xmm0
	subps	%xmm5,  %xmm1
#else
	movaps	 0 * SIZE(AA), %xmm0
	movaps	 4 * SIZE(AA), %xmm1

	subps	%xmm4, %xmm0
	subps	%xmm5, %xmm1
#endif

#ifdef LN
	movss	63 * SIZE(AA), %xmm2
	movhps	SSEONE, %xmm2
	shufps	$0x2e, %xmm2, %xmm2
	mulps	%xmm2, %xmm1

#endif

#ifdef LT
	movlps	 0 * SIZE(AA), %xmm2
	movhps	SSEONE, %xmm2
	shufps	$0xa8, %xmm2, %xmm2
	mulps	%xmm2, %xmm0

	movaps	%xmm0, %xmm4
	shufps	$0x00, %xmm4, %xmm4
	movlps	 0 * SIZE(AA), %xmm2
	movlps	 2 * SIZE(AA), %xmm3

#endif

#ifdef RN
	movss	 0 * SIZE(B),  %xmm4
	shufps	 $0x00, %xmm4, %xmm4
	mulps	 %xmm4, %xmm0
	mulps	 %xmm4, %xmm1
#endif

#ifdef RT
	movss	 0 * SIZE(B),  %xmm4
	shufps	 $0x00, %xmm4, %xmm4
	mulps	 %xmm4, %xmm0
	mulps	 %xmm4, %xmm1
#endif

#if defined(LN) || defined(LT)
	movlps	%xmm0,   0 * SIZE(B)
	movhps	%xmm0,   2 * SIZE(B)
	movlps	%xmm1,   4 * SIZE(B)
	movhps	%xmm1,   6 * SIZE(B)

	movaps	%xmm0, %xmm2
	shufps	$0x00, %xmm2, %xmm2
	movaps	%xmm2,   0 * SIZE(BB)
	movaps	%xmm0, %xmm2
	shufps	$0x55, %xmm2, %xmm2
	movaps	%xmm2,   4 * SIZE(BB)
	movaps	%xmm0, %xmm2
	shufps	$0xaa, %xmm2, %xmm2
	movaps	%xmm2,   8 * SIZE(BB)
	movaps	%xmm0, %xmm2
	shufps	$0xff, %xmm2, %xmm2
	movaps	%xmm2,  12 * SIZE(BB)

	movaps	%xmm1, %xmm2
	shufps	$0x00, %xmm2, %xmm2
	movaps	%xmm2,  16 * SIZE(BB)
	movaps	%xmm1, %xmm2
	shufps	$0x55, %xmm2, %xmm2
	movaps	%xmm2,  20 * SIZE(BB)
	movaps	%xmm1, %xmm2
	shufps	$0xaa, %xmm2, %xmm2
	movaps	%xmm2,  24 * SIZE(BB)
	movaps	%xmm1, %xmm2
	shufps	$0xff, %xmm2, %xmm2
	movaps	%xmm2,  28 * SIZE(BB)
#else
	movaps	%xmm0,   0 * SIZE(AA)
	movaps	%xmm1,   4 * SIZE(AA)
#endif

#ifdef LN
	subl	$8 * SIZE, %esi
#endif

#if defined(LN) || defined(LT)
	movlps	%xmm0,  0 * SIZE(%esi)
	movhps	%xmm0,  2 * SIZE(%esi)
	movlps	%xmm1,  4 * SIZE(%esi)
	movhps	%xmm1,  6 * SIZE(%esi)
#else
	movlps	%xmm0,  0 * SIZE(%esi)
	movhps	%xmm0,  2 * SIZE(%esi)
	movlps	%xmm1,  4 * SIZE(%esi)
	movhps	%xmm1,  6 * SIZE(%esi)
#endif

#ifndef LN
	addl	$8 * SIZE, %esi
#endif

#if defined(LT) || defined(RN)
	movl	K,  %eax
	subl	KK, %eax
	leal	(,%eax, SIZE), %eax
	leal	(AA, %eax, 8), AA
#ifdef LT
	addl	$8 * SIZE, B
#endif
#endif

#ifdef LN
	subl	$8, KK
	movl	BORIG, B
#endif

#ifdef LT
	addl	$8, KK
#endif

#ifdef RT
	movl	K, %eax
	movl	BORIG, B
	sall	$3 + BASE_SHIFT, %eax
	addl	%eax, AORIG
#endif


	BRANCH
	decl	%ebx			# i --
	jg	.L110
	ALIGN_2	

.L130:
	movl	M,  %ebx
	andl	$7, %ebx
	jle	.L999

	testl	$4, %ebx
	jle	.L150

#if (L1_DATA_LINESIZE == 64)
	leal	BUFFER, BB
	movaps	 0 * SIZE + BUFFER, %xmm2
	XORPS	%xmm4, %xmm4
	movaps	 0 * SIZE(AA), %xmm0
	XORPS	%xmm5, %xmm5
	movaps	 16 * SIZE + BUFFER, %xmm3
	XORPS	%xmm6, %xmm6
	movaps	 16 * SIZE(AA), %xmm1
	XORPS	%xmm7, %xmm7

	movl	K, %eax
	sarl	$3, %eax
	je	.L132
	ALIGN_2

.L131:
	mulps	%xmm0, %xmm2
	movaps	 4 * SIZE(AA), %xmm0
	addps	%xmm2, %xmm4
	mulps	 4 * SIZE(BB), %xmm0
	movaps	32 * SIZE(BB), %xmm2
	addps	%xmm0, %xmm5
	movaps	 8 * SIZE(AA), %xmm0
	mulps	 8 * SIZE(BB), %xmm0
	addps	%xmm0, %xmm6
	movaps	12 * SIZE(AA), %xmm0
	mulps	12 * SIZE(BB), %xmm0
	addps	%xmm0, %xmm7
	movaps	32 * SIZE(AA), %xmm0
	mulps	%xmm1, %xmm3
	movaps	20 * SIZE(AA), %xmm1
	addps	%xmm3, %xmm4
	mulps	20 * SIZE(BB), %xmm1
	movaps	48 * SIZE(BB), %xmm3
	addps	%xmm1, %xmm5
	movaps	24 * SIZE(AA), %xmm1
	mulps	24 * SIZE(BB), %xmm1
	addps	%xmm1, %xmm6
	movaps	28 * SIZE(AA), %xmm1
	mulps	28 * SIZE(BB), %xmm1
	addps	%xmm1, %xmm7
	movaps	48 * SIZE(AA), %xmm1

	addl   $32 * SIZE, AA
	addl   $32 * SIZE, BB
	decl   %eax
	jne    .L131
	ALIGN_2

#else
	leal	BUFFER, BB
	movaps	 0 * SIZE + BUFFER, %xmm2
	XORPS	%xmm4, %xmm4
	movaps	 0 * SIZE(AA), %xmm0
	XORPS	%xmm5, %xmm5
	movaps	 8 * SIZE + BUFFER, %xmm3
	XORPS	%xmm6, %xmm6
	movaps	 8 * SIZE(AA), %xmm1
	XORPS	%xmm7, %xmm7

	movl	K, %eax
	sarl	$3, %eax
	je	.L132
	ALIGN_2

.L131:
	mulps	%xmm0, %xmm2
	movaps	 4 * SIZE(AA), %xmm0
	addps	%xmm2, %xmm4
	mulps	 4 * SIZE(BB), %xmm0
	movaps	16 * SIZE(BB), %xmm2
	addps	%xmm0, %xmm5
	movaps	16 * SIZE(AA), %xmm0
	mulps	%xmm1, %xmm3
	movaps	12 * SIZE(AA), %xmm1
	addps	%xmm3, %xmm6
	mulps	12 * SIZE(BB), %xmm1
	movaps	24 * SIZE(BB), %xmm3
	addps	%xmm1, %xmm7
	movaps	24 * SIZE(AA), %xmm1
	mulps	%xmm0, %xmm2
	movaps	20 * SIZE(AA), %xmm0
	addps	%xmm2, %xmm4
	mulps	20 * SIZE(BB), %xmm0
	movaps	32 * SIZE(BB), %xmm2
	addps	%xmm0, %xmm5
	movaps	32 * SIZE(AA), %xmm0
	mulps	%xmm1, %xmm3
	movaps	28 * SIZE(AA), %xmm1
	addps	%xmm3, %xmm6
	mulps	28 * SIZE(BB), %xmm1
	movaps	40 * SIZE(BB), %xmm3
	addps	%xmm1, %xmm7
	movaps	40 * SIZE(AA), %xmm1

	addl   $32 * SIZE, AA
	addl   $32 * SIZE, BB
	decl   %eax
	jne    .L131
	ALIGN_2
#endif

.L132:
	movl	K, %eax
	andl	$7, %eax		# if (k & 1)
	BRANCH
	je .L134

.L133:
	movaps	 0 * SIZE(BB), %xmm2
	movaps	 0 * SIZE(AA), %xmm0
	mulps	%xmm0, %xmm2
	addps	%xmm2, %xmm4

	addl	$4 * SIZE, AA
	addl	$4 * SIZE, BB
	decl	%eax
	jg	.L133
	ALIGN_4

.L134:
	addps	%xmm5, %xmm4
	addps	%xmm7, %xmm6
	addps	%xmm6, %xmm4

	mulps	%xmm3, %xmm4

	movlps	0 * SIZE(%esi), %xmm0
	movhps	2 * SIZE(%esi), %xmm0
	addps	%xmm0, %xmm4

#ifdef HAVE_SSE2
	movsd	%xmm4, 0 * SIZE(%esi)
	unpckhpd %xmm4, %xmm4
	movsd	%xmm4, 2 * SIZE(%esi)

#else
	movlps	%xmm4, 0 * SIZE(%esi)
	movhps	%xmm4, 2 * SIZE(%esi)
#endif
	addl	$4 * SIZE, %esi
	ALIGN_2	

.L150:
	testl	$2, %ebx
	jle	.L170

#if (L1_DATA_LINESIZE == 64)
	leal	BUFFER, BB
	MOVSD	 0 * SIZE + BUFFER, %xmm2
	XORPS	%xmm4, %xmm4
	MOVSD	 0 * SIZE(AA), %xmm0
	XORPS	%xmm5, %xmm5
	MOVSD	 16 * SIZE + BUFFER, %xmm3
	XORPS	%xmm6, %xmm6
	MOVSD	 8 * SIZE(AA), %xmm1
	XORPS	%xmm7, %xmm7

	movl	K, %eax
	sarl	$3, %eax
	je	.L152
	ALIGN_2

.L151:
	mulps	%xmm0, %xmm2
	MOVSD	 2 * SIZE(AA), %xmm0
	addps	%xmm2, %xmm4
	MOVSD	 4 * SIZE(BB), %xmm2
	mulps	%xmm0, %xmm2
	MOVSD	 4 * SIZE(AA), %xmm0
	addps	%xmm2, %xmm5
	MOVSD	 8 * SIZE(BB), %xmm2
	mulps	%xmm0, %xmm2
	MOVSD	 6 * SIZE(AA), %xmm0
	addps	%xmm2, %xmm6
	MOVSD	12 * SIZE(BB), %xmm2
	mulps	%xmm0, %xmm2
	MOVSD	16 * SIZE(AA), %xmm0
	addps	%xmm2, %xmm7
	MOVSD	32 * SIZE(BB), %xmm2
	mulps	%xmm1, %xmm3
	MOVSD	10 * SIZE(AA), %xmm1
	addps	%xmm3, %xmm4
	MOVSD	20 * SIZE(BB), %xmm3
	mulps	%xmm1, %xmm3
	MOVSD	12 * SIZE(AA), %xmm1
	addps	%xmm3, %xmm5
	MOVSD	24 * SIZE(BB), %xmm3
	mulps	%xmm1, %xmm3
	MOVSD	14 * SIZE(AA), %xmm1
	addps	%xmm3, %xmm6
	MOVSD	28 * SIZE(BB), %xmm3
	mulps	%xmm1, %xmm3
	MOVSD	24 * SIZE(AA), %xmm1
	addps	%xmm3, %xmm7
	MOVSD	48 * SIZE(BB), %xmm3

	addl   $16 * SIZE, AA
	addl   $32 * SIZE, BB
	decl   %eax
	jne    .L151
	ALIGN_2

#else
	leal	BUFFER, BB
	MOVSD	 0 * SIZE + BUFFER, %xmm2
	XORPS	%xmm4, %xmm4
	MOVSD	 0 * SIZE(AA), %xmm0
	XORPS	%xmm5, %xmm5
	MOVSD	 8 * SIZE + BUFFER, %xmm3
	XORPS	%xmm6, %xmm6
	MOVSD	 8 * SIZE(AA), %xmm1
	XORPS	%xmm7, %xmm7

	movl	K, %eax
	sarl	$3, %eax
	je	.L152
	ALIGN_2

.L151:
	mulps	%xmm0, %xmm2
	MOVSD	 2 * SIZE(AA), %xmm0
	addps	%xmm2, %xmm4
	MOVSD	 4 * SIZE(BB), %xmm2
	mulps	%xmm0, %xmm2
	MOVSD	 4 * SIZE(AA), %xmm0
	addps	%xmm2, %xmm5
	MOVSD	16 * SIZE(BB), %xmm2
	mulps	%xmm0, %xmm3
	MOVSD	 6 * SIZE(AA), %xmm0
	addps	%xmm3, %xmm6
	MOVSD	12 * SIZE(BB), %xmm3
	mulps	%xmm0, %xmm3
	MOVSD	16 * SIZE(AA), %xmm0
	addps	%xmm3, %xmm7
	MOVSD	24 * SIZE(BB), %xmm3
	mulps	%xmm1, %xmm2
	MOVSD	10 * SIZE(AA), %xmm1
	addps	%xmm2, %xmm4
	MOVSD	20 * SIZE(BB), %xmm2
	mulps	%xmm1, %xmm2
	MOVSD	12 * SIZE(AA), %xmm1
	addps	%xmm2, %xmm5
	MOVSD	32 * SIZE(BB), %xmm2
	mulps	%xmm1, %xmm3
	MOVSD	14 * SIZE(AA), %xmm1
	addps	%xmm3, %xmm6
	MOVSD	28 * SIZE(BB), %xmm3
	mulps	%xmm1, %xmm3
	MOVSD	24 * SIZE(AA), %xmm1
	addps	%xmm3, %xmm7
	MOVSD	40 * SIZE(BB), %xmm3

	addl   $16 * SIZE, AA
	addl   $32 * SIZE, BB
	decl   %eax
	jne    .L151
	ALIGN_2
#endif

.L152:
	movl	K, %eax
	andl	$7, %eax		# if (k & 1)
	BRANCH
	je .L154

.L153:
	mulps	%xmm0, %xmm2
	MOVSD	 2 * SIZE(AA), %xmm0
	addps	%xmm2, %xmm4
	MOVSD	 4 * SIZE(BB), %xmm2

	addl	$2 * SIZE, AA
	addl	$4 * SIZE, BB
	decl	%eax
	jg	.L153
	ALIGN_4

.L154:
	addps	%xmm5, %xmm4
	addps	%xmm7, %xmm6
	addps	%xmm6, %xmm4

	mulps	%xmm3, %xmm4

#ifdef HAVE_SSE2
	movsd	%xmm4, 0 * SIZE(%esi)
#else
	movlps	%xmm4, 0 * SIZE(%esi)
#endif

	addl	$2 * SIZE, %esi
	ALIGN_2	

.L170:
	testl	$1, %ebx
	jle	.L999

#if (L1_DATA_LINESIZE == 64)
	leal	BUFFER, BB
	movss	 0 * SIZE + BUFFER, %xmm2
	XORPS	%xmm4, %xmm4
	movss	 0 * SIZE(AA), %xmm0
	XORPS	%xmm5, %xmm5
	movss	 16 * SIZE + BUFFER, %xmm3
	XORPS	%xmm6, %xmm6
	movss	 4 * SIZE(AA), %xmm1
	XORPS	%xmm7, %xmm7

	movl	K, %eax
	sarl	$3, %eax
	je	.L172
	ALIGN_2

.L171:
	mulss	%xmm0, %xmm2
	movss	 1 * SIZE(AA), %xmm0
	addss	%xmm2, %xmm4
	mulss	 4 * SIZE(BB), %xmm0
	movss	32 * SIZE(BB), %xmm2
	addss	%xmm0, %xmm5
	movss	 2 * SIZE(AA), %xmm0
	mulss	 8 * SIZE(BB), %xmm0
	addss	%xmm0, %xmm6
	movss	 3 * SIZE(AA), %xmm0
	mulss	12 * SIZE(BB), %xmm0
	addss	%xmm0, %xmm7
	movss	 8 * SIZE(AA), %xmm0
	mulss	%xmm1, %xmm3
	movss	 5 * SIZE(AA), %xmm1
	addss	%xmm3, %xmm4
	mulss	20 * SIZE(BB), %xmm1
	movss	48 * SIZE(BB), %xmm3
	addss	%xmm1, %xmm5
	movss	 6 * SIZE(AA), %xmm1
	mulss	24 * SIZE(BB), %xmm1
	addss	%xmm1, %xmm6
	movss	 7 * SIZE(AA), %xmm1
	mulss	28 * SIZE(BB), %xmm1
	addss	%xmm1, %xmm7
	movss	12 * SIZE(AA), %xmm1

	addl   $ 8 * SIZE, AA
	addl   $32 * SIZE, BB
	decl   %eax
	jne    .L171
	ALIGN_2

#else
	leal	BUFFER, BB
	movss	 0 * SIZE + BUFFER, %xmm2
	XORPS	%xmm4, %xmm4
	movss	 0 * SIZE(AA), %xmm0
	XORPS	%xmm5, %xmm5
	movss	 8 * SIZE + BUFFER, %xmm3
	XORPS	%xmm6, %xmm6
	movss	 4 * SIZE(AA), %xmm1
	XORPS	%xmm7, %xmm7

	movl	K, %eax
	sarl	$3, %eax
	je	.L172
	ALIGN_2

.L171:
	mulss	%xmm0, %xmm2
	movss	 1 * SIZE(AA), %xmm0
	addss	%xmm2, %xmm4
	mulss	 4 * SIZE(BB), %xmm0
	movss	16 * SIZE(BB), %xmm2
	addss	%xmm0, %xmm5
	movss	 2 * SIZE(AA), %xmm0
	mulss	%xmm0, %xmm3
	movss	 3 * SIZE(AA), %xmm0
	addss	%xmm3, %xmm6
	mulss	12 * SIZE(BB), %xmm0
	movss	24 * SIZE(BB), %xmm3
	addss	%xmm0, %xmm7
	movss	 8 * SIZE(AA), %xmm0
	mulss	%xmm1, %xmm2
	movss	 5 * SIZE(AA), %xmm1
	addss	%xmm2, %xmm4
	mulss	20 * SIZE(BB), %xmm1
	movss	32 * SIZE(BB), %xmm2
	addss	%xmm1, %xmm5
	movss	 6 * SIZE(AA), %xmm1
	mulss	%xmm1, %xmm3
	movss	 7 * SIZE(AA), %xmm1
	addss	%xmm3, %xmm6
	mulss	28 * SIZE(BB), %xmm1
	movss	40 * SIZE(BB), %xmm3
	addss	%xmm1, %xmm7
	movss	12 * SIZE(AA), %xmm1

	addl   $ 8 * SIZE, AA
	addl   $32 * SIZE, BB
	decl   %eax
	jne    .L171
	ALIGN_2
#endif

.L172:
	movl	K, %eax
	andl	$7, %eax		# if (k & 1)
	BRANCH
	je .L174

.L173:
	movss	 0 * SIZE(AA), %xmm0
	movss	 0 * SIZE(BB), %xmm2
	mulss	%xmm0, %xmm2
	addss	%xmm2, %xmm4

	addl	$1 * SIZE, AA
	addl	$4 * SIZE, BB
	decl	%eax
	jg	.L173
	ALIGN_4

.L174:
	addss	%xmm5, %xmm4
	addss	%xmm7, %xmm6
	addss	%xmm6, %xmm4
	mulss	%xmm3, %xmm4

	addss	0 * SIZE(%esi), %xmm4
	movss	%xmm4, 0 * SIZE(%esi)
	ALIGN_2	

.L999:
	movl	OLD_STACK, %esp

	EMMS

	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	ALIGN_2


	EPILOGUE
